package devmgr.api.model;

import io.swagger.annotations.ApiModelProperty;
import devmgr.api.symbol.AsyncMirrorGroup;
import devmgr.api.symbol.IOInterfaceType;
import devmgr.api.symbol.RemoteTarget;

import javax.xml.bind.annotation.XmlRootElement;

/**
 * Created by lorenp on 10/27/2014.
 */
@XmlRootElement
@io.swagger.annotations.ApiModel(description = "Asynchronous Mirror Group")
public class Amg extends AsyncMirrorGroup implements Identifiable, RemoteMirror {
    public String getId(){
        return getGroupRef();
    }

    @io.swagger.annotations.ApiModelProperty(value ="The connection type used to create this mirror group.")
    private IOInterfaceType connectionType;

    public IOInterfaceType getConnectionType() {
        return connectionType;
    }

    public void setConnectionType(IOInterfaceType connectionType) {
        this.connectionType = connectionType;
    }

    @Override
    public String getRemoteTargetId() {
        return remoteTargetId;
    }

    @Override
    public void setRemoteTargetId(String remoteTargetId) {
        this.remoteTargetId = remoteTargetId;
    }

    @Override
    public String getRemoteTargetWwn() {
        return remoteTargetWwn;
    }

    @Override
    public void setRemoteTargetWwn(String remoteTargetWwn) {
        this.remoteTargetWwn = remoteTargetWwn;
    }

    @Override
    public String getRemoteTargetName() {
        return remoteTargetName;
    }

    @Override
    public void setRemoteTargetName(String remoteTargetName) {
        this.remoteTargetName = remoteTargetName;
    }

    @ApiModelProperty(value = "The WWN of the target array in the mirroring relationship." +
            " This field may not be immediately available after an AMG is created.")
    private String remoteTargetWwn;

    @ApiModelProperty(value = "The user label of the target array in the mirroring relationship." +
            " This field may not be immediately available after an AMG is created, and will not be available in embedded mode.")
    private String remoteTargetName;

    @ApiModelProperty(value = "The id of the target array in the mirroring relationship." +
            " This field may not be immediately available after an AMG is created, and will not be available in embedded mode.")
    private String remoteTargetId;

    public RemoteTarget getRemoteTarget() {
        return remoteTarget;
    }

    public void setRemoteTarget(RemoteTarget remoteTarget) {
        this.remoteTarget = remoteTarget;
    }

    @io.swagger.annotations.ApiModelProperty(value ="The connection information for the remote StorageSystem.")
    private RemoteTarget remoteTarget;
}
