package devmgr.api.model;

import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import devmgr.api.symbol.AsyncMirrorGroupMember;
import devmgr.api.symbol.RemoteVolume;
import devmgr.api.symbol.VolumeMediaScanParams;

import javax.xml.bind.annotation.XmlRootElement;

/**
 * Created by lorenp on 10/28/2014.
 */
@ApiModel(description = "A representation of an asynchronous mirroring relationship between a local and remote volume." )
@XmlRootElement
public class AmgMember extends AsyncMirrorGroupMember implements RemoteMirror {
    public String getId(){
        return getMemberRef();
    }

    @ApiModelProperty(value = "The label of the source volume on the local StorageSystem.")
    private String localVolumeName;

    public String getRemoteVolumeName() {
        return remoteVolumeName;
    }

    public void setRemoteVolumeName(String remoteVolumeName) {
        this.remoteVolumeName = remoteVolumeName;
    }

    public String getLocalVolumeName() {
        return localVolumeName;
    }

    public void setLocalVolumeName(String localVolumeName) {
        this.localVolumeName = localVolumeName;
    }

    @ApiModelProperty(value = "The label of the remote target volume.")
    private String remoteVolumeName;

    public RemoteVolume getRemoteVolumeInfo() {
        return remoteVolumeInfo;
    }

    public void setRemoteVolumeInfo(RemoteVolume remoteVolumeInfo) {
        this.remoteVolumeInfo = remoteVolumeInfo;
    }
    @ApiModelProperty(value = "Detailed information on the remote volume.")
    private RemoteVolume remoteVolumeInfo;
    @ApiModelProperty(value = "The WWN of the target array in the mirroring relationship." +
            " This field may not be immediately available after an AMG is created.")
    private String remoteTargetWwn;

    @ApiModelProperty(value = "The user label of the target array in the mirroring relationship." +
            " This field may not be immediately available after an AMG is created, and will not be available in embedded mode.")
    private String remoteTargetName;

    @Override
    public String getRemoteTargetId() {
        return remoteTargetId;
    }

    @Override
    public void setRemoteTargetId(String remoteTargetId) {
        this.remoteTargetId = remoteTargetId;
    }

    @Override
    public String getRemoteTargetName() {
        return remoteTargetName;
    }

    @Override
    public void setRemoteTargetName(String remoteTargetName) {
        this.remoteTargetName = remoteTargetName;
    }

    @Override
    public String getRemoteTargetWwn() {
        return remoteTargetWwn;
    }

    @Override
    public void setRemoteTargetWwn(String remoteTargetWwn) {
        this.remoteTargetWwn = remoteTargetWwn;
    }

    @ApiModelProperty(value = "The id of the target array in the mirroring relationship." +
            " This field may not be immediately available after an AMG is created, and will not be" +
            " available in embedded mode.")
    private String remoteTargetId;

    public Long getTotalSizeInBytes() {
        return totalSizeInBytes;
    }

    public void setTotalSizeInBytes(Long totalSizeInBytes) {
        this.totalSizeInBytes = totalSizeInBytes;
    }

    @io.swagger.annotations.ApiModelProperty(value ="The capacity of the underlying" +
            " repository volume in bytes.")
    private Long totalSizeInBytes;

    public VolumeMediaScanParams getMediaScan() {
        return mediaScan;
    }

    public void setMediaScan(VolumeMediaScanParams mediaScan) {
        this.mediaScan = mediaScan;
    }

    /** The volume-specific media scan settings currently in effect for the volume. */
    @io.swagger.annotations.ApiModelProperty(value ="The volume-specific media scan settings currently" +
            " in effect for the repository volume.")
    private VolumeMediaScanParams mediaScan;

}
