package devmgr.api.model;

import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import devmgr.api.symbol.PITGroup;

import javax.xml.bind.annotation.XmlRootElement;

/**
 * PIT Group extension
 */
@ApiModel
@XmlRootElement
public class SnapshotGroup extends PITGroup {
    private String volcopyId;
	
    /**
     * Id of the PITGroup/SnapshotGroup
     * @return
     */
    public String getId(){
        return getPitGroupRef();
    }
    
    /**
     * Id of the associated volume copy.
     * @return
     */
    public String getVolcopyId(){
        return volcopyId;
    }
    
    public void setVolcopyId(String volcopyId) {
        this.volcopyId = volcopyId;
    }

    public int getSnapshotCount() {
        return snapshotCount;
    }

    public void setSnapshotCount(int snapshotCount) {
        this.snapshotCount = snapshotCount;
    }

    private int snapshotCount;

    @ApiModelProperty("The aggregate capacity of the repository in bytes")
    public long getRepositoryCapacity() {
        return repositoryCapacity;
    }

    public void setRepositoryCapacity(long repositoryCapacity) {
        this.repositoryCapacity = repositoryCapacity;
    }

    private long repositoryCapacity;
}
