package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** This structure is used to model the critical aspects of an alarm. */
@SuppressWarnings("serial")
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(962)
public class Alarm implements Serializable {
	public Alarm() {
	}

	/** The reference for this physical alarm. */
	@io.swagger.annotations.ApiModelProperty(value ="The reference for this physical alarm." , required = true)
	@XmlElement(required = true)
	private String alarmRef;

	/** @return The reference for this physical alarm. */
	public String getAlarmRef() {
		return this.alarmRef;
	}
	/** @param x The reference for this physical alarm. */
	public void setAlarmRef(String x) {
		this.alarmRef = x;
	}

	/** The location of the alarm. The parent reference in Location identifies the tray containing the alarm, and the position field is set to 1. */
	@io.swagger.annotations.ApiModelProperty(value ="The location of the alarm. The parent reference in Location identifies the tray containing the alarm, and the position field is set to 1." , required = true)
	@XmlElement(required = true)
	private Location physicalLocation;

	/** @return The location of the alarm. The parent reference in Location identifies the tray containing the alarm, and the position field is set to 1. */
	public Location getPhysicalLocation() {
		return this.physicalLocation;
	}
	/** @param x The location of the alarm. The parent reference in Location identifies the tray containing the alarm, and the position field is set to 1. */
	public void setPhysicalLocation(Location x) {
		this.physicalLocation = x;
	}

	/** The operational status of the alarm. */
	@io.swagger.annotations.ApiModelProperty(value ="The operational status of the alarm." , required = true)
	@XmlElement(required = true)
	private AlarmStatus status = AlarmStatus.__UNDEFINED;

	/** @return The operational status of the alarm. */
	public AlarmStatus getStatus() {
		return this.status;
	}
	/** @param x The operational status of the alarm. */
	public void setStatus(AlarmStatus x) {
		this.status = x;
	}

	/** True if the alarm is manageable using the setAlarm procedure. */
	@io.swagger.annotations.ApiModelProperty(value ="True if the alarm is manageable using the setAlarm procedure." , required = true)
	@XmlElement(required = true)
	private boolean isManageable;

	/** @return True if the alarm is manageable using the setAlarm procedure. */
	public boolean isIsManageable() {
		return this.isManageable;
	}
	/** @param x True if the alarm is manageable using the setAlarm procedure. */
	public void setIsManageable(boolean x) {
		this.isManageable = x;
	}

	/** The CRU type of the alarm plus its ready-to-remove attributes, which are based on the CRU type */
	@io.swagger.annotations.ApiModelProperty(value ="The CRU type of the alarm plus its ready-to-remove attributes, which are based on the CRU type" , required = true)
	@XmlElement(required = true)
	private RTRAttributes rtrAttributes;

	/** @return The CRU type of the alarm plus its ready-to-remove attributes, which are based on the CRU type */
	public RTRAttributes getRtrAttributes() {
		return this.rtrAttributes;
	}
	/** @param x The CRU type of the alarm plus its ready-to-remove attributes, which are based on the CRU type */
	public void setRtrAttributes(RTRAttributes x) {
		this.rtrAttributes = x;
	}

	/** The repair policy for the alarm component. */
	@io.swagger.annotations.ApiModelProperty(value ="The repair policy for the alarm component." , required = true)
	@XmlElement(required = true)
	private RepairPolicy repairPolicy;

	/** @return The repair policy for the alarm component. */
	public RepairPolicy getRepairPolicy() {
		return this.repairPolicy;
	}
	/** @param x The repair policy for the alarm component. */
	public void setRepairPolicy(RepairPolicy x) {
		this.repairPolicy = x;
	}
}
