package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** This structure is used to report progress of an async mirror synchronization operation. */
@SuppressWarnings("serial")
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(1003)
public class AsyncMirrorGroupMemberSyncProgress implements Serializable {
	public AsyncMirrorGroupMemberSyncProgress() {
	}

	/** The completion percentage for the operation. If the operation is not currently running this value will be equal to PERCENT_COMPLETE_OP_NOT_RUNNING. */
	@io.swagger.annotations.ApiModelProperty(value ="The completion percentage for the operation. If the operation is not currently running this value will be equal to PERCENT_COMPLETE_OP_NOT_RUNNING." , required = true)
	@XmlElement(required = true)
	private int percentComplete;

	/** @return The completion percentage for the operation. If the operation is not currently running this value will be equal to PERCENT_COMPLETE_OP_NOT_RUNNING. */
	public int getPercentComplete() {
		return this.percentComplete;
	}
	/** @param x The completion percentage for the operation. If the operation is not currently running this value will be equal to PERCENT_COMPLETE_OP_NOT_RUNNING. */
	public void setPercentComplete(int x) {
		this.percentComplete = x;
	}

	/** The estimated time to completion in minutes. If the time is not known this value will be equal to TIME_TO_COMPLETION_UNKNOWN. */
	@io.swagger.annotations.ApiModelProperty(value ="The estimated time to completion in minutes. If the time is not known this value will be equal to TIME_TO_COMPLETION_UNKNOWN." , required = true)
	@XmlElement(required = true)
	private int timeToCompletion;

	/** @return The estimated time to completion in minutes. If the time is not known this value will be equal to TIME_TO_COMPLETION_UNKNOWN. */
	public int getTimeToCompletion() {
		return this.timeToCompletion;
	}
	/** @param x The estimated time to completion in minutes. If the time is not known this value will be equal to TIME_TO_COMPLETION_UNKNOWN. */
	public void setTimeToCompletion(int x) {
		this.timeToCompletion = x;
	}

	/** The amount of data that remains to be synchronized in the current synchronization step. */
	@io.swagger.annotations.ApiModelProperty(value ="The amount of data that remains to be synchronized in the current synchronization step." , required = true)
	@XmlElement(required = true)
	private long syncBytes;

	/** @return The amount of data that remains to be synchronized in the current synchronization step. */
	public long getSyncBytes() {
		return this.syncBytes;
	}
	/** @param x The amount of data that remains to be synchronized in the current synchronization step. */
	public void setSyncBytes(long x) {
		this.syncBytes = x;
	}

	/** A reference to the async mirror member. */
	@io.swagger.annotations.ApiModelProperty(value ="A reference to the async mirror member." , required = true)
	@XmlElement(required = true)
	private String mirrorRef;

	/** @return A reference to the async mirror member. */
	public String getMirrorRef() {
		return this.mirrorRef;
	}
	/** @param x A reference to the async mirror member. */
	public void setMirrorRef(String x) {
		this.mirrorRef = x;
	}

	/** Amount of data (in bytes) marked as unsynchronized in the tracking delta log for this member. */
	@io.swagger.annotations.ApiModelProperty(value ="Amount of data (in bytes) marked as unsynchronized in the tracking delta log for this member." , required = true)
	@XmlElement(required = true)
	private long trackingBytes;

	/** @return Amount of data (in bytes) marked as unsynchronized in the tracking delta log for this member. */
	public long getTrackingBytes() {
		return this.trackingBytes;
	}
	/** @param x Amount of data (in bytes) marked as unsynchronized in the tracking delta log for this member. */
	public void setTrackingBytes(long x) {
		this.trackingBytes = x;
	}
}
