package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** This enumeration describes the type of asynchronous mirror synchronization interval. */
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(33)
public enum AsyncMirrorSyncType implements Serializable {
		/** The synchronization type is unknown. This should never happen. */
		unknown(0),
		/** The synchronization was scheduled/periodic. */
		periodic(1),
		/** The synchronization was manually requested by the storage administrator. */
		manual(2),
		/** The synchronization occurred as part of an initialization when the mirror was first created. */
		initialSync(3),
		/** The synchronization occurred as part of an orderly role change. */
		roleChange(4),
		__UNDEFINED(464378545);

		public final int value;

		private AsyncMirrorSyncType(int v) {
			this.value = v;
		}
}
