package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** This structure is used to convey an automatic configuration template and information about the resulting configuration. */
@SuppressWarnings("serial")
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(660)
public class AutoConfigCandidate implements Serializable {
	public AutoConfigCandidate() {
	}

	/** The automatic configuration template. */
	@io.swagger.annotations.ApiModelProperty(value ="The automatic configuration template." , required = true)
	@XmlElement(required = true)
	private AutoConfigTemplate autoConfigTemplate;

	/** @return The automatic configuration template. */
	public AutoConfigTemplate getAutoConfigTemplate() {
		return this.autoConfigTemplate;
	}
	/** @param x The automatic configuration template. */
	public void setAutoConfigTemplate(AutoConfigTemplate x) {
		this.autoConfigTemplate = x;
	}

	/** The resulting configuration summary. */
	@io.swagger.annotations.ApiModelProperty(value ="The resulting configuration summary." , required = true)
	@XmlElement(required = true)
	private AutoConfigSummary autoConfigSummary;

	/** @return The resulting configuration summary. */
	public AutoConfigSummary getAutoConfigSummary() {
		return this.autoConfigSummary;
	}
	/** @param x The resulting configuration summary. */
	public void setAutoConfigSummary(AutoConfigSummary x) {
		this.autoConfigSummary = x;
	}
}
