package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** This structure is used to convey information about the configuration that will be created from a given AutoConfigTemplate. */
@SuppressWarnings("serial")
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(581)
public class AutoConfigSummary implements Serializable {
	public AutoConfigSummary() {
	}

	/** The total number of volume groups. */
	@io.swagger.annotations.ApiModelProperty(value ="The total number of volume groups." , required = true)
	@XmlElement(required = true)
	private int totalVolumeGroups;

	/** @return The total number of volume groups. */
	public int getTotalVolumeGroups() {
		return this.totalVolumeGroups;
	}
	/** @param x The total number of volume groups. */
	public void setTotalVolumeGroups(int x) {
		this.totalVolumeGroups = x;
	}

	/** The total number of hot spares. */
	@io.swagger.annotations.ApiModelProperty(value ="The total number of hot spares." , required = true)
	@XmlElement(required = true)
	private int hotSpareCount;

	/** @return The total number of hot spares. */
	public int getHotSpareCount() {
		return this.hotSpareCount;
	}
	/** @param x The total number of hot spares. */
	public void setHotSpareCount(int x) {
		this.hotSpareCount = x;
	}

	/** The total number of unassigned drives. */
	@io.swagger.annotations.ApiModelProperty(value ="The total number of unassigned drives." , required = true)
	@XmlElement(required = true)
	private int unassignedCount;

	/** @return The total number of unassigned drives. */
	public int getUnassignedCount() {
		return this.unassignedCount;
	}
	/** @param x The total number of unassigned drives. */
	public void setUnassignedCount(int x) {
		this.unassignedCount = x;
	}

	/** The list of volume groups. */
	@io.swagger.annotations.ApiModelProperty(value ="The list of volume groups." , required = true)
	@XmlElement(required = true)
	private VolumeGroupSummary[] volumeGroupSummary;

	/** @return The list of volume groups. */
	public VolumeGroupSummary[] getVolumeGroupSummary() {
		return this.volumeGroupSummary;
	}
	/** @param x The list of volume groups. */
	public void setVolumeGroupSummary(VolumeGroupSummary[] x) {
		this.volumeGroupSummary = x;
	}
}
