package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** This structure is used to model the critical aspects of a battery component. */
@SuppressWarnings("serial")
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(973)
public class Battery implements Serializable,devmgr.api.model.Identifiable {
	public Battery() {
	}

	/** The reference for this battery. */
	@io.swagger.annotations.ApiModelProperty(value ="The reference for this battery." , required = true)
	@XmlElement(required = true)
	private String batteryRef;

	/** @return The reference for this battery. */
	public String getBatteryRef() {
		return this.batteryRef;
	}
	/** @param x The reference for this battery. */
	public void setBatteryRef(String x) {
		this.batteryRef = x;
	}

	/** The operational status of the battery. */
	@io.swagger.annotations.ApiModelProperty(value ="The operational status of the battery." , required = true)
	@XmlElement(required = true)
	private BatteryStatus status = BatteryStatus.__UNDEFINED;

	/** @return The operational status of the battery. */
	public BatteryStatus getStatus() {
		return this.status;
	}
	/** @param x The operational status of the battery. */
	public void setStatus(BatteryStatus x) {
		this.status = x;
	}

	/** The physical location of the battery. The parent reference in Location identifies the CRU that physically houses the battery, and the position field is the parent-relative/like-component relative slot number of the battery, starting at one. */
	@io.swagger.annotations.ApiModelProperty(value ="The physical location of the battery. The parent reference in Location identifies the CRU that physically houses the battery, and the position field is the parent-relative/like-component relative slot number of the battery, starting at one." , required = true)
	@XmlElement(required = true)
	private Location physicalLocation;

	/** @return The physical location of the battery. The parent reference in Location identifies the CRU that physically houses the battery, and the position field is the parent-relative/like-component relative slot number of the battery, starting at one. */
	public Location getPhysicalLocation() {
		return this.physicalLocation;
	}
	/** @param x The physical location of the battery. The parent reference in Location identifies the CRU that physically houses the battery, and the position field is the parent-relative/like-component relative slot number of the battery, starting at one. */
	public void setPhysicalLocation(Location x) {
		this.physicalLocation = x;
	}

	/** Current battery age, in days. */
	@io.swagger.annotations.ApiModelProperty(value ="Current battery age, in days." , required = true)
	@XmlElement(required = true)
	private int batteryAge;

	/** @return Current battery age, in days. */
	public int getBatteryAge() {
		return this.batteryAge;
	}
	/** @param x Current battery age, in days. */
	public void setBatteryAge(int x) {
		this.batteryAge = x;
	}

	/** Days of battery life remaining. A value of -1 indicates that the battery life expiration age has been set to 0xFF in NVSRAM, disabling cache battery expiration event notification. */
	@io.swagger.annotations.ApiModelProperty(value ="Days of battery life remaining. A value of -1 indicates that the battery life expiration age has been set to 0xFF in NVSRAM, disabling cache battery expiration event notification." , required = true)
	@XmlElement(required = true)
	private int batteryLifeRemaining;

	/** @return Days of battery life remaining. A value of -1 indicates that the battery life expiration age has been set to 0xFF in NVSRAM, disabling cache battery expiration event notification. */
	public int getBatteryLifeRemaining() {
		return this.batteryLifeRemaining;
	}
	/** @param x Days of battery life remaining. A value of -1 indicates that the battery life expiration age has been set to 0xFF in NVSRAM, disabling cache battery expiration event notification. */
	public void setBatteryLifeRemaining(int x) {
		this.batteryLifeRemaining = x;
	}

	/** Used to determine the scope of the battery. */
	@io.swagger.annotations.ApiModelProperty(value ="Used to determine the scope of the battery." , required = true)
	@XmlElement(required = true)
	private BatteryTypeData batteryTypeData;

	/** @return Used to determine the scope of the battery. */
	public BatteryTypeData getBatteryTypeData() {
		return this.batteryTypeData;
	}
	/** @param x Used to determine the scope of the battery. */
	public void setBatteryTypeData(BatteryTypeData x) {
		this.batteryTypeData = x;
	}

	/** Reserved. */
	@XmlTransient
	private String reserved1;

	/** @return Reserved. */
	public String getReserved1() {
		return this.reserved1;
	}
	/** @param x Reserved. */
	public void setReserved1(String x) {
		this.reserved1 = x;
	}

	/** Reserved. */
	@XmlTransient
	private String reserved2;

	/** @return Reserved. */
	public String getReserved2() {
		return this.reserved2;
	}
	/** @param x Reserved. */
	public void setReserved2(String x) {
		this.reserved2 = x;
	}

	/** VPD manufacture date. */
	@io.swagger.annotations.ApiModelProperty(value ="VPD manufacture date." , required = true)
	@XmlElement(required = true)
	private long manufacturerDate;

	/** @return VPD manufacture date. */
	public long getManufacturerDate() {
		return this.manufacturerDate;
	}
	/** @param x VPD manufacture date. */
	public void setManufacturerDate(long x) {
		this.manufacturerDate = x;
	}

	/** VPD vendor name. */
	@io.swagger.annotations.ApiModelProperty(value ="VPD vendor name." , required = true)
	@XmlElement(required = true)
	private String vendorName;

	/** @return VPD vendor name. */
	public String getVendorName() {
		return this.vendorName;
	}
	/** @param x VPD vendor name. */
	public void setVendorName(String x) {
		this.vendorName = x;
	}

	/** VPD part number. */
	@io.swagger.annotations.ApiModelProperty(value ="VPD part number." , required = true)
	@XmlElement(required = true)
	private String vendorPN;

	/** @return VPD part number. */
	public String getVendorPN() {
		return this.vendorPN;
	}
	/** @param x VPD part number. */
	public void setVendorPN(String x) {
		this.vendorPN = x;
	}

	/** VPD serial number. */
	@io.swagger.annotations.ApiModelProperty(value ="VPD serial number." , required = true)
	@XmlElement(required = true)
	private String vendorSN;

	/** @return VPD serial number. */
	public String getVendorSN() {
		return this.vendorSN;
	}
	/** @param x VPD serial number. */
	public void setVendorSN(String x) {
		this.vendorSN = x;
	}

	/** VPD field replaceable unit type. */
	@io.swagger.annotations.ApiModelProperty(value ="VPD field replaceable unit type." , required = true)
	@XmlElement(required = true)
	private String fruType;

	/** @return VPD field replaceable unit type. */
	public String getFruType() {
		return this.fruType;
	}
	/** @param x VPD field replaceable unit type. */
	public void setFruType(String x) {
		this.fruType = x;
	}

	/** The CRU type of the battery plus its ready-to-remove attributes, which are based on the CRU type. */
	@io.swagger.annotations.ApiModelProperty(value ="The CRU type of the battery plus its ready-to-remove attributes, which are based on the CRU type." , required = true)
	@XmlElement(required = true)
	private RTRAttributes rtrAttributes;

	/** @return The CRU type of the battery plus its ready-to-remove attributes, which are based on the CRU type. */
	public RTRAttributes getRtrAttributes() {
		return this.rtrAttributes;
	}
	/** @param x The CRU type of the battery plus its ready-to-remove attributes, which are based on the CRU type. */
	public void setRtrAttributes(RTRAttributes x) {
		this.rtrAttributes = x;
	}

	/** The repair policy for the battery component. */
	@io.swagger.annotations.ApiModelProperty(value ="The repair policy for the battery component." , required = true)
	@XmlElement(required = true)
	private RepairPolicy repairPolicy;

	/** @return The repair policy for the battery component. */
	public RepairPolicy getRepairPolicy() {
		return this.repairPolicy;
	}
	/** @param x The repair policy for the battery component. */
	public void setRepairPolicy(RepairPolicy x) {
		this.repairPolicy = x;
	}

	/** This boolean field is set to true when cache battery expired event notification is enabled. */
	@io.swagger.annotations.ApiModelProperty(value ="This boolean field is set to true when cache battery expired event notification is enabled." , required = true)
	@XmlElement(required = true)
	private boolean batteryCanExpire;

	/** @return This boolean field is set to true when cache battery expired event notification is enabled. */
	public boolean isBatteryCanExpire() {
		return this.batteryCanExpire;
	}
	/** @param x This boolean field is set to true when cache battery expired event notification is enabled. */
	public void setBatteryCanExpire(boolean x) {
		this.batteryCanExpire = x;
	}

	/** This boolean field is set to true when the batteryCanExpire field in this structure is set to false and when the controller tracks the battery serial number. */
	@io.swagger.annotations.ApiModelProperty(value ="This boolean field is set to true when the batteryCanExpire field in this structure is set to false and when the controller tracks the battery serial number." , required = true)
	@XmlElement(required = true)
	private boolean automaticAgeReset;

	/** @return This boolean field is set to true when the batteryCanExpire field in this structure is set to false and when the controller tracks the battery serial number. */
	public boolean isAutomaticAgeReset() {
		return this.automaticAgeReset;
	}
	/** @param x This boolean field is set to true when the batteryCanExpire field in this structure is set to false and when the controller tracks the battery serial number. */
	public void setAutomaticAgeReset(boolean x) {
		this.automaticAgeReset = x;
	}

	/** Contains details about the learn cycle for this battery */
	@io.swagger.annotations.ApiModelProperty(value ="Contains details about the learn cycle for this battery" , required = true)
	@XmlElement(required = true)
	private SmartBatteryData learnCycleData;

	/** @return Contains details about the learn cycle for this battery */
	public SmartBatteryData getLearnCycleData() {
		return this.learnCycleData;
	}
	/** @param x Contains details about the learn cycle for this battery */
	public void setLearnCycleData(SmartBatteryData x) {
		this.learnCycleData = x;
	}
	@Override
	public String getId(){
		return batteryRef;
	}
}
