package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** This enumeration object is used to determine the status of a battery component. */
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(45)
public enum BatteryStatus implements Serializable {
		/** The battery is working correctly. */
		optimal(1),
		/** The battery is performing a full charge cycle. */
		fullCharging(2),
		/** The battery is near expiration */
		nearExpiration(3),
		/** The battery is not working. */
		failed(4),
		/** The battery is not present. */
		removed(5),
		/** The status of the battery is unknown. */
		unknown(6),
		/** The battery is not part of the configuration. */
		notInConfig(7),
		/** The battery is present, which should not be part of the configuration. */
		configMismatch(8),
		/** A smart battery is undergoing a learn cycle. */
		learning(9),
		/** The battery is over temperature. */
		overtemp(10),
		/** The battery has expired. */
		expired(11),
		/** The battery is performing a maintenance charge cycle. */
		maintenanceCharging(13),
		/** Battery is usable but must be replaced */
		replacementRequired(14),
		__UNDEFINED(464378545);

		public final int value;

		private BatteryStatus(int v) {
			this.value = v;
		}
}
