package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** This enumeration object is used to specify the type of volume candidate that the client wishes to obtain in a getVolumeCandidates procedure call. */
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(118)
public enum CandidateSelectionType implements Serializable {
		/** The caller wishes to obtain volume candidates for creating volumes on existing free extent areas within the storage array. */
		freeExtent(1),
		/** The caller wishes to obtain volume candidates for creating volumes on a new volume group constructed from a set of manually-selected drives. */
		manual(2),
		/** The caller wishes to obtain volume candidates for creating volumes on a new volume group constructed from drives that are automatically selected by the controller. Each volume candidate object will indicate the count, or number, of drives. The controller will not actually select specific drives until the volume creation operation is performed, though. */
		count(3),
		__UNDEFINED(464378545);

		public final int value;

		private CandidateSelectionType(int v) {
			this.value = v;
		}
}
