package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** This structure is used to store information about a physical channel port. This structure is deprecated. The same information is available in the LinkSpeedDetectionError structure. */
@SuppressWarnings("serial")
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(477)
public class ChannelPorts implements Serializable {
	public ChannelPorts() {
	}

	/** This is set to true only if speed detection has failed. */
	@io.swagger.annotations.ApiModelProperty(value ="This is set to true only if speed detection has failed." , required = true)
	@XmlElement(required = true)
	private boolean speedDetError;

	/** @return This is set to true only if speed detection has failed. */
	public boolean isSpeedDetError() {
		return this.speedDetError;
	}
	/** @param x This is set to true only if speed detection has failed. */
	public void setSpeedDetError(boolean x) {
		this.speedDetError = x;
	}

	/** This is set to true if the port is bypassed. */
	@io.swagger.annotations.ApiModelProperty(value ="This is set to true if the port is bypassed." , required = true)
	@XmlElement(required = true)
	private boolean manuallyBypassed;

	/** @return This is set to true if the port is bypassed. */
	public boolean isManuallyBypassed() {
		return this.manuallyBypassed;
	}
	/** @param x This is set to true if the port is bypassed. */
	public void setManuallyBypassed(boolean x) {
		this.manuallyBypassed = x;
	}

	/** This is the ChannelPort port number, 1 based. */
	@io.swagger.annotations.ApiModelProperty(value ="This is the ChannelPort port number, 1 based." , required = true)
	@XmlElement(required = true)
	private SFPPort portNumber = SFPPort.__UNDEFINED;

	/** @return This is the ChannelPort port number, 1 based. */
	public SFPPort getPortNumber() {
		return this.portNumber;
	}
	/** @param x This is the ChannelPort port number, 1 based. */
	public void setPortNumber(SFPPort x) {
		this.portNumber = x;
	}
}
