package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** This union represents a pending host that was presented to the controller by a host context agent and which has been "checked" by the controller against the configured topology. */
@SuppressWarnings("serial")
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(1131)
public class CheckedPendingHost implements Serializable {
	public CheckedPendingHost() {
	}

	/** This enumeration data type indicates whether a CheckedPendingHost matches or does not match a host in the configured topology. */
	@io.swagger.annotations.ApiModelProperty(value ="This enumeration data type indicates whether a CheckedPendingHost matches or does not match a host in the configured topology." , required = true)
	@XmlElement(required = true)
	private CheckedPendingHostType type = CheckedPendingHostType.__UNDEFINED;

	/** @return This enumeration data type indicates whether a CheckedPendingHost matches or does not match a host in the configured topology. */
	public CheckedPendingHostType getType() {
		return this.type;
	}
	/** @param x This enumeration data type indicates whether a CheckedPendingHost matches or does not match a host in the configured topology. */
	public void setType(CheckedPendingHostType x) {
		this.type = x;
	}

	/** This field is only present if type is PENDING_HOST_MATCHED. It contains data about a pending host and its relationship to a likely matching host in the configured topology. */
	@io.swagger.annotations.ApiModelProperty(value ="This field is only present if type is PENDING_HOST_MATCHED. It contains data about a pending host and its relationship to a likely matching host in the configured topology." , required = false)
	@XmlElement(required = false)
	private MatchedPendingHost matchedPendingHost;

	/** @return This field is only present if type is PENDING_HOST_MATCHED. It contains data about a pending host and its relationship to a likely matching host in the configured topology. */
	public MatchedPendingHost getMatchedPendingHost() {
		return this.matchedPendingHost;
	}
	/** @param x This field is only present if type is PENDING_HOST_MATCHED. It contains data about a pending host and its relationship to a likely matching host in the configured topology. */
	public void setMatchedPendingHost(MatchedPendingHost x) {
		this.matchedPendingHost = x;
	}

	/** This field is only present if type is PENDING_HOST_UNMATCHED. It contains data about a pending host that does not match any configured host and the relationship of that hosts ports to ports in the configured topology. */
	@io.swagger.annotations.ApiModelProperty(value ="This field is only present if type is PENDING_HOST_UNMATCHED. It contains data about a pending host that does not match any configured host and the relationship of that hosts ports to ports in the configured topology." , required = false)
	@XmlElement(required = false)
	private UnmatchedPendingHost unmatchedPendingHost;

	/** @return This field is only present if type is PENDING_HOST_UNMATCHED. It contains data about a pending host that does not match any configured host and the relationship of that hosts ports to ports in the configured topology. */
	public UnmatchedPendingHost getUnmatchedPendingHost() {
		return this.unmatchedPendingHost;
	}
	/** @param x This field is only present if type is PENDING_HOST_UNMATCHED. It contains data about a pending host that does not match any configured host and the relationship of that hosts ports to ports in the configured topology. */
	public void setUnmatchedPendingHost(UnmatchedPendingHost x) {
		this.unmatchedPendingHost = x;
	}
}
