package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** This union type contains the information returned by the analyzeCoWRepository procedure. */
@SuppressWarnings("serial")
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(303)
public class CoWRepositoryAnalysisResultsReturned implements Serializable {
	public CoWRepositoryAnalysisResultsReturned() {
	}

	/** An enumeration used to determine the return status of a SYMbol function call. */
	@io.swagger.annotations.ApiModelProperty(value ="An enumeration used to determine the return status of a SYMbol function call." , required = true)
	@XmlElement(required = true)
	private ReturnCode returnCode = ReturnCode.__UNDEFINED;

	/** @return An enumeration used to determine the return status of a SYMbol function call. */
	public ReturnCode getReturnCode() {
		return this.returnCode;
	}
	/** @param x An enumeration used to determine the return status of a SYMbol function call. */
	public void setReturnCode(ReturnCode x) {
		this.returnCode = x;
	}

	/** Analysis data is returned only if the ReturnCode equals RETCODE_OK. */
	@io.swagger.annotations.ApiModelProperty(value ="Analysis data is returned only if the ReturnCode equals RETCODE_OK." , required = false)
	@XmlElement(required = false)
	private CoWRepositoryAnalysisResults result;

	/** @return Analysis data is returned only if the ReturnCode equals RETCODE_OK. */
	public CoWRepositoryAnalysisResults getResult() {
		return this.result;
	}
	/** @param x Analysis data is returned only if the ReturnCode equals RETCODE_OK. */
	public void setResult(CoWRepositoryAnalysisResults x) {
		this.result = x;
	}
}
