package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** This structure is used to convey information about a physical component within the storage array. This is used internally to the controller only. It is used to build a list of all of the components and to communicate components between controllers. */
@SuppressWarnings("serial")
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(1142)
public class Component implements Serializable {
	public Component() {
	}

	/** This field contains detailed information about the component based on the type of component. */
	@io.swagger.annotations.ApiModelProperty(value ="This field contains detailed information about the component based on the type of component." , required = true)
	@XmlElement(required = true)
	private ComponentTypeData componentData;

	/** @return This field contains detailed information about the component based on the type of component. */
	public ComponentTypeData getComponentData() {
		return this.componentData;
	}
	/** @param x This field contains detailed information about the component based on the type of component. */
	public void setComponentData(ComponentTypeData x) {
		this.componentData = x;
	}

	/** Reserved for future use. */
	@XmlTransient
	private String reserved1;

	/** @return Reserved for future use. */
	public String getReserved1() {
		return this.reserved1;
	}
	/** @param x Reserved for future use. */
	public void setReserved1(String x) {
		this.reserved1 = x;
	}

	/** Reserved for future use. */
	@XmlTransient
	private String reserved2;

	/** @return Reserved for future use. */
	public String getReserved2() {
		return this.reserved2;
	}
	/** @param x Reserved for future use. */
	public void setReserved2(String x) {
		this.reserved2 = x;
	}
}
