package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** The component removal method and method-dependent ready-to-remove data. */
@SuppressWarnings("serial")
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(507)
public class ComponentRemovalData implements Serializable {
	public ComponentRemovalData() {
	}

	/** This enumeration defines the removal methods that apply to any component. */
	@io.swagger.annotations.ApiModelProperty(value ="This enumeration defines the removal methods that apply to any component." , required = true)
	@XmlElement(required = true)
	private ComponentRemovalMethod removalMethod = ComponentRemovalMethod.__UNDEFINED;

	/** @return This enumeration defines the removal methods that apply to any component. */
	public ComponentRemovalMethod getRemovalMethod() {
		return this.removalMethod;
	}
	/** @param x This enumeration defines the removal methods that apply to any component. */
	public void setRemovalMethod(ComponentRemovalMethod x) {
		this.removalMethod = x;
	}

	/** This field holds the component's ready-to-remove attributes. It is only present when the removalMethod is equal to COMP_RMV_METHOD_REMOVE_SELF. */
	@io.swagger.annotations.ApiModelProperty(value ="This field holds the component's ready-to-remove attributes. It is only present when the removalMethod is equal to COMP_RMV_METHOD_REMOVE_SELF." , required = false)
	@XmlElement(required = false)
	private RTRAttributeData rtrAttributes;

	/** @return This field holds the component's ready-to-remove attributes. It is only present when the removalMethod is equal to COMP_RMV_METHOD_REMOVE_SELF. */
	public RTRAttributeData getRtrAttributes() {
		return this.rtrAttributes;
	}
	/** @param x This field holds the component's ready-to-remove attributes. It is only present when the removalMethod is equal to COMP_RMV_METHOD_REMOVE_SELF. */
	public void setRtrAttributes(RTRAttributeData x) {
		this.rtrAttributes = x;
	}
}
