package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** This structure contains information about a member of a concatenated volume. NOTE: DVE and other operations not allowed on a ConcatVolumeMember's underlying RAID volume will be controlled via the VolumePerms set on that volume. */
@SuppressWarnings("serial")
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(995)
public class ConcatVolumeMember implements Serializable {
	public ConcatVolumeMember() {
	}

	/** A reference (key) for ConcatVolumeMember. */
	@io.swagger.annotations.ApiModelProperty(value ="A reference (key) for ConcatVolumeMember." , required = true)
	@XmlElement(required = true)
	private String memberRef;

	/** @return A reference (key) for ConcatVolumeMember. */
	public String getMemberRef() {
		return this.memberRef;
	}
	/** @param x A reference (key) for ConcatVolumeMember. */
	public void setMemberRef(String x) {
		this.memberRef = x;
	}

	/** A reference to the parent ConcatVolume. */
	@io.swagger.annotations.ApiModelProperty(value ="A reference to the parent ConcatVolume." , required = true)
	@XmlElement(required = true)
	private String concatVolRef;

	/** @return A reference to the parent ConcatVolume. */
	public String getConcatVolRef() {
		return this.concatVolRef;
	}
	/** @param x A reference to the parent ConcatVolume. */
	public void setConcatVolRef(String x) {
		this.concatVolRef = x;
	}

	/** A reference to the member RAID volume providing storage capacity. */
	@io.swagger.annotations.ApiModelProperty(value ="A reference to the member RAID volume providing storage capacity." , required = true)
	@XmlElement(required = true)
	private String storageVolumeRef;

	/** @return A reference to the member RAID volume providing storage capacity. */
	public String getStorageVolumeRef() {
		return this.storageVolumeRef;
	}
	/** @param x A reference to the member RAID volume providing storage capacity. */
	public void setStorageVolumeRef(String x) {
		this.storageVolumeRef = x;
	}

	/** The index (order) of the member in the aggregated parent volume capacity. */
	@io.swagger.annotations.ApiModelProperty(value ="The index (order) of the member in the aggregated parent volume capacity." , required = true)
	@XmlElement(required = true)
	private int parentIndex;

	/** @return The index (order) of the member in the aggregated parent volume capacity. */
	public int getParentIndex() {
		return this.parentIndex;
	}
	/** @param x The index (order) of the member in the aggregated parent volume capacity. */
	public void setParentIndex(int x) {
		this.parentIndex = x;
	}
}
