package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** This enumeration lists the different error modes for which a controller may be operating. The controller's functionality may be diminished if it is operating in one of the these modes. */
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(122)
public enum ControllerErrorModeType implements Serializable {
		/** The controller is not operating in an error mode. */
		notInErrorMode(0),
		/** The controller is operating in an error mode but the specific mode is unknown. */
		unknown(1),
		/** The controller is operating in T10 PI Service Mode. */
		t10PiServiceMode(2),
		/** The controller is operating in T10 PI lockdown error mode. */
		t10PiLockdown(3),
		__UNDEFINED(464378545);

		public final int value;

		private ControllerErrorModeType(int v) {
			this.value = v;
		}
}
