package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** This structure is used to model the aspects of a GBIC associated with a controller channel. */
@SuppressWarnings("serial")
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(562)
public class ControllerGBIC implements Serializable {
	public ControllerGBIC() {
	}

	/** Interface (host/drive) to which the GBIC belongs. */
	@io.swagger.annotations.ApiModelProperty(value ="Interface (host/drive) to which the GBIC belongs." , required = true)
	@XmlElement(required = true)
	private ControllerGBICType controllerGBICType = ControllerGBICType.__UNDEFINED;

	/** @return Interface (host/drive) to which the GBIC belongs. */
	public ControllerGBICType getControllerGBICType() {
		return this.controllerGBICType;
	}
	/** @param x Interface (host/drive) to which the GBIC belongs. */
	public void setControllerGBICType(ControllerGBICType x) {
		this.controllerGBICType = x;
	}

	/** Information on the controller associated with the GBIC. */
	@io.swagger.annotations.ApiModelProperty(value ="Information on the controller associated with the GBIC." , required = true)
	@XmlElement(required = true)
	private String parentController;

	/** @return Information on the controller associated with the GBIC. */
	public String getParentController() {
		return this.parentController;
	}
	/** @param x Information on the controller associated with the GBIC. */
	public void setParentController(String x) {
		this.parentController = x;
	}

	/** The channel number that this GBIC is associated with. */
	@io.swagger.annotations.ApiModelProperty(value ="The channel number that this GBIC is associated with." , required = true)
	@XmlElement(required = true)
	private int channel;

	/** @return The channel number that this GBIC is associated with. */
	public int getChannel() {
		return this.channel;
	}
	/** @param x The channel number that this GBIC is associated with. */
	public void setChannel(int x) {
		this.channel = x;
	}

	/** Reserved for future use. */
	@XmlTransient
	private String reserved1;

	/** @return Reserved for future use. */
	public String getReserved1() {
		return this.reserved1;
	}
	/** @param x Reserved for future use. */
	public void setReserved1(String x) {
		this.reserved1 = x;
	}

	/** Reserved for future use. */
	@XmlTransient
	private String reserved2;

	/** @return Reserved for future use. */
	public String getReserved2() {
		return this.reserved2;
	}
	/** @param x Reserved for future use. */
	public void setReserved2(String x) {
		this.reserved2 = x;
	}
}
