package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** This structure is used to convey details of the controller that fails to flush dirty cache data on failed volume(s) possibly due to offlined drives. It is reported in the FailureTypeEntry for REC_CACHE_NOT_FLUSHED_ON_ONLY_CTLR. */
@SuppressWarnings("serial")
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(524)
public class ControllerWithDirtyCacheDetails implements Serializable {
	public ControllerWithDirtyCacheDetails() {
	}

	/** This field contains the identification of the controller that fails to flush dirty cache data on failed volume(s) possibly due to offlined drives. The controller should not be replaced to avoid loss of data. */
	@io.swagger.annotations.ApiModelProperty(value ="This field contains the identification of the controller that fails to flush dirty cache data on failed volume(s) possibly due to offlined drives. The controller should not be replaced to avoid loss of data." , required = true)
	@XmlElement(required = true)
	private String controllerRef;

	/** @return This field contains the identification of the controller that fails to flush dirty cache data on failed volume(s) possibly due to offlined drives. The controller should not be replaced to avoid loss of data. */
	public String getControllerRef() {
		return this.controllerRef;
	}
	/** @param x This field contains the identification of the controller that fails to flush dirty cache data on failed volume(s) possibly due to offlined drives. The controller should not be replaced to avoid loss of data. */
	public void setControllerRef(String x) {
		this.controllerRef = x;
	}
}
