package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** This structure has the content for each of the port's (TLV_MAX_PROTOCOL_ENTRIES) possible entries in the Operational, Local, and Remote Priority-base Flow Control Summary tables. An entry will be provided for each application protocol exchanged via DCBX. This summary table is used to summarize the Priority Group, Priority-based Flow Control, and Application Feature DCBX TLVs. */
@SuppressWarnings("serial")
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(371)
public class DCBXSummaryData implements Serializable {
	public DCBXSummaryData() {
	}

	/** This enumeration contains the known Ethernet Protocol types currently negotiated via DCBX. */
	@io.swagger.annotations.ApiModelProperty(value ="This enumeration contains the known Ethernet Protocol types currently negotiated via DCBX." , required = true)
	@XmlElement(required = true)
	private EnhEthProtocolType protocolType = EnhEthProtocolType.__UNDEFINED;

	/** @return This enumeration contains the known Ethernet Protocol types currently negotiated via DCBX. */
	public EnhEthProtocolType getProtocolType() {
		return this.protocolType;
	}
	/** @param x This enumeration contains the known Ethernet Protocol types currently negotiated via DCBX. */
	public void setProtocolType(EnhEthProtocolType x) {
		this.protocolType = x;
	}

	/** This object contains a priority number (0 - TLV_MAX_PROTOCOL_ENTRIES) assigned to the given protocol type. */
	@io.swagger.annotations.ApiModelProperty(value ="This object contains a priority number (0 - TLV_MAX_PROTOCOL_ENTRIES) assigned to the given protocol type." , required = true)
	@XmlElement(required = true)
	private int priority;

	/** @return This object contains a priority number (0 - TLV_MAX_PROTOCOL_ENTRIES) assigned to the given protocol type. */
	public int getPriority() {
		return this.priority;
	}
	/** @param x This object contains a priority number (0 - TLV_MAX_PROTOCOL_ENTRIES) assigned to the given protocol type. */
	public void setPriority(int x) {
		this.priority = x;
	}

	/** This object contains a priority group ID assigned to the given priority number. */
	@io.swagger.annotations.ApiModelProperty(value ="This object contains a priority group ID assigned to the given priority number." , required = true)
	@XmlElement(required = true)
	private int priorityGroupId;

	/** @return This object contains a priority group ID assigned to the given priority number. */
	public int getPriorityGroupId() {
		return this.priorityGroupId;
	}
	/** @param x This object contains a priority group ID assigned to the given priority number. */
	public void setPriorityGroupId(int x) {
		this.priorityGroupId = x;
	}

	/** This object contains the percentage of the link band-width assigned to the given priority group ID. */
	@io.swagger.annotations.ApiModelProperty(value ="This object contains the percentage of the link band-width assigned to the given priority group ID." , required = true)
	@XmlElement(required = true)
	private int linkBandwidthPercentage;

	/** @return This object contains the percentage of the link band-width assigned to the given priority group ID. */
	public int getLinkBandwidthPercentage() {
		return this.linkBandwidthPercentage;
	}
	/** @param x This object contains the percentage of the link band-width assigned to the given priority group ID. */
	public void setLinkBandwidthPercentage(int x) {
		this.linkBandwidthPercentage = x;
	}

	/** This is the status of the given priority number. */
	@io.swagger.annotations.ApiModelProperty(value ="This is the status of the given priority number." , required = true)
	@XmlElement(required = true)
	private boolean enabled;

	/** @return This is the status of the given priority number. */
	public boolean isEnabled() {
		return this.enabled;
	}
	/** @param x This is the status of the given priority number. */
	public void setEnabled(boolean x) {
		this.enabled = x;
	}
}
