package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** This structure contains information about a core dump in controller memory, if one exists. */
@SuppressWarnings("serial")
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(316)
public class DPLCoreDumpData implements Serializable {
	public DPLCoreDumpData() {
	}

	/** The tag value of the DPL core dump currently in controller memory. Each core dump has a unique tag value. A value of DPL_CORE_DUMP_NULL_TAG indicates there is no DPL core dump to retrieve. */
	@io.swagger.annotations.ApiModelProperty(value ="The tag value of the DPL core dump currently in controller memory. Each core dump has a unique tag value. A value of DPL_CORE_DUMP_NULL_TAG indicates there is no DPL core dump to retrieve." , required = true)
	@XmlElement(required = true)
	private int dplCoreDumpTag;

	/** @return The tag value of the DPL core dump currently in controller memory. Each core dump has a unique tag value. A value of DPL_CORE_DUMP_NULL_TAG indicates there is no DPL core dump to retrieve. */
	public int getDplCoreDumpTag() {
		return this.dplCoreDumpTag;
	}
	/** @param x The tag value of the DPL core dump currently in controller memory. Each core dump has a unique tag value. A value of DPL_CORE_DUMP_NULL_TAG indicates there is no DPL core dump to retrieve. */
	public void setDplCoreDumpTag(int x) {
		this.dplCoreDumpTag = x;
	}

	/** If true, a DPL core dump currently exists in controller memory and has not been retrieved. */
	@io.swagger.annotations.ApiModelProperty(value ="If true, a DPL core dump currently exists in controller memory and has not been retrieved." , required = true)
	@XmlElement(required = true)
	private boolean dplCoreDumpNeedsRetrieved;

	/** @return If true, a DPL core dump currently exists in controller memory and has not been retrieved. */
	public boolean isDplCoreDumpNeedsRetrieved() {
		return this.dplCoreDumpNeedsRetrieved;
	}
	/** @param x If true, a DPL core dump currently exists in controller memory and has not been retrieved. */
	public void setDplCoreDumpNeedsRetrieved(boolean x) {
		this.dplCoreDumpNeedsRetrieved = x;
	}

	/** If true, DPL Core Dump is enabled in the controller. */
	@io.swagger.annotations.ApiModelProperty(value ="If true, DPL Core Dump is enabled in the controller." , required = true)
	@XmlElement(required = true)
	private boolean dplCoreDumpEnabled;

	/** @return If true, DPL Core Dump is enabled in the controller. */
	public boolean isDplCoreDumpEnabled() {
		return this.dplCoreDumpEnabled;
	}
	/** @param x If true, DPL Core Dump is enabled in the controller. */
	public void setDplCoreDumpEnabled(boolean x) {
		this.dplCoreDumpEnabled = x;
	}

	/** The time that the core dump was collected measured in seconds since midnight GMT on January 1, 1970. */
	@io.swagger.annotations.ApiModelProperty(value ="The time that the core dump was collected measured in seconds since midnight GMT on January 1, 1970." , required = true)
	@XmlElement(required = true)
	private long timeStamp;

	/** @return The time that the core dump was collected measured in seconds since midnight GMT on January 1, 1970. */
	public long getTimeStamp() {
		return this.timeStamp;
	}
	/** @param x The time that the core dump was collected measured in seconds since midnight GMT on January 1, 1970. */
	public void setTimeStamp(long x) {
		this.timeStamp = x;
	}
}
