package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** This union contains additional detail about the DPL core dump. */
@SuppressWarnings("serial")
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(544)
public class DPLCoreDumpDetail implements Serializable {
	public DPLCoreDumpDetail() {
	}

	/** This enumeration identifies the reason for a DPL core dump. */
	@io.swagger.annotations.ApiModelProperty(value ="This enumeration identifies the reason for a DPL core dump." , required = true)
	@XmlElement(required = true)
	private DPLCoreDumpReason reason = DPLCoreDumpReason.__UNDEFINED;

	/** @return This enumeration identifies the reason for a DPL core dump. */
	public DPLCoreDumpReason getReason() {
		return this.reason;
	}
	/** @param x This enumeration identifies the reason for a DPL core dump. */
	public void setReason(DPLCoreDumpReason x) {
		this.reason = x;
	}

	/** This field is present only if the value of reason is equal to DPL_CORE_DUMP_REASON_ASSERT. In the case of an assertion this structure will contain the firmware location. */
	@io.swagger.annotations.ApiModelProperty(value ="This field is present only if the value of reason is equal to DPL_CORE_DUMP_REASON_ASSERT. In the case of an assertion this structure will contain the firmware location." , required = false)
	@XmlElement(required = false)
	private DPLCoreDumpFWLocation fwLocation;

	/** @return This field is present only if the value of reason is equal to DPL_CORE_DUMP_REASON_ASSERT. In the case of an assertion this structure will contain the firmware location. */
	public DPLCoreDumpFWLocation getFwLocation() {
		return this.fwLocation;
	}
	/** @param x This field is present only if the value of reason is equal to DPL_CORE_DUMP_REASON_ASSERT. In the case of an assertion this structure will contain the firmware location. */
	public void setFwLocation(DPLCoreDumpFWLocation x) {
		this.fwLocation = x;
	}

	/** This field is present only if the value of reason is equal to DPL_CORE_DUMP_REASON_PANIC. It contains a string with the panic message. */
	@io.swagger.annotations.ApiModelProperty(value ="This field is present only if the value of reason is equal to DPL_CORE_DUMP_REASON_PANIC. It contains a string with the panic message." , required = false)
	@XmlElement(required = false)
	private String panicReason;

	/** @return This field is present only if the value of reason is equal to DPL_CORE_DUMP_REASON_PANIC. It contains a string with the panic message. */
	public String getPanicReason() {
		return this.panicReason;
	}
	/** @param x This field is present only if the value of reason is equal to DPL_CORE_DUMP_REASON_PANIC. It contains a string with the panic message. */
	public void setPanicReason(String x) {
		this.panicReason = x;
	}
}
