package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** This structure specifies the parameters that are provided by the client when starting a DPL Core Dump retrieval. */
@SuppressWarnings("serial")
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(377)
public class DPLCoreDumpRetrieveStartDetails implements Serializable {
	public DPLCoreDumpRetrieveStartDetails() {
	}

	/** The tag value of the DPL core dump to be retrieved. This value is unique for each core dump. */
	@io.swagger.annotations.ApiModelProperty(value ="The tag value of the DPL core dump to be retrieved. This value is unique for each core dump." , required = true)
	@XmlElement(required = true)
	private int dplCoreDumpTag;

	/** @return The tag value of the DPL core dump to be retrieved. This value is unique for each core dump. */
	public int getDplCoreDumpTag() {
		return this.dplCoreDumpTag;
	}
	/** @param x The tag value of the DPL core dump to be retrieved. This value is unique for each core dump. */
	public void setDplCoreDumpTag(int x) {
		this.dplCoreDumpTag = x;
	}
}
