package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** This structure specifies the detailed content of the data sent to the controller for a chunk transfer that occurs in the context of a DBM Block restore operation, i.e. in a continueRawDataRestore( ) request. */
@SuppressWarnings("serial")
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(297)
public class DbmBlkRestoreChunkDetails implements Serializable {
	public DbmBlkRestoreChunkDetails() {
	}

	/** CRC data. */
	@io.swagger.annotations.ApiModelProperty(value ="CRC data." , required = true)
	@XmlElement(required = true)
	private int chunkCRC;

	/** @return CRC data. */
	public int getChunkCRC() {
		return this.chunkCRC;
	}
	/** @param x CRC data. */
	public void setChunkCRC(int x) {
		this.chunkCRC = x;
	}

	/** The size of each dbm block (sector). */
	@io.swagger.annotations.ApiModelProperty(value ="The size of each dbm block (sector)." , required = true)
	@XmlElement(required = true)
	private int blockSize;

	/** @return The size of each dbm block (sector). */
	public int getBlockSize() {
		return this.blockSize;
	}
	/** @param x The size of each dbm block (sector). */
	public void setBlockSize(int x) {
		this.blockSize = x;
	}

	/** An array identifying the block addresses of the blocks whose data resides in the blockData array */
	@io.swagger.annotations.ApiModelProperty(value ="An array identifying the block addresses of the blocks whose data resides in the blockData array" , required = true)
	@XmlElement(required = true)
	private int[] sstorLBA;

	/** @return An array identifying the block addresses of the blocks whose data resides in the blockData array */
	public int[] getSstorLBA() {
		return this.sstorLBA;
	}
	/** @param x An array identifying the block addresses of the blocks whose data resides in the blockData array */
	public void setSstorLBA(int[] x) {
		this.sstorLBA = x;
	}

	/** An array of block data. */
	@io.swagger.annotations.ApiModelProperty(value ="An array of block data." , required = true)
	@XmlElement(required = true)
	private String blockData;

	/** @return An array of block data. */
	public String getBlockData() {
		return this.blockData;
	}
	/** @param x An array of block data. */
	public void setBlockData(String x) {
		this.blockData = x;
	}
}
