package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** The set of record types in the configuration; defines the data set. */
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(213)
public enum DbmRecConfigType implements Serializable {
		/** Empty set */
		configNone(0),
		/** Most record types from Erie and earlier, includes the traditional volume groups (non-Disk Pool) */
		traditionalConfig(1),
		/** Includes the traditional record types, the disk pool record types, and other record types added later. */
		configAll(2),
		/** Defines the minimum safe record set for restoration purposes. */
		partialConfig(3),
		__UNDEFINED(464378545);

		public final int value;

		private DbmRecConfigType(int v) {
			this.value = v;
		}
}
