package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** This structure represents a "chunk" of the DDC log data image. */
@SuppressWarnings("serial")
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(346)
public class DdcLogData implements Serializable {
	public DdcLogData() {
	}

	/** True if this is the last chunk in the series. */
	@io.swagger.annotations.ApiModelProperty(value ="True if this is the last chunk in the series." , required = true)
	@XmlElement(required = true)
	private boolean lastChunk;

	/** @return True if this is the last chunk in the series. */
	public boolean isLastChunk() {
		return this.lastChunk;
	}
	/** @param x True if this is the last chunk in the series. */
	public void setLastChunk(boolean x) {
		this.lastChunk = x;
	}

	/** The DDC data for this chunk. */
	@io.swagger.annotations.ApiModelProperty(value ="The DDC data for this chunk." , required = true)
	@XmlElement(required = true)
	private String logData;

	/** @return The DDC data for this chunk. */
	public String getLogData() {
		return this.logData;
	}
	/** @param x The DDC data for this chunk. */
	public void setLogData(String x) {
		this.logData = x;
	}
}
