package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** This structure is the input to the activateDiscreteTimeSeries procedure call. It contains the individual arguments that define the discrete time series to create and activate on each controller. */
@SuppressWarnings("serial")
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(901)
public class DiscreteTimeSeriesDescriptor implements Serializable {
	public DiscreteTimeSeriesDescriptor() {
	}

	/** A reference to the storage array object (e.g., volume, drive, ets.) to observe. */
	@io.swagger.annotations.ApiModelProperty(value ="A reference to the storage array object (e.g., volume, drive, ets.) to observe." , required = true)
	@XmlElement(required = true)
	private ObjectReference objectRef;

	/** @return A reference to the storage array object (e.g., volume, drive, ets.) to observe. */
	public ObjectReference getObjectRef() {
		return this.objectRef;
	}
	/** @param x A reference to the storage array object (e.g., volume, drive, ets.) to observe. */
	public void setObjectRef(ObjectReference x) {
		this.objectRef = x;
	}

	/** The type of statistic to observe in the activated stream. */
	@io.swagger.annotations.ApiModelProperty(value ="The type of statistic to observe in the activated stream." , required = true)
	@XmlElement(required = true)
	private StatStreamType streamType = StatStreamType.__UNDEFINED;

	/** @return The type of statistic to observe in the activated stream. */
	public StatStreamType getStreamType() {
		return this.streamType;
	}
	/** @param x The type of statistic to observe in the activated stream. */
	public void setStreamType(StatStreamType x) {
		this.streamType = x;
	}

	/** The amount of time, expressed in seconds, to spend recording observations. If the discrete time series is not retrieved by the client before the end of the duration, the stream wraps around, i.e., observations will be overwritten. */
	@io.swagger.annotations.ApiModelProperty(value ="The amount of time, expressed in seconds, to spend recording observations. If the discrete time series is not retrieved by the client before the end of the duration, the stream wraps around, i.e., observations will be overwritten." , required = true)
	@XmlElement(required = true)
	private int duration;

	/** @return The amount of time, expressed in seconds, to spend recording observations. If the discrete time series is not retrieved by the client before the end of the duration, the stream wraps around, i.e., observations will be overwritten. */
	public int getDuration() {
		return this.duration;
	}
	/** @param x The amount of time, expressed in seconds, to spend recording observations. If the discrete time series is not retrieved by the client before the end of the duration, the stream wraps around, i.e., observations will be overwritten. */
	public void setDuration(int x) {
		this.duration = x;
	}
}
