package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** This structure is used to initiate a Dynamic Capacity Expansion (DCE) operation on a disk pool. */
@SuppressWarnings("serial")
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(841)
public class DiskPoolExpansionDescriptor implements Serializable {
	public DiskPoolExpansionDescriptor() {
	}

	/** The disk pool being expanded. */
	@io.swagger.annotations.ApiModelProperty(value ="The disk pool being expanded." , required = true)
	@XmlElement(required = true)
	private String volumeGroupRef;

	/** @return The disk pool being expanded. */
	public String getVolumeGroupRef() {
		return this.volumeGroupRef;
	}
	/** @param x The disk pool being expanded. */
	public void setVolumeGroupRef(String x) {
		this.volumeGroupRef = x;
	}

	/** The drives to be used for expansion. */
	@io.swagger.annotations.ApiModelProperty(value ="The drives to be used for expansion." , required = true)
	@XmlElement(required = true)
	private String[] driveRef;

	/** @return The drives to be used for expansion. */
	public String[] getDriveRef() {
		return this.driveRef;
	}
	/** @param x The drives to be used for expansion. */
	public void setDriveRef(String[] x) {
		this.driveRef = x;
	}
}
