package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** used to specify the type of Drive Channel port. */
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(24)
public enum DriveChannelPortType implements Serializable {
		/** Port is unknown and cannot be determined. */
		portUnknown(0),
		/** XBB Port 1 (SOC mode). */
		port1(1),
		/** XBB Port 2 (SOC mode). */
		port2(2),
		/** XBB Port 3 (SOC mode). */
		port3(3),
		/** XBB Port 4 (SOC mode). */
		port4(4),
		/** XBB Port 1 or 2 (Hub mode). */
		port12(5),
		/** XBB Port 3 or 4 (Hub mode). */
		port34(6),
		/** XBB Port 7 */
		port7(7),
		/** 588X Bridge controller in/out port. */
		minihubInout(8),
		/** Vail expansion port. This value of the enumeration is no longer used and is considered deprecated. */
		expansionOnly(9),
		/** 288X expansion and internal. */
		expansionAndInternal(10),
		__UNDEFINED(464378545);

		public final int value;

		private DriveChannelPortType(int v) {
			this.value = v;
		}
}
