package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** This enumeration object is used to specify the state of the drive channel. */
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(209)
public enum DriveChannelState implements Serializable {
		/** The drive channel state is optimal. */
		optimal(0),
		/** The drive channel state is degraded. */
		degraded(1),
		/** An internal fault has occurred on shared drive channel circuitry. The failed circuit resides on the controller reporting the problem. This failure is automatically cleared when the faulty controller is replaced. */
		hwFailed(2),
		__UNDEFINED(464378545);

		public final int value;

		private DriveChannelState(int v) {
			this.value = v;
		}
}
