package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** This enumeration is used to indicate the drive orientation (horizontal, vertical, or none) of the drives in the enclosure. */
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(131)
public enum DriveOrientation implements Serializable {
		/** The enclosure does not contain any drives. */
		none(1),
		/** The drives in the enclosure lay flat. */
		horizontal(2),
		/** The drives in the enclosure stand on side (vertically). */
		vertical(3),
		__UNDEFINED(464378545);

		public final int value;

		private DriveOrientation(int v) {
			this.value = v;
		}
}
