package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** This structure contains the operational state of the given DCBX features. Refer to the IEEE Std 802.1AB-2005 */
@SuppressWarnings("serial")
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(294)
public class EnhEthFeaturesState implements Serializable {
	public EnhEthFeaturesState() {
	}

	/** This bool indicates the Operational mode of the FIP Application. . */
	@io.swagger.annotations.ApiModelProperty(value ="This bool indicates the Operational mode of the FIP Application. ." , required = true)
	@XmlElement(required = true)
	private boolean fipOperational;

	/** @return This bool indicates the Operational mode of the FIP Application. . */
	public boolean isFipOperational() {
		return this.fipOperational;
	}
	/** @param x This bool indicates the Operational mode of the FIP Application. . */
	public void setFipOperational(boolean x) {
		this.fipOperational = x;
	}

	/** This bool indicates the Operational mode of the FCoE Application. */
	@io.swagger.annotations.ApiModelProperty(value ="This bool indicates the Operational mode of the FCoE Application." , required = true)
	@XmlElement(required = true)
	private boolean fcoeOperational;

	/** @return This bool indicates the Operational mode of the FCoE Application. */
	public boolean isFcoeOperational() {
		return this.fcoeOperational;
	}
	/** @param x This bool indicates the Operational mode of the FCoE Application. */
	public void setFcoeOperational(boolean x) {
		this.fcoeOperational = x;
	}

	/** This bool indicates the Operational mode of the PFC Feature. */
	@io.swagger.annotations.ApiModelProperty(value ="This bool indicates the Operational mode of the PFC Feature." , required = true)
	@XmlElement(required = true)
	private boolean pfcOperational;

	/** @return This bool indicates the Operational mode of the PFC Feature. */
	public boolean isPfcOperational() {
		return this.pfcOperational;
	}
	/** @param x This bool indicates the Operational mode of the PFC Feature. */
	public void setPfcOperational(boolean x) {
		this.pfcOperational = x;
	}

	/** The bool indicates the Operational mode of the PG Feature. */
	@io.swagger.annotations.ApiModelProperty(value ="The bool indicates the Operational mode of the PG Feature." , required = true)
	@XmlElement(required = true)
	private boolean pgOperational;

	/** @return The bool indicates the Operational mode of the PG Feature. */
	public boolean isPgOperational() {
		return this.pgOperational;
	}
	/** @param x The bool indicates the Operational mode of the PG Feature. */
	public void setPgOperational(boolean x) {
		this.pgOperational = x;
	}

	/** This bool indicates if this interface has the FCoE bandwidth. */
	@io.swagger.annotations.ApiModelProperty(value ="This bool indicates if this interface has the FCoE bandwidth." , required = true)
	@XmlElement(required = true)
	private boolean fcoeBandwidth;

	/** @return This bool indicates if this interface has the FCoE bandwidth. */
	public boolean isFcoeBandwidth() {
		return this.fcoeBandwidth;
	}
	/** @param x This bool indicates if this interface has the FCoE bandwidth. */
	public void setFcoeBandwidth(boolean x) {
		this.fcoeBandwidth = x;
	}

	/** This bool indicates the Operational Mode of the iSCSI Application. */
	@io.swagger.annotations.ApiModelProperty(value ="This bool indicates the Operational Mode of the iSCSI Application." , required = true)
	@XmlElement(required = true)
	private boolean iscsiOperational;

	/** @return This bool indicates the Operational Mode of the iSCSI Application. */
	public boolean isIscsiOperational() {
		return this.iscsiOperational;
	}
	/** @param x This bool indicates the Operational Mode of the iSCSI Application. */
	public void setIscsiOperational(boolean x) {
		this.iscsiOperational = x;
	}

	/** This bool indicates if this interface has a FCoE/FIP Application Map Mismatch. */
	@io.swagger.annotations.ApiModelProperty(value ="This bool indicates if this interface has a FCoE/FIP Application Map Mismatch." , required = true)
	@XmlElement(required = true)
	private boolean fcoeFipMismatch;

	/** @return This bool indicates if this interface has a FCoE/FIP Application Map Mismatch. */
	public boolean isFcoeFipMismatch() {
		return this.fcoeFipMismatch;
	}
	/** @param x This bool indicates if this interface has a FCoE/FIP Application Map Mismatch. */
	public void setFcoeFipMismatch(boolean x) {
		this.fcoeFipMismatch = x;
	}
}
