package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** This object is used to report Enhanced Ethernet TLV data. Refer to the IEEE Std 802.1AB-2005 */
@SuppressWarnings("serial")
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(844)
public class EnhEthTLVSet implements Serializable {
	public EnhEthTLVSet() {
	}

	/** This is Enhanced Ethernet TLV data (local, remote and operational). */
	@io.swagger.annotations.ApiModelProperty(value ="This is Enhanced Ethernet TLV data (local, remote and operational)." , required = true)
	@XmlElement(required = true)
	private EnhEthTLV[] enhEthTLV;

	/** @return This is Enhanced Ethernet TLV data (local, remote and operational). */
	public EnhEthTLV[] getEnhEthTLV() {
		return this.enhEthTLV;
	}
	/** @param x This is Enhanced Ethernet TLV data (local, remote and operational). */
	public void setEnhEthTLV(EnhEthTLV[] x) {
		this.enhEthTLV = x;
	}

	/** This is the summary of DCBX data. */
	@io.swagger.annotations.ApiModelProperty(value ="This is the summary of DCBX data." , required = true)
	@XmlElement(required = true)
	private DCBXSummaryData[] dcbxSummaryData;

	/** @return This is the summary of DCBX data. */
	public DCBXSummaryData[] getDcbxSummaryData() {
		return this.dcbxSummaryData;
	}
	/** @param x This is the summary of DCBX data. */
	public void setDcbxSummaryData(DCBXSummaryData[] x) {
		this.dcbxSummaryData = x;
	}
}
