package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** This structure contains two pieces of information about the version of the ESM factory default settings: (1) an indication of whether or not factory default version management is supported by the ESM and (2) the actual version of the factory default settings. */
@SuppressWarnings("serial")
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(473)
public class EsmFactoryDefaultsVersionData implements Serializable {
	public EsmFactoryDefaultsVersionData() {
	}

	/** This field is set to true if the ESM supports version reporting and downloading of factory default settings, and false otherwise. A setting of false in this field can mean either (1) the ESM is a legacy ESM for which the version-reporting feature is unavailable or (2) the ESM is capable of supporting version-reporting, but is not running the correct firmware version to do so. */
	@io.swagger.annotations.ApiModelProperty(value ="This field is set to true if the ESM supports version reporting and downloading of factory default settings, and false otherwise. A setting of false in this field can mean either (1) the ESM is a legacy ESM for which the version-reporting feature is unavailable or (2) the ESM is capable of supporting version-reporting, but is not running the correct firmware version to do so." , required = true)
	@XmlElement(required = true)
	private boolean isSupported;

	/** @return This field is set to true if the ESM supports version reporting and downloading of factory default settings, and false otherwise. A setting of false in this field can mean either (1) the ESM is a legacy ESM for which the version-reporting feature is unavailable or (2) the ESM is capable of supporting version-reporting, but is not running the correct firmware version to do so. */
	public boolean isIsSupported() {
		return this.isSupported;
	}
	/** @param x This field is set to true if the ESM supports version reporting and downloading of factory default settings, and false otherwise. A setting of false in this field can mean either (1) the ESM is a legacy ESM for which the version-reporting feature is unavailable or (2) the ESM is capable of supporting version-reporting, but is not running the correct firmware version to do so. */
	public void setIsSupported(boolean x) {
		this.isSupported = x;
	}

	/** The factory default version string. The format of the string is: */
	@io.swagger.annotations.ApiModelProperty(value ="The factory default version string. The format of the string is:" , required = true)
	@XmlElement(required = true)
	private String factoryDefaultsVersion;

	/** @return The factory default version string. The format of the string is: */
	public String getFactoryDefaultsVersion() {
		return this.factoryDefaultsVersion;
	}
	/** @param x The factory default version string. The format of the string is: */
	public void setFactoryDefaultsVersion(String x) {
		this.factoryDefaultsVersion = x;
	}
}
