package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** This structure provides the ability to extend the content of the SAData structure which would otherwise not be possible due to the nature of the SAData struct. This new struct replaces one of the existing reserved fields in SAData. */
@SuppressWarnings("serial")
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(653)
public class ExtendedSAData implements Serializable {
	public ExtendedSAData() {
	}

	/** This field defines some reserved space in this structure for future use. */
	@XmlTransient
	private String reserved1;

	/** @return This field defines some reserved space in this structure for future use. */
	public String getReserved1() {
		return this.reserved1;
	}
	/** @param x This field defines some reserved space in this structure for future use. */
	public void setReserved1(String x) {
		this.reserved1 = x;
	}

	/** This is a list of versions for the various firmware components (RAID, NVSRAM, hypervisor, ....). The list contains an entry for every code module applicable to the current platform. */
	@io.swagger.annotations.ApiModelProperty(value ="This is a list of versions for the various firmware components (RAID, NVSRAM, hypervisor, ....). The list contains an entry for every code module applicable to the current platform." , required = true)
	@XmlElement(required = true)
	private VersionDescriptor[] codeVersions;

	/** @return This is a list of versions for the various firmware components (RAID, NVSRAM, hypervisor, ....). The list contains an entry for every code module applicable to the current platform. */
	public VersionDescriptor[] getCodeVersions() {
		return this.codeVersions;
	}
	/** @param x This is a list of versions for the various firmware components (RAID, NVSRAM, hypervisor, ....). The list contains an entry for every code module applicable to the current platform. */
	public void setCodeVersions(VersionDescriptor[] x) {
		this.codeVersions = x;
	}
}
