package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** This structure contains information about flash cache drives. */
@SuppressWarnings("serial")
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(530)
public class FlashCacheWithDrives implements Serializable {
	public FlashCacheWithDrives() {
	}

	/** The security type of the drives. */
	@io.swagger.annotations.ApiModelProperty(value ="The security type of the drives." , required = true)
	@XmlElement(required = true)
	private SecurityType securityType = SecurityType.__UNDEFINED;

	/** @return The security type of the drives. */
	public SecurityType getSecurityType() {
		return this.securityType;
	}
	/** @param x The security type of the drives. */
	public void setSecurityType(SecurityType x) {
		this.securityType = x;
	}

	/** The protection information capabilities of the drives. */
	@io.swagger.annotations.ApiModelProperty(value ="The protection information capabilities of the drives." , required = true)
	@XmlElement(required = true)
	private ProtectionInformationCapabilities protectionInformationCapabilities;

	/** @return The protection information capabilities of the drives. */
	public ProtectionInformationCapabilities getProtectionInformationCapabilities() {
		return this.protectionInformationCapabilities;
	}
	/** @param x The protection information capabilities of the drives. */
	public void setProtectionInformationCapabilities(ProtectionInformationCapabilities x) {
		this.protectionInformationCapabilities = x;
	}

	/** The used capacity of the drives (in bytes). */
	@io.swagger.annotations.ApiModelProperty(value ="The used capacity of the drives (in bytes)." , required = true)
	@XmlElement(required = true)
	private long usedCapacity;

	/** @return The used capacity of the drives (in bytes). */
	public long getUsedCapacity() {
		return this.usedCapacity;
	}
	/** @param x The used capacity of the drives (in bytes). */
	public void setUsedCapacity(long x) {
		this.usedCapacity = x;
	}

	/** Refines the information in the securityType field to describe the set of drives. */
	@io.swagger.annotations.ApiModelProperty(value ="Refines the information in the securityType field to describe the set of drives." , required = true)
	@XmlElement(required = true)
	private SecurityLevel securityLevel = SecurityLevel.__UNDEFINED;

	/** @return Refines the information in the securityType field to describe the set of drives. */
	public SecurityLevel getSecurityLevel() {
		return this.securityLevel;
	}
	/** @param x Refines the information in the securityType field to describe the set of drives. */
	public void setSecurityLevel(SecurityLevel x) {
		this.securityLevel = x;
	}
}
