package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** Contains data associated with a FRU diagnostic test. */
@SuppressWarnings("serial")
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(432)
public class FruDiagReturn implements Serializable {
	public FruDiagReturn() {
	}

	/** An enumeration used to determine the return status of a SYMbol function call. */
	@io.swagger.annotations.ApiModelProperty(value ="An enumeration used to determine the return status of a SYMbol function call." , required = true)
	@XmlElement(required = true)
	private ReturnCode returnCode = ReturnCode.__UNDEFINED;

	/** @return An enumeration used to determine the return status of a SYMbol function call. */
	public ReturnCode getReturnCode() {
		return this.returnCode;
	}
	/** @param x An enumeration used to determine the return status of a SYMbol function call. */
	public void setReturnCode(ReturnCode x) {
		this.returnCode = x;
	}

	/** This contains the data associated with a FRU diagnostic test. This field is only available when the returnCode is equal to RETCODE_OK. */
	@io.swagger.annotations.ApiModelProperty(value ="This contains the data associated with a FRU diagnostic test. This field is only available when the returnCode is equal to RETCODE_OK." , required = false)
	@XmlElement(required = false)
	private FruDiagReturnData fruDiagReturnData;

	/** @return This contains the data associated with a FRU diagnostic test. This field is only available when the returnCode is equal to RETCODE_OK. */
	public FruDiagReturnData getFruDiagReturnData() {
		return this.fruDiagReturnData;
	}
	/** @param x This contains the data associated with a FRU diagnostic test. This field is only available when the returnCode is equal to RETCODE_OK. */
	public void setFruDiagReturnData(FruDiagReturnData x) {
		this.fruDiagReturnData = x;
	}
}
