package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** This structure contains the histogram data collected by the storage array. A histogram is defined as a series of observations made over time, divided into categories representing value ranges, and summarized as counts of observations per category. This structure contains two such series, one per controller. */
@SuppressWarnings("serial")
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(748)
public class HistogramBundle implements Serializable {
	public HistogramBundle() {
	}

	/** The time that the histogram was retrieved. Time is the number of seconds since midnight, January 1, 1970. */
	@io.swagger.annotations.ApiModelProperty(value ="The time that the histogram was retrieved. Time is the number of seconds since midnight, January 1, 1970." , required = true)
	@XmlElement(required = true)
	private long observationTime;

	/** @return The time that the histogram was retrieved. Time is the number of seconds since midnight, January 1, 1970. */
	public long getObservationTime() {
		return this.observationTime;
	}
	/** @param x The time that the histogram was retrieved. Time is the number of seconds since midnight, January 1, 1970. */
	public void setObservationTime(long x) {
		this.observationTime = x;
	}

	/** A reference to the object to which the histogram applies. */
	@io.swagger.annotations.ApiModelProperty(value ="A reference to the object to which the histogram applies." , required = true)
	@XmlElement(required = true)
	private ObjectReference objectRef;

	/** @return A reference to the object to which the histogram applies. */
	public ObjectReference getObjectRef() {
		return this.objectRef;
	}
	/** @param x A reference to the object to which the histogram applies. */
	public void setObjectRef(ObjectReference x) {
		this.objectRef = x;
	}

	/** An array of histogram streams, one stream per controller. */
	@io.swagger.annotations.ApiModelProperty(value ="An array of histogram streams, one stream per controller." , required = true)
	@XmlElement(required = true)
	private Histogram[] histogram;

	/** @return An array of histogram streams, one stream per controller. */
	public Histogram[] getHistogram() {
		return this.histogram;
	}
	/** @param x An array of histogram streams, one stream per controller. */
	public void setHistogram(Histogram[] x) {
		this.histogram = x;
	}
}
