package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** This structure contains the InfiniBand statistical data reported by the getIbStatistics procedure. There are two sub-groups of statistics in this structure: statistical counters that are relative to a baseline and point-in-time readings. */
@SuppressWarnings("serial")
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(1119)
public class IbStatisticalData implements Serializable {
	public IbStatisticalData() {
	}

	/** A reference to the controller that collected these statistics. */
	@io.swagger.annotations.ApiModelProperty(value ="A reference to the controller that collected these statistics." , required = true)
	@XmlElement(required = true)
	private String controller;

	/** @return A reference to the controller that collected these statistics. */
	public String getController() {
		return this.controller;
	}
	/** @param x A reference to the controller that collected these statistics. */
	public void setController(String x) {
		this.controller = x;
	}

	/** InfiniBand counter-oriented statistics that are relative to a pre-set baseline. */
	@io.swagger.annotations.ApiModelProperty(value ="InfiniBand counter-oriented statistics that are relative to a pre-set baseline." , required = true)
	@XmlElement(required = true)
	private IbBaselinedStatistics baselinedStats;

	/** @return InfiniBand counter-oriented statistics that are relative to a pre-set baseline. */
	public IbBaselinedStatistics getBaselinedStats() {
		return this.baselinedStats;
	}
	/** @param x InfiniBand counter-oriented statistics that are relative to a pre-set baseline. */
	public void setBaselinedStats(IbBaselinedStatistics x) {
		this.baselinedStats = x;
	}

	/** InfiniBand statistical data that just consists of certain values that are read at the point in time the request is received. */
	@io.swagger.annotations.ApiModelProperty(value ="InfiniBand statistical data that just consists of certain values that are read at the point in time the request is received." , required = true)
	@XmlElement(required = true)
	private IbPointInTimeStatistics pitStats;

	/** @return InfiniBand statistical data that just consists of certain values that are read at the point in time the request is received. */
	public IbPointInTimeStatistics getPitStats() {
		return this.pitStats;
	}
	/** @param x InfiniBand statistical data that just consists of certain values that are read at the point in time the request is received. */
	public void setPitStats(IbPointInTimeStatistics x) {
		this.pitStats = x;
	}
}
