package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** This structure is used with the createInitiator and setInitiatorProperties procedures. It indicates what properties the caller wants to set and the values for those properties. To support setting a subset of these properties, all of the fields are variable-length arrays of maximum size one; If the caller does not want to set a property, the corresponding length indicator should be zero; otherwise the length indicator is one, and the single element is the new value of the property. */
@SuppressWarnings("serial")
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(892)
public class InitiatorChangeableProperties implements Serializable {
	public InitiatorChangeableProperties() {
	}

	/** The node name for the initiator. */
	@io.swagger.annotations.ApiModelProperty(value ="The node name for the initiator." , required = true)
	@XmlElement(required = true)
	private ScsiNodeName[] nodeName;

	/** @return The node name for the initiator. */
	public ScsiNodeName[] getNodeName() {
		return this.nodeName;
	}
	/** @param x The node name for the initiator. */
	public void setNodeName(ScsiNodeName[] x) {
		this.nodeName = x;
	}

	/** The user-assigned, descriptive label string for the initiator. */
	@io.swagger.annotations.ApiModelProperty(value ="The user-assigned, descriptive label string for the initiator." , required = true)
	@XmlElement(required = true)
	private String[] label;

	/** @return The user-assigned, descriptive label string for the initiator. */
	public String[] getLabel() {
		return this.label;
	}
	/** @param x The user-assigned, descriptive label string for the initiator. */
	public void setLabel(String[] x) {
		this.label = x;
	}

	/** The set of the authentication methods for the initiator. When creating a new initiator, this field defines the authentication methods that the new initiator will have. When updating an existing initiator, this field replaces all existing authentication methods; depending on how the caller populates the list, authentication methods may be added, deleted, or modified. Secrets associated with authentication methods may be modified in this manner. The way to indicate that there is no password is to set the length indicator on the field named secret within AuthMethodTypeData (which is the type of the individual elements of AuthenticationBundle) to zero. */
	@io.swagger.annotations.ApiModelProperty(value ="The set of the authentication methods for the initiator. When creating a new initiator, this field defines the authentication methods that the new initiator will have. When updating an existing initiator, this field replaces all existing authentication methods; depending on how the caller populates the list, authentication methods may be added, deleted, or modified. Secrets associated with authentication methods may be modified in this manner. The way to indicate that there is no password is to set the length indicator on the field named secret within AuthMethodTypeData (which is the type of the individual elements of AuthenticationBundle) to zero." , required = true)
	@XmlElement(required = true)
	private AuthenticationBundle[] configuredAuthMethods;

	/** @return The set of the authentication methods for the initiator. When creating a new initiator, this field defines the authentication methods that the new initiator will have. When updating an existing initiator, this field replaces all existing authentication methods; depending on how the caller populates the list, authentication methods may be added, deleted, or modified. Secrets associated with authentication methods may be modified in this manner. The way to indicate that there is no password is to set the length indicator on the field named secret within AuthMethodTypeData (which is the type of the individual elements of AuthenticationBundle) to zero. */
	public AuthenticationBundle[] getConfiguredAuthMethods() {
		return this.configuredAuthMethods;
	}
	/** @param x The set of the authentication methods for the initiator. When creating a new initiator, this field defines the authentication methods that the new initiator will have. When updating an existing initiator, this field replaces all existing authentication methods; depending on how the caller populates the list, authentication methods may be added, deleted, or modified. Secrets associated with authentication methods may be modified in this manner. The way to indicate that there is no password is to set the length indicator on the field named secret within AuthMethodTypeData (which is the type of the individual elements of AuthenticationBundle) to zero. */
	public void setConfiguredAuthMethods(AuthenticationBundle[] x) {
		this.configuredAuthMethods = x;
	}

	/** A reference to the host with which this initiator is associated. */
	@io.swagger.annotations.ApiModelProperty(value ="A reference to the host with which this initiator is associated." , required = true)
	@XmlElement(required = true)
	private String[] hostRef;

	/** @return A reference to the host with which this initiator is associated. */
	public String[] getHostRef() {
		return this.hostRef;
	}
	/** @param x A reference to the host with which this initiator is associated. */
	public void setHostRef(String[] x) {
		this.hostRef = x;
	}
}
