package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** This union contains settings for changeable properties of a remote target object. */
@SuppressWarnings("serial")
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(843)
public class InitiatorTargetChangeableProperties implements Serializable {
	public InitiatorTargetChangeableProperties() {
	}

	/** This enumeration defines the different I/O interface types that may be reported as part of the configuration information associated with a controller. */
	@io.swagger.annotations.ApiModelProperty(value ="This enumeration defines the different I/O interface types that may be reported as part of the configuration information associated with a controller." , required = true)
	@XmlElement(required = true)
	private IOInterfaceType ioInterfaceType = IOInterfaceType.__UNDEFINED;

	/** @return This enumeration defines the different I/O interface types that may be reported as part of the configuration information associated with a controller. */
	public IOInterfaceType getIoInterfaceType() {
		return this.ioInterfaceType;
	}
	/** @param x This enumeration defines the different I/O interface types that may be reported as part of the configuration information associated with a controller. */
	public void setIoInterfaceType(IOInterfaceType x) {
		this.ioInterfaceType = x;
	}

	/** This data is returned if the ioInterfaceType is equal to IO_IF_ISCSI */
	@io.swagger.annotations.ApiModelProperty(value ="This data is returned if the ioInterfaceType is equal to IO_IF_ISCSI" , required = false)
	@XmlElement(required = false)
	private IscsiInitiatorTargetBaseParameters iSCSIInitiatorTargetBaseParameters;

	/** @return This data is returned if the ioInterfaceType is equal to IO_IF_ISCSI */
	public IscsiInitiatorTargetBaseParameters getISCSIInitiatorTargetBaseParameters() {
		return this.iSCSIInitiatorTargetBaseParameters;
	}
	/** @param x This data is returned if the ioInterfaceType is equal to IO_IF_ISCSI */
	public void setISCSIInitiatorTargetBaseParameters(IscsiInitiatorTargetBaseParameters x) {
		this.iSCSIInitiatorTargetBaseParameters = x;
	}

	/** The node name is returned if the ioInterfaceType is equal to IO_IF_FC. */
	@io.swagger.annotations.ApiModelProperty(value ="The node name is returned if the ioInterfaceType is equal to IO_IF_FC." , required = false)
	@XmlElement(required = false)
	private ScsiNodeName[] nodeName;

	/** @return The node name is returned if the ioInterfaceType is equal to IO_IF_FC. */
	public ScsiNodeName[] getNodeName() {
		return this.nodeName;
	}
	/** @param x The node name is returned if the ioInterfaceType is equal to IO_IF_FC. */
	public void setNodeName(ScsiNodeName[] x) {
		this.nodeName = x;
	}
}
