package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** This structure contains the updated settings for the remote entity (initiator or target). */
@SuppressWarnings("serial")
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(857)
public class InitiatorTargetPropertiesUpdateDescriptor implements Serializable {
	public InitiatorTargetPropertiesUpdateDescriptor() {
	}

	/** The remote entity (initiator or target) to which the property settings apply. */
	@io.swagger.annotations.ApiModelProperty(value ="The remote entity (initiator or target) to which the property settings apply." , required = true)
	@XmlElement(required = true)
	private String remoteRef;

	/** @return The remote entity (initiator or target) to which the property settings apply. */
	public String getRemoteRef() {
		return this.remoteRef;
	}
	/** @param x The remote entity (initiator or target) to which the property settings apply. */
	public void setRemoteRef(String x) {
		this.remoteRef = x;
	}

	/** The settings for the remote target. */
	@io.swagger.annotations.ApiModelProperty(value ="The settings for the remote target." , required = true)
	@XmlElement(required = true)
	private InitiatorTargetChangeableProperties remoteTargetSettings;

	/** @return The settings for the remote target. */
	public InitiatorTargetChangeableProperties getRemoteTargetSettings() {
		return this.remoteTargetSettings;
	}
	/** @param x The settings for the remote target. */
	public void setRemoteTargetSettings(InitiatorTargetChangeableProperties x) {
		this.remoteTargetSettings = x;
	}
}
