package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** This enumeration data type identifies the possible states of Internet Protocol address configuration. */
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(262)
public enum IpConfigState implements Serializable {
		/** The address parameters have not been configured. */
		unconfigured(1),
		/** The interface is in the process of acquiring certain address-related parameters, including IP address. */
		acquiring(2),
		/** The address parameters are configured for operation. */
		configured(3),
		/** The address configuration is invalid, most likely due to improper manual configuration. */
		invalid(4),
		__UNDEFINED(464378545);

		public final int value;

		private IpConfigState(int v) {
			this.value = v;
		}
}
