package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** This structure contains the iSCSI copper cable diagnostics results for a specific channel. */
@SuppressWarnings("serial")
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(372)
public class IscsiCableDiagChannelResults implements Serializable {
	public IscsiCableDiagChannelResults() {
	}

	/** A code indicating the status results for the channel. */
	@io.swagger.annotations.ApiModelProperty(value ="A code indicating the status results for the channel." , required = true)
	@XmlElement(required = true)
	private int channelStatus;

	/** @return A code indicating the status results for the channel. */
	public int getChannelStatus() {
		return this.channelStatus;
	}
	/** @param x A code indicating the status results for the channel. */
	public void setChannelStatus(int x) {
		this.channelStatus = x;
	}

	/** The approximate length of the cable measured in meters. */
	@io.swagger.annotations.ApiModelProperty(value ="The approximate length of the cable measured in meters." , required = true)
	@XmlElement(required = true)
	private int cableLength;

	/** @return The approximate length of the cable measured in meters. */
	public int getCableLength() {
		return this.cableLength;
	}
	/** @param x The approximate length of the cable measured in meters. */
	public void setCableLength(int x) {
		this.cableLength = x;
	}
}
