package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** This structure is used with the setIscsiInterfceProperties procedure. It indicates what properties the caller wants to set and the values for those properties. To support setting a subset of these properties, all of the fields are variable-length arrays of maximum size one; If the caller does not want to set a property, the corresponding length indicator should be zero; otherwise the length indicator is one, and the single element is the new value of the property. */
@SuppressWarnings("serial")
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(836)
public class IscsiInterfaceChangeableProperties implements Serializable {
	public IscsiInterfaceChangeableProperties() {
	}

	/** The tcp port number on which to listen for incoming connections. */
	@io.swagger.annotations.ApiModelProperty(value ="The tcp port number on which to listen for incoming connections." , required = true)
	@XmlElement(required = true)
	private int[] tcpListenPort;

	/** @return The tcp port number on which to listen for incoming connections. */
	public int[] getTcpListenPort() {
		return this.tcpListenPort;
	}
	/** @param x The tcp port number on which to listen for incoming connections. */
	public void setTcpListenPort(int[] x) {
		this.tcpListenPort = x;
	}

	/** The IPV4 address for the interface. */
	@io.swagger.annotations.ApiModelProperty(value ="The IPV4 address for the interface." , required = true)
	@XmlElement(required = true)
	private String[] ipv4Address;

	/** @return The IPV4 address for the interface. */
	public String[] getIpv4Address() {
		return this.ipv4Address;
	}
	/** @param x The IPV4 address for the interface. */
	public void setIpv4Address(String[] x) {
		this.ipv4Address = x;
	}

	/** The IPV4 subnet mask for the interface. */
	@io.swagger.annotations.ApiModelProperty(value ="The IPV4 subnet mask for the interface." , required = true)
	@XmlElement(required = true)
	private String[] ipv4SubnetMask;

	/** @return The IPV4 subnet mask for the interface. */
	public String[] getIpv4SubnetMask() {
		return this.ipv4SubnetMask;
	}
	/** @param x The IPV4 subnet mask for the interface. */
	public void setIpv4SubnetMask(String[] x) {
		this.ipv4SubnetMask = x;
	}

	/** The gateway IPV4 address for the interface. */
	@io.swagger.annotations.ApiModelProperty(value ="The gateway IPV4 address for the interface." , required = true)
	@XmlElement(required = true)
	private String[] ipv4GatewayAddress;

	/** @return The gateway IPV4 address for the interface. */
	public String[] getIpv4GatewayAddress() {
		return this.ipv4GatewayAddress;
	}
	/** @param x The gateway IPV4 address for the interface. */
	public void setIpv4GatewayAddress(String[] x) {
		this.ipv4GatewayAddress = x;
	}

	/** The IPV4 configuration method for the interface. The method is either by static setting of the IP address (IPV4_CONFIG_STATIC) or by use of the dynamic host configuration protocol (IPV4_CONFIG_DHCP). Whenever there is a transition of the configuration method from IPV4_CONFIG_STATIC to IPV4_CONFIG_DHCP, the storage array performs the equivalent of a refreshIscsiDhcpParameters operation. */
	@io.swagger.annotations.ApiModelProperty(value ="The IPV4 configuration method for the interface. The method is either by static setting of the IP address (IPV4_CONFIG_STATIC) or by use of the dynamic host configuration protocol (IPV4_CONFIG_DHCP). Whenever there is a transition of the configuration method from IPV4_CONFIG_STATIC to IPV4_CONFIG_DHCP, the storage array performs the equivalent of a refreshIscsiDhcpParameters operation." , required = true)
	@XmlElement(required = true)
	private IpV4ConfigMethod[] ipv4AddressConfigMethod;

	/** @return The IPV4 configuration method for the interface. The method is either by static setting of the IP address (IPV4_CONFIG_STATIC) or by use of the dynamic host configuration protocol (IPV4_CONFIG_DHCP). Whenever there is a transition of the configuration method from IPV4_CONFIG_STATIC to IPV4_CONFIG_DHCP, the storage array performs the equivalent of a refreshIscsiDhcpParameters operation. */
	public IpV4ConfigMethod[] getIpv4AddressConfigMethod() {
		return this.ipv4AddressConfigMethod;
	}
	/** @param x The IPV4 configuration method for the interface. The method is either by static setting of the IP address (IPV4_CONFIG_STATIC) or by use of the dynamic host configuration protocol (IPV4_CONFIG_DHCP). Whenever there is a transition of the configuration method from IPV4_CONFIG_STATIC to IPV4_CONFIG_DHCP, the storage array performs the equivalent of a refreshIscsiDhcpParameters operation. */
	public void setIpv4AddressConfigMethod(IpV4ConfigMethod[] x) {
		this.ipv4AddressConfigMethod = x;
	}

	/** The maximum size of the payload section in an Ethernet frame. */
	@io.swagger.annotations.ApiModelProperty(value ="The maximum size of the payload section in an Ethernet frame." , required = true)
	@XmlElement(required = true)
	private int[] maximumFramePayloadSize;

	/** @return The maximum size of the payload section in an Ethernet frame. */
	public int[] getMaximumFramePayloadSize() {
		return this.maximumFramePayloadSize;
	}
	/** @param x The maximum size of the payload section in an Ethernet frame. */
	public void setMaximumFramePayloadSize(int[] x) {
		this.maximumFramePayloadSize = x;
	}

	/** Settings that govern the value of the IPV4 VLAN identifier for the interface. */
	@io.swagger.annotations.ApiModelProperty(value ="Settings that govern the value of the IPV4 VLAN identifier for the interface." , required = true)
	@XmlElement(required = true)
	private SettingControl[] ipv4VlanId;

	/** @return Settings that govern the value of the IPV4 VLAN identifier for the interface. */
	public SettingControl[] getIpv4VlanId() {
		return this.ipv4VlanId;
	}
	/** @param x Settings that govern the value of the IPV4 VLAN identifier for the interface. */
	public void setIpv4VlanId(SettingControl[] x) {
		this.ipv4VlanId = x;
	}

	/** Settings that govern the priority to associate with outbound IPV4 packets sent over the interface. */
	@io.swagger.annotations.ApiModelProperty(value ="Settings that govern the priority to associate with outbound IPV4 packets sent over the interface." , required = true)
	@XmlElement(required = true)
	private SettingControl[] ipv4OutboundPacketPriority;

	/** @return Settings that govern the priority to associate with outbound IPV4 packets sent over the interface. */
	public SettingControl[] getIpv4OutboundPacketPriority() {
		return this.ipv4OutboundPacketPriority;
	}
	/** @param x Settings that govern the priority to associate with outbound IPV4 packets sent over the interface. */
	public void setIpv4OutboundPacketPriority(SettingControl[] x) {
		this.ipv4OutboundPacketPriority = x;
	}

	/** A boolean which, if set to true, indicates that IPV4 addressing should be enabled for the interface. */
	@io.swagger.annotations.ApiModelProperty(value ="A boolean which, if set to true, indicates that IPV4 addressing should be enabled for the interface." , required = true)
	@XmlElement(required = true)
	private boolean[] ipv4Enabled;

	/** @return A boolean which, if set to true, indicates that IPV4 addressing should be enabled for the interface. */
	public boolean[] getIpv4Enabled() {
		return this.ipv4Enabled;
	}
	/** @param x A boolean which, if set to true, indicates that IPV4 addressing should be enabled for the interface. */
	public void setIpv4Enabled(boolean[] x) {
		this.ipv4Enabled = x;
	}

	/** A boolean which, if set to true, indicates that IPV6 addressing should be enabled for the interface. */
	@io.swagger.annotations.ApiModelProperty(value ="A boolean which, if set to true, indicates that IPV6 addressing should be enabled for the interface." , required = true)
	@XmlElement(required = true)
	private boolean[] ipv6Enabled;

	/** @return A boolean which, if set to true, indicates that IPV6 addressing should be enabled for the interface. */
	public boolean[] getIpv6Enabled() {
		return this.ipv6Enabled;
	}
	/** @param x A boolean which, if set to true, indicates that IPV6 addressing should be enabled for the interface. */
	public void setIpv6Enabled(boolean[] x) {
		this.ipv6Enabled = x;
	}

	/** The set of IPV6 local addresses that are to be assigned to the interface. This set completely replaces the previous set. */
	@io.swagger.annotations.ApiModelProperty(value ="The set of IPV6 local addresses that are to be assigned to the interface. This set completely replaces the previous set." , required = true)
	@XmlElement(required = true)
	private IpV6AddressDataBundle[] ipv6LocalAddresses;

	/** @return The set of IPV6 local addresses that are to be assigned to the interface. This set completely replaces the previous set. */
	public IpV6AddressDataBundle[] getIpv6LocalAddresses() {
		return this.ipv6LocalAddresses;
	}
	/** @param x The set of IPV6 local addresses that are to be assigned to the interface. This set completely replaces the previous set. */
	public void setIpv6LocalAddresses(IpV6AddressDataBundle[] x) {
		this.ipv6LocalAddresses = x;
	}

	/** The set of IPV6 routable addresses that are to be assigned to the interface. This set completely replaces the previous set. */
	@io.swagger.annotations.ApiModelProperty(value ="The set of IPV6 routable addresses that are to be assigned to the interface. This set completely replaces the previous set." , required = true)
	@XmlElement(required = true)
	private IpV6AddressDataBundle[] ipv6RoutableAddresses;

	/** @return The set of IPV6 routable addresses that are to be assigned to the interface. This set completely replaces the previous set. */
	public IpV6AddressDataBundle[] getIpv6RoutableAddresses() {
		return this.ipv6RoutableAddresses;
	}
	/** @param x The set of IPV6 routable addresses that are to be assigned to the interface. This set completely replaces the previous set. */
	public void setIpv6RoutableAddresses(IpV6AddressDataBundle[] x) {
		this.ipv6RoutableAddresses = x;
	}

	/** The address to set for the IPV6 port router. */
	@io.swagger.annotations.ApiModelProperty(value ="The address to set for the IPV6 port router." , required = true)
	@XmlElement(required = true)
	private IpV6AddressData[] ipv6PortRouterAddress;

	/** @return The address to set for the IPV6 port router. */
	public IpV6AddressData[] getIpv6PortRouterAddress() {
		return this.ipv6PortRouterAddress;
	}
	/** @param x The address to set for the IPV6 port router. */
	public void setIpv6PortRouterAddress(IpV6AddressData[] x) {
		this.ipv6PortRouterAddress = x;
	}

	/** The method to use in configuring IPV6 addresses for the interface. */
	@io.swagger.annotations.ApiModelProperty(value ="The method to use in configuring IPV6 addresses for the interface." , required = true)
	@XmlElement(required = true)
	private IpV6ConfigMethod[] ipv6AddressConfigMethod;

	/** @return The method to use in configuring IPV6 addresses for the interface. */
	public IpV6ConfigMethod[] getIpv6AddressConfigMethod() {
		return this.ipv6AddressConfigMethod;
	}
	/** @param x The method to use in configuring IPV6 addresses for the interface. */
	public void setIpv6AddressConfigMethod(IpV6ConfigMethod[] x) {
		this.ipv6AddressConfigMethod = x;
	}

	/** Settings that govern priority assignment for packets sent over the interface. */
	@io.swagger.annotations.ApiModelProperty(value ="Settings that govern priority assignment for packets sent over the interface." , required = true)
	@XmlElement(required = true)
	private SettingControl[] ipv6OutboundPacketPriority;

	/** @return Settings that govern priority assignment for packets sent over the interface. */
	public SettingControl[] getIpv6OutboundPacketPriority() {
		return this.ipv6OutboundPacketPriority;
	}
	/** @param x Settings that govern priority assignment for packets sent over the interface. */
	public void setIpv6OutboundPacketPriority(SettingControl[] x) {
		this.ipv6OutboundPacketPriority = x;
	}

	/** Settings that govern VLAN identifier assignment for packets sent over the interface. */
	@io.swagger.annotations.ApiModelProperty(value ="Settings that govern VLAN identifier assignment for packets sent over the interface." , required = true)
	@XmlElement(required = true)
	private SettingControl[] ipv6VlanId;

	/** @return Settings that govern VLAN identifier assignment for packets sent over the interface. */
	public SettingControl[] getIpv6VlanId() {
		return this.ipv6VlanId;
	}
	/** @param x Settings that govern VLAN identifier assignment for packets sent over the interface. */
	public void setIpv6VlanId(SettingControl[] x) {
		this.ipv6VlanId = x;
	}

	/** The hop limit to use in IPV6 packets sent over the interface. */
	@io.swagger.annotations.ApiModelProperty(value ="The hop limit to use in IPV6 packets sent over the interface." , required = true)
	@XmlElement(required = true)
	private short[] ipv6HopLimit;

	/** @return The hop limit to use in IPV6 packets sent over the interface. */
	public short[] getIpv6HopLimit() {
		return this.ipv6HopLimit;
	}
	/** @param x The hop limit to use in IPV6 packets sent over the interface. */
	public void setIpv6HopLimit(short[] x) {
		this.ipv6HopLimit = x;
	}

	/** The amount of time in milliseconds, within which a neighbor is assumed to be reachable */
	@io.swagger.annotations.ApiModelProperty(value ="The amount of time in milliseconds, within which a neighbor is assumed to be reachable" , required = true)
	@XmlElement(required = true)
	private int[] ipv6NdReachableTime;

	/** @return The amount of time in milliseconds, within which a neighbor is assumed to be reachable */
	public int[] getIpv6NdReachableTime() {
		return this.ipv6NdReachableTime;
	}
	/** @param x The amount of time in milliseconds, within which a neighbor is assumed to be reachable */
	public void setIpv6NdReachableTime(int[] x) {
		this.ipv6NdReachableTime = x;
	}

	/** The number of milliseconds between neighbor solicitation probes. */
	@io.swagger.annotations.ApiModelProperty(value ="The number of milliseconds between neighbor solicitation probes." , required = true)
	@XmlElement(required = true)
	private int[] ipv6NdRetransmitTime;

	/** @return The number of milliseconds between neighbor solicitation probes. */
	public int[] getIpv6NdRetransmitTime() {
		return this.ipv6NdRetransmitTime;
	}
	/** @param x The number of milliseconds between neighbor solicitation probes. */
	public void setIpv6NdRetransmitTime(int[] x) {
		this.ipv6NdRetransmitTime = x;
	}

	/** The time in milliseconds after which information for a neighbor that cannot be verified as reachable will be considered "stale. */
	@io.swagger.annotations.ApiModelProperty(value ="The time in milliseconds after which information for a neighbor that cannot be verified as reachable will be considered \"stale." , required = true)
	@XmlElement(required = true)
	private int[] ipv6NdStaleTimeout;

	/** @return The time in milliseconds after which information for a neighbor that cannot be verified as reachable will be considered "stale. */
	public int[] getIpv6NdStaleTimeout() {
		return this.ipv6NdStaleTimeout;
	}
	/** @param x The time in milliseconds after which information for a neighbor that cannot be verified as reachable will be considered "stale. */
	public void setIpv6NdStaleTimeout(int[] x) {
		this.ipv6NdStaleTimeout = x;
	}

	/** The number of neighbor-solicitation messages to send in trying to determine IP address uniqueness. */
	@io.swagger.annotations.ApiModelProperty(value ="The number of neighbor-solicitation messages to send in trying to determine IP address uniqueness." , required = true)
	@XmlElement(required = true)
	private short[] ipv6DuplicateAddressDetectionAttempts;

	/** @return The number of neighbor-solicitation messages to send in trying to determine IP address uniqueness. */
	public short[] getIpv6DuplicateAddressDetectionAttempts() {
		return this.ipv6DuplicateAddressDetectionAttempts;
	}
	/** @param x The number of neighbor-solicitation messages to send in trying to determine IP address uniqueness. */
	public void setIpv6DuplicateAddressDetectionAttempts(short[] x) {
		this.ipv6DuplicateAddressDetectionAttempts = x;
	}

	/** This field is used to set the maximum interface speed. If autoconfiguration is supported (see the autoconfigSupport field in the EthernetInterfaceData structure), the value in this field is ignored. */
	@io.swagger.annotations.ApiModelProperty(value ="This field is used to set the maximum interface speed. If autoconfiguration is supported (see the autoconfigSupport field in the EthernetInterfaceData structure), the value in this field is ignored." , required = true)
	@XmlElement(required = true)
	private InterfaceSpeed[] maximumInterfaceSpeed;

	/** @return This field is used to set the maximum interface speed. If autoconfiguration is supported (see the autoconfigSupport field in the EthernetInterfaceData structure), the value in this field is ignored. */
	public InterfaceSpeed[] getMaximumInterfaceSpeed() {
		return this.maximumInterfaceSpeed;
	}
	/** @param x This field is used to set the maximum interface speed. If autoconfiguration is supported (see the autoconfigSupport field in the EthernetInterfaceData structure), the value in this field is ignored. */
	public void setMaximumInterfaceSpeed(InterfaceSpeed[] x) {
		this.maximumInterfaceSpeed = x;
	}
}
