package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** This structure is used with the getIscsiNegotiationDefaults procedure. It contains the iSCSI negotiation default settings for sessions and connections. */
@SuppressWarnings("serial")
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(618)
public class IscsiNegotiationDefaults implements Serializable {
	public IscsiNegotiationDefaults() {
	}

	/** The session-level default settings */
	@io.swagger.annotations.ApiModelProperty(value ="The session-level default settings" , required = true)
	@XmlElement(required = true)
	private IscsiNegotiableSessionSettings sessionDefaults;

	/** @return The session-level default settings */
	public IscsiNegotiableSessionSettings getSessionDefaults() {
		return this.sessionDefaults;
	}
	/** @param x The session-level default settings */
	public void setSessionDefaults(IscsiNegotiableSessionSettings x) {
		this.sessionDefaults = x;
	}

	/** The connection-level default settings */
	@io.swagger.annotations.ApiModelProperty(value ="The connection-level default settings" , required = true)
	@XmlElement(required = true)
	private IscsiNegotiableConnectionSettings connectionDefaults;

	/** @return The connection-level default settings */
	public IscsiNegotiableConnectionSettings getConnectionDefaults() {
		return this.connectionDefaults;
	}
	/** @param x The connection-level default settings */
	public void setConnectionDefaults(IscsiNegotiableConnectionSettings x) {
		this.connectionDefaults = x;
	}
}
