package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** This enumeration type identifies the different ways that the getIscsiStatistics procedure call has for reporting the statistics - either absolute or relative. */
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(128)
public enum IscsiStatisticsReportType implements Serializable {
		/** The reported statistics are the raw, start-of-day-relative counter values maintained by the firmware. */
		raw(0),
		/** The reported statistics are relative to the client-set baseline (see setIscsiStatisticsBaseline procedure). */
		rel(1),
		__UNDEFINED(464378545);

		public final int value;

		private IscsiStatisticsReportType(int v) {
			this.value = v;
		}
}
