package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** This structure defines the how a KeyValue identified by it ref is associated with an an object. */
@SuppressWarnings("serial")
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(850)
public class KeyValueTagMapping implements Serializable {
	public KeyValueTagMapping() {
	}

	/** This field identifies the key-value tag to be associated with the Volume or Workload. */
	@io.swagger.annotations.ApiModelProperty(value ="This field identifies the key-value tag to be associated with the Volume or Workload." , required = true)
	@XmlElement(required = true)
	private String keyValueTagRef;

	/** @return This field identifies the key-value tag to be associated with the Volume or Workload. */
	public String getKeyValueTagRef() {
		return this.keyValueTagRef;
	}
	/** @param x This field identifies the key-value tag to be associated with the Volume or Workload. */
	public void setKeyValueTagRef(String x) {
		this.keyValueTagRef = x;
	}

	/** This element identifies the object that is associated with the key-value tag. */
	@io.swagger.annotations.ApiModelProperty(value ="This element identifies the object that is associated with the key-value tag." , required = true)
	@XmlElement(required = true)
	private KeyValueTagObjectReference associatedObject;

	/** @return This element identifies the object that is associated with the key-value tag. */
	public KeyValueTagObjectReference getAssociatedObject() {
		return this.associatedObject;
	}
	/** @param x This element identifies the object that is associated with the key-value tag. */
	public void setAssociatedObject(KeyValueTagObjectReference x) {
		this.associatedObject = x;
	}

	/** The unique identifier for the specific mapping between the KeyValueTag and the KeyValueTagObjectReference identified in this structure. */
	@io.swagger.annotations.ApiModelProperty(value ="The unique identifier for the specific mapping between the KeyValueTag and the KeyValueTagObjectReference identified in this structure." , required = true)
	@XmlElement(required = true)
	private String mappingRef;

	/** @return The unique identifier for the specific mapping between the KeyValueTag and the KeyValueTagObjectReference identified in this structure. */
	public String getMappingRef() {
		return this.mappingRef;
	}
	/** @param x The unique identifier for the specific mapping between the KeyValueTag and the KeyValueTagObjectReference identified in this structure. */
	public void setMappingRef(String x) {
		this.mappingRef = x;
	}
}
