package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** This enumeration identifies the different user groups defined for the management client record facility. Group IDs are a way of allowing multiple clients to use the management client record facility without having to worry about intermingling of their records. Essentially each group has its own data set. It is assumed that clients will be well-behaved and not masquerade as another group; there is no provision in SYMbol to explicitly prevent this, however. Engenio is the only organization that can assign new group IDs; any client wanting to use the management client record facility must obtain a group ID from Engenio. */
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(66)
public enum MCR_GROUP_ID implements Serializable {
		/** First user group. */
		apollo(0),
		/** Second user group. */
		aggregation(1),
		/** Third user group. */
		smis(2),
		/** For internal use only. */
		groupIdInternal(3),
		/** For App Aware. */
		appAware(4),
		/** Autosupport user group. */
		asup(5),
		/** ASUP configuration key. */
		asupConfiguration(6),
		/** Global preference store key. */
		prefStoreGlobal(7),
		/** Array data preference store key. */
		prefStoreArray(8),
		/** Persistent monitor configuration key. */
		persistentMonitor(9),
		/** SSD wear level data key. */
		ssdWearLevelData(10),
		__UNDEFINED(464378545);

		public final int value;

		private MCR_GROUP_ID(int v) {
			this.value = v;
		}
}
