package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** This structure is used to contain information about a metadata volume. */
@SuppressWarnings("serial")
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(1049)
public class MetadataVolume implements Serializable {
	public MetadataVolume() {
	}

	/** This object identifies the metadata volume. */
	@io.swagger.annotations.ApiModelProperty(value ="This object identifies the metadata volume." , required = true)
	@XmlElement(required = true)
	private String metadataVolRef;

	/** @return This object identifies the metadata volume. */
	public String getMetadataVolRef() {
		return this.metadataVolRef;
	}
	/** @param x This object identifies the metadata volume. */
	public void setMetadataVolRef(String x) {
		this.metadataVolRef = x;
	}

	/** This object specifies the metadata volume type. */
	@io.swagger.annotations.ApiModelProperty(value ="This object specifies the metadata volume type." , required = true)
	@XmlElement(required = true)
	private MetadataVolType metadataVolType = MetadataVolType.__UNDEFINED;

	/** @return This object specifies the metadata volume type. */
	public MetadataVolType getMetadataVolType() {
		return this.metadataVolType;
	}
	/** @param x This object specifies the metadata volume type. */
	public void setMetadataVolType(MetadataVolType x) {
		this.metadataVolType = x;
	}

	/** Volume that contains data */
	@io.swagger.annotations.ApiModelProperty(value ="Volume that contains data" , required = true)
	@XmlElement(required = true)
	private String associatedVolume;

	/** @return Volume that contains data */
	public String getAssociatedVolume() {
		return this.associatedVolume;
	}
	/** @param x Volume that contains data */
	public void setAssociatedVolume(String x) {
		this.associatedVolume = x;
	}

	/** The controller that created the metadata volume. */
	@io.swagger.annotations.ApiModelProperty(value ="The controller that created the metadata volume." , required = true)
	@XmlElement(required = true)
	private String preferredManager;

	/** @return The controller that created the metadata volume. */
	public String getPreferredManager() {
		return this.preferredManager;
	}
	/** @param x The controller that created the metadata volume. */
	public void setPreferredManager(String x) {
		this.preferredManager = x;
	}

	/** The permissions allowed. */
	@io.swagger.annotations.ApiModelProperty(value ="The permissions allowed." , required = true)
	@XmlElement(required = true)
	private VolumePerms perms;

	/** @return The permissions allowed. */
	public VolumePerms getPerms() {
		return this.perms;
	}
	/** @param x The permissions allowed. */
	public void setPerms(VolumePerms x) {
		this.perms = x;
	}

	/** True, if the volume is offline. */
	@io.swagger.annotations.ApiModelProperty(value ="True, if the volume is offline." , required = true)
	@XmlElement(required = true)
	private boolean offline;

	/** @return True, if the volume is offline. */
	public boolean isOffline() {
		return this.offline;
	}
	/** @param x True, if the volume is offline. */
	public void setOffline(boolean x) {
		this.offline = x;
	}

	/** Reserved */
	@XmlTransient
	private String reserved1;

	/** @return Reserved */
	public String getReserved1() {
		return this.reserved1;
	}
	/** @param x Reserved */
	public void setReserved1(String x) {
		this.reserved1 = x;
	}
}
