package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** This enumeration object is used to indicate the NetApp management applications that are allowed to manage a particular storage array. */
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(152)
public enum MgmtApplicationType implements Serializable {
		/** No Engenio management application is allowed to manage the array. */
		none(0),
		/** Only a SANtricity AMW is allowed to manage the array. */
		santricity(1),
		/** Only freestanding Simplicity is allowed to manage the array. */
		simplicity(2),
		/** Either SANtricity-invoked Simplicity or freestanding Simplicity is allowed to manage the array. */
		santricityOrSimplicity(3),
		/** SANtricity UMW is allowed to manage the array. */
		umw(4),
		__UNDEFINED(464378545);

		public final int value;

		private MgmtApplicationType(int v) {
			this.value = v;
		}
}
