package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** This structure contains an ID value and some opaque content that is not interpreted in any way by the controller firmware. */
@SuppressWarnings("serial")
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(533)
public class MgmtClientRecord implements Serializable {
	public MgmtClientRecord() {
	}

	/** This field contains the database ID of the record. */
	@io.swagger.annotations.ApiModelProperty(value ="This field contains the database ID of the record." , required = true)
	@XmlElement(required = true)
	private MgmtClientRecordId id;

	/** @return This field contains the database ID of the record. */
	public MgmtClientRecordId getId() {
		return this.id;
	}
	/** @param x This field contains the database ID of the record. */
	public void setId(MgmtClientRecordId x) {
		this.id = x;
	}

	/** This field contains data that is represented as a group of byte values along with information about the content length. */
	@io.swagger.annotations.ApiModelProperty(value ="This field contains data that is represented as a group of byte values along with information about the content length." , required = true)
	@XmlElement(required = true)
	private String content;

	/** @return This field contains data that is represented as a group of byte values along with information about the content length. */
	public String getContent() {
		return this.content;
	}
	/** @param x This field contains data that is represented as a group of byte values along with information about the content length. */
	public void setContent(String x) {
		this.content = x;
	}
}
