package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** This structure is used to convey information about the critical aspects of a minihub. */
@SuppressWarnings("serial")
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(1015)
public class Minihub implements Serializable {
	public Minihub() {
	}

	/** The reference for this physical minihub. */
	@io.swagger.annotations.ApiModelProperty(value ="The reference for this physical minihub." , required = true)
	@XmlElement(required = true)
	private String minihubRef;

	/** @return The reference for this physical minihub. */
	public String getMinihubRef() {
		return this.minihubRef;
	}
	/** @param x The reference for this physical minihub. */
	public void setMinihubRef(String x) {
		this.minihubRef = x;
	}

	/** The operational status of the minihub. */
	@io.swagger.annotations.ApiModelProperty(value ="The operational status of the minihub." , required = true)
	@XmlElement(required = true)
	private MinihubStatus status = MinihubStatus.__UNDEFINED;

	/** @return The operational status of the minihub. */
	public MinihubStatus getStatus() {
		return this.status;
	}
	/** @param x The operational status of the minihub. */
	public void setStatus(MinihubStatus x) {
		this.status = x;
	}

	/** The physical location of the minihub. Note that the tray reference identifies the enclosure containing the minihub, but the slot information does not apply to this component. */
	@io.swagger.annotations.ApiModelProperty(value ="The physical location of the minihub. Note that the tray reference identifies the enclosure containing the minihub, but the slot information does not apply to this component." , required = true)
	@XmlElement(required = true)
	private Location physicalLocation;

	/** @return The physical location of the minihub. Note that the tray reference identifies the enclosure containing the minihub, but the slot information does not apply to this component. */
	public Location getPhysicalLocation() {
		return this.physicalLocation;
	}
	/** @param x The physical location of the minihub. Note that the tray reference identifies the enclosure containing the minihub, but the slot information does not apply to this component. */
	public void setPhysicalLocation(Location x) {
		this.physicalLocation = x;
	}

	/** Information returned is based on the minihub type. */
	@io.swagger.annotations.ApiModelProperty(value ="Information returned is based on the minihub type." , required = true)
	@XmlElement(required = true)
	private MinihubTypeData minihubData;

	/** @return Information returned is based on the minihub type. */
	public MinihubTypeData getMinihubData() {
		return this.minihubData;
	}
	/** @param x Information returned is based on the minihub type. */
	public void setMinihubData(MinihubTypeData x) {
		this.minihubData = x;
	}

	/** The current speed of the minihub. */
	@io.swagger.annotations.ApiModelProperty(value ="The current speed of the minihub." , required = true)
	@XmlElement(required = true)
	private InterfaceSpeed currentSpeed = InterfaceSpeed.__UNDEFINED;

	/** @return The current speed of the minihub. */
	public InterfaceSpeed getCurrentSpeed() {
		return this.currentSpeed;
	}
	/** @param x The current speed of the minihub. */
	public void setCurrentSpeed(InterfaceSpeed x) {
		this.currentSpeed = x;
	}

	/** The maximum speed of the minihub. */
	@io.swagger.annotations.ApiModelProperty(value ="The maximum speed of the minihub." , required = true)
	@XmlElement(required = true)
	private InterfaceSpeed maxSpeed = InterfaceSpeed.__UNDEFINED;

	/** @return The maximum speed of the minihub. */
	public InterfaceSpeed getMaxSpeed() {
		return this.maxSpeed;
	}
	/** @param x The maximum speed of the minihub. */
	public void setMaxSpeed(InterfaceSpeed x) {
		this.maxSpeed = x;
	}

	/** The channel number that this minihub is associated with. */
	@io.swagger.annotations.ApiModelProperty(value ="The channel number that this minihub is associated with." , required = true)
	@XmlElement(required = true)
	private int channel;

	/** @return The channel number that this minihub is associated with. */
	public int getChannel() {
		return this.channel;
	}
	/** @param x The channel number that this minihub is associated with. */
	public void setChannel(int x) {
		this.channel = x;
	}

	/** Detailed information for each port of the minihub. This field is deprecated. */
	@io.swagger.annotations.ApiModelProperty(value ="Detailed information for each port of the minihub. This field is deprecated." , required = true)
	@XmlElement(required = true)
	private PortList portList;

	/** @return Detailed information for each port of the minihub. This field is deprecated. */
	public PortList getPortList() {
		return this.portList;
	}
	/** @param x Detailed information for each port of the minihub. This field is deprecated. */
	public void setPortList(PortList x) {
		this.portList = x;
	}

	/** The vendor name of the minihub. */
	@io.swagger.annotations.ApiModelProperty(value ="The vendor name of the minihub." , required = true)
	@XmlElement(required = true)
	private String vendorName;

	/** @return The vendor name of the minihub. */
	public String getVendorName() {
		return this.vendorName;
	}
	/** @param x The vendor name of the minihub. */
	public void setVendorName(String x) {
		this.vendorName = x;
	}

	/** The part number of the minihub. */
	@io.swagger.annotations.ApiModelProperty(value ="The part number of the minihub." , required = true)
	@XmlElement(required = true)
	private String partNumber;

	/** @return The part number of the minihub. */
	public String getPartNumber() {
		return this.partNumber;
	}
	/** @param x The part number of the minihub. */
	public void setPartNumber(String x) {
		this.partNumber = x;
	}

	/** The serial number of the minihub. */
	@io.swagger.annotations.ApiModelProperty(value ="The serial number of the minihub." , required = true)
	@XmlElement(required = true)
	private String serialNumber;

	/** @return The serial number of the minihub. */
	public String getSerialNumber() {
		return this.serialNumber;
	}
	/** @param x The serial number of the minihub. */
	public void setSerialNumber(String x) {
		this.serialNumber = x;
	}

	/** The field replaceable unit type of the minihub. */
	@io.swagger.annotations.ApiModelProperty(value ="The field replaceable unit type of the minihub." , required = true)
	@XmlElement(required = true)
	private String fruType;

	/** @return The field replaceable unit type of the minihub. */
	public String getFruType() {
		return this.fruType;
	}
	/** @param x The field replaceable unit type of the minihub. */
	public void setFruType(String x) {
		this.fruType = x;
	}

	/** The date the minihub was manufactured. */
	@io.swagger.annotations.ApiModelProperty(value ="The date the minihub was manufactured." , required = true)
	@XmlElement(required = true)
	private long manufacturerDate;

	/** @return The date the minihub was manufactured. */
	public long getManufacturerDate() {
		return this.manufacturerDate;
	}
	/** @param x The date the minihub was manufactured. */
	public void setManufacturerDate(long x) {
		this.manufacturerDate = x;
	}

	/** Reserved for future use. */
	@XmlTransient
	private String reserved1;

	/** @return Reserved for future use. */
	public String getReserved1() {
		return this.reserved1;
	}
	/** @param x Reserved for future use. */
	public void setReserved1(String x) {
		this.reserved1 = x;
	}

	/** Reserved for future use. */
	@XmlTransient
	private String reserved2;

	/** @return Reserved for future use. */
	public String getReserved2() {
		return this.reserved2;
	}
	/** @param x Reserved for future use. */
	public void setReserved2(String x) {
		this.reserved2 = x;
	}

	/** The CRU type of the minihub plus its ready-to-remove attributes, which are based on the CRU type */
	@io.swagger.annotations.ApiModelProperty(value ="The CRU type of the minihub plus its ready-to-remove attributes, which are based on the CRU type" , required = true)
	@XmlElement(required = true)
	private RTRAttributes rtrAttributes;

	/** @return The CRU type of the minihub plus its ready-to-remove attributes, which are based on the CRU type */
	public RTRAttributes getRtrAttributes() {
		return this.rtrAttributes;
	}
	/** @param x The CRU type of the minihub plus its ready-to-remove attributes, which are based on the CRU type */
	public void setRtrAttributes(RTRAttributes x) {
		this.rtrAttributes = x;
	}
}
