package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** This structure is used to create a mirror. */
@SuppressWarnings("serial")
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(986)
public class MirrorCreationDescriptor implements Serializable {
	public MirrorCreationDescriptor() {
	}

	/** The local base volume to mirror from. */
	@io.swagger.annotations.ApiModelProperty(value ="The local base volume to mirror from." , required = true)
	@XmlElement(required = true)
	private String baseVolume;

	/** @return The local base volume to mirror from. */
	public String getBaseVolume() {
		return this.baseVolume;
	}
	/** @param x The local base volume to mirror from. */
	public void setBaseVolume(String x) {
		this.baseVolume = x;
	}

	/** This field is deprecated. It will continue to be supported if remoteNodeName is NULL (IOInterfaceType == IO_IF_NOT_IMPLEMENTED). This will allow continued compatibility with clients still using this field. */
	@io.swagger.annotations.ApiModelProperty(value ="This field is deprecated. It will continue to be supported if remoteNodeName is NULL (IOInterfaceType == IO_IF_NOT_IMPLEMENTED). This will allow continued compatibility with clients still using this field." , required = true)
	@XmlElement(required = true)
	private String remoteNodeWWN;

	/** @return This field is deprecated. It will continue to be supported if remoteNodeName is NULL (IOInterfaceType == IO_IF_NOT_IMPLEMENTED). This will allow continued compatibility with clients still using this field. */
	public String getRemoteNodeWWN() {
		return this.remoteNodeWWN;
	}
	/** @param x This field is deprecated. It will continue to be supported if remoteNodeName is NULL (IOInterfaceType == IO_IF_NOT_IMPLEMENTED). This will allow continued compatibility with clients still using this field. */
	public void setRemoteNodeWWN(String x) {
		this.remoteNodeWWN = x;
	}

	/** Remote volume WWN. */
	@io.swagger.annotations.ApiModelProperty(value ="Remote volume WWN." , required = true)
	@XmlElement(required = true)
	private String remoteVolWWN;

	/** @return Remote volume WWN. */
	public String getRemoteVolWWN() {
		return this.remoteVolWWN;
	}
	/** @param x Remote volume WWN. */
	public void setRemoteVolWWN(String x) {
		this.remoteVolWWN = x;
	}

	/** Synchronization priority for mirrors. */
	@io.swagger.annotations.ApiModelProperty(value ="Synchronization priority for mirrors." , required = true)
	@XmlElement(required = true)
	private MirrorSyncPriority syncPriority = MirrorSyncPriority.__UNDEFINED;

	/** @return Synchronization priority for mirrors. */
	public MirrorSyncPriority getSyncPriority() {
		return this.syncPriority;
	}
	/** @param x Synchronization priority for mirrors. */
	public void setSyncPriority(MirrorSyncPriority x) {
		this.syncPriority = x;
	}

	/** The password of the remote array. */
	@io.swagger.annotations.ApiModelProperty(value ="The password of the remote array." , required = true)
	@XmlElement(required = true)
	private RemoteMirrorAuthenticator remotePassword;

	/** @return The password of the remote array. */
	public RemoteMirrorAuthenticator getRemotePassword() {
		return this.remotePassword;
	}
	/** @param x The password of the remote array. */
	public void setRemotePassword(RemoteMirrorAuthenticator x) {
		this.remotePassword = x;
	}

	/** Mirror write mode for the pair. */
	@io.swagger.annotations.ApiModelProperty(value ="Mirror write mode for the pair." , required = true)
	@XmlElement(required = true)
	private MirrorProxyWriteMode writeMode = MirrorProxyWriteMode.__UNDEFINED;

	/** @return Mirror write mode for the pair. */
	public MirrorProxyWriteMode getWriteMode() {
		return this.writeMode;
	}
	/** @param x Mirror write mode for the pair. */
	public void setWriteMode(MirrorProxyWriteMode x) {
		this.writeMode = x;
	}

	/** Indicator for whether automatic resynchronization is allowed for this mirror. */
	@io.swagger.annotations.ApiModelProperty(value ="Indicator for whether automatic resynchronization is allowed for this mirror." , required = true)
	@XmlElement(required = true)
	private boolean autoResyncFlag;

	/** @return Indicator for whether automatic resynchronization is allowed for this mirror. */
	public boolean isAutoResyncFlag() {
		return this.autoResyncFlag;
	}
	/** @param x Indicator for whether automatic resynchronization is allowed for this mirror. */
	public void setAutoResyncFlag(boolean x) {
		this.autoResyncFlag = x;
	}

	/** Write consistency group reference. NULL = not in group. */
	@io.swagger.annotations.ApiModelProperty(value ="Write consistency group reference. NULL = not in group." , required = true)
	@XmlElement(required = true)
	private String consistencyGroupRef;

	/** @return Write consistency group reference. NULL = not in group. */
	public String getConsistencyGroupRef() {
		return this.consistencyGroupRef;
	}
	/** @param x Write consistency group reference. NULL = not in group. */
	public void setConsistencyGroupRef(String x) {
		this.consistencyGroupRef = x;
	}

	/** The name of the RemoteVolume. */
	@io.swagger.annotations.ApiModelProperty(value ="The name of the RemoteVolume." , required = true)
	@XmlElement(required = true)
	private ScsiNodeName remoteNodeName;

	/** @return The name of the RemoteVolume. */
	public ScsiNodeName getRemoteNodeName() {
		return this.remoteNodeName;
	}
	/** @param x The name of the RemoteVolume. */
	public void setRemoteNodeName(ScsiNodeName x) {
		this.remoteNodeName = x;
	}
}
