package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** This structure contains information about a MirrorProxyVolume. */
@SuppressWarnings("serial")
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(985)
public class MirrorProxyVolume implements Serializable {
	public MirrorProxyVolume() {
	}

	/** The WWN of the local mirror volume. */
	@io.swagger.annotations.ApiModelProperty(value ="The WWN of the local mirror volume." , required = true)
	@XmlElement(required = true)
	private String worldWideName;

	/** @return The WWN of the local mirror volume. */
	public String getWorldWideName() {
		return this.worldWideName;
	}
	/** @param x The WWN of the local mirror volume. */
	public void setWorldWideName(String x) {
		this.worldWideName = x;
	}

	/** The reference to the local mirror volume. */
	@io.swagger.annotations.ApiModelProperty(value ="The reference to the local mirror volume." , required = true)
	@XmlElement(required = true)
	private String mirrorProxyRef;

	/** @return The reference to the local mirror volume. */
	public String getMirrorProxyRef() {
		return this.mirrorProxyRef;
	}
	/** @param x The reference to the local mirror volume. */
	public void setMirrorProxyRef(String x) {
		this.mirrorProxyRef = x;
	}

	/** The ssid of the local mirror volume. */
	@io.swagger.annotations.ApiModelProperty(value ="The ssid of the local mirror volume." , required = true)
	@XmlElement(required = true)
	private int volumeHandle;

	/** @return The ssid of the local mirror volume. */
	public int getVolumeHandle() {
		return this.volumeHandle;
	}
	/** @param x The ssid of the local mirror volume. */
	public void setVolumeHandle(int x) {
		this.volumeHandle = x;
	}

	/** The status of the local mirror volume. */
	@io.swagger.annotations.ApiModelProperty(value ="The status of the local mirror volume." , required = true)
	@XmlElement(required = true)
	private MirrorProxyStatus localMirrorStatus = MirrorProxyStatus.__UNDEFINED;

	/** @return The status of the local mirror volume. */
	public MirrorProxyStatus getLocalMirrorStatus() {
		return this.localMirrorStatus;
	}
	/** @param x The status of the local mirror volume. */
	public void setLocalMirrorStatus(MirrorProxyStatus x) {
		this.localMirrorStatus = x;
	}

	/** The status of the remote mirror volume. */
	@io.swagger.annotations.ApiModelProperty(value ="The status of the remote mirror volume." , required = true)
	@XmlElement(required = true)
	private MirrorProxyStatus remoteMirrorStatus = MirrorProxyStatus.__UNDEFINED;

	/** @return The status of the remote mirror volume. */
	public MirrorProxyStatus getRemoteMirrorStatus() {
		return this.remoteMirrorStatus;
	}
	/** @param x The status of the remote mirror volume. */
	public void setRemoteMirrorStatus(MirrorProxyStatus x) {
		this.remoteMirrorStatus = x;
	}

	/** The role of the local mirror volume. */
	@io.swagger.annotations.ApiModelProperty(value ="The role of the local mirror volume." , required = true)
	@XmlElement(required = true)
	private MirrorProxyRole localRole = MirrorProxyRole.__UNDEFINED;

	/** @return The role of the local mirror volume. */
	public MirrorProxyRole getLocalRole() {
		return this.localRole;
	}
	/** @param x The role of the local mirror volume. */
	public void setLocalRole(MirrorProxyRole x) {
		this.localRole = x;
	}

	/** The role of the remote mirror volume. */
	@io.swagger.annotations.ApiModelProperty(value ="The role of the remote mirror volume." , required = true)
	@XmlElement(required = true)
	private MirrorProxyRole remoteRole = MirrorProxyRole.__UNDEFINED;

	/** @return The role of the remote mirror volume. */
	public MirrorProxyRole getRemoteRole() {
		return this.remoteRole;
	}
	/** @param x The role of the remote mirror volume. */
	public void setRemoteRole(MirrorProxyRole x) {
		this.remoteRole = x;
	}

	/** The synchronization priority for the local mirror volume. */
	@io.swagger.annotations.ApiModelProperty(value ="The synchronization priority for the local mirror volume." , required = true)
	@XmlElement(required = true)
	private MirrorSyncPriority localPriority = MirrorSyncPriority.__UNDEFINED;

	/** @return The synchronization priority for the local mirror volume. */
	public MirrorSyncPriority getLocalPriority() {
		return this.localPriority;
	}
	/** @param x The synchronization priority for the local mirror volume. */
	public void setLocalPriority(MirrorSyncPriority x) {
		this.localPriority = x;
	}

	/** The synchronization priority for the remote mirror volume. */
	@io.swagger.annotations.ApiModelProperty(value ="The synchronization priority for the remote mirror volume." , required = true)
	@XmlElement(required = true)
	private MirrorSyncPriority peerPriority = MirrorSyncPriority.__UNDEFINED;

	/** @return The synchronization priority for the remote mirror volume. */
	public MirrorSyncPriority getPeerPriority() {
		return this.peerPriority;
	}
	/** @param x The synchronization priority for the remote mirror volume. */
	public void setPeerPriority(MirrorSyncPriority x) {
		this.peerPriority = x;
	}

	/** The amount of capacity being used by the mirror. */
	@io.swagger.annotations.ApiModelProperty(value ="The amount of capacity being used by the mirror." , required = true)
	@XmlElement(required = true)
	private long usableCapacity;

	/** @return The amount of capacity being used by the mirror. */
	public long getUsableCapacity() {
		return this.usableCapacity;
	}
	/** @param x The amount of capacity being used by the mirror. */
	public void setUsableCapacity(long x) {
		this.usableCapacity = x;
	}

	/** The controller reference that owns the local mirror volume. */
	@io.swagger.annotations.ApiModelProperty(value ="The controller reference that owns the local mirror volume." , required = true)
	@XmlElement(required = true)
	private String currentManager;

	/** @return The controller reference that owns the local mirror volume. */
	public String getCurrentManager() {
		return this.currentManager;
	}
	/** @param x The controller reference that owns the local mirror volume. */
	public void setCurrentManager(String x) {
		this.currentManager = x;
	}

	/** The reference to the base volume of the local mirror. */
	@io.swagger.annotations.ApiModelProperty(value ="The reference to the base volume of the local mirror." , required = true)
	@XmlElement(required = true)
	private String baseVolume;

	/** @return The reference to the base volume of the local mirror. */
	public String getBaseVolume() {
		return this.baseVolume;
	}
	/** @param x The reference to the base volume of the local mirror. */
	public void setBaseVolume(String x) {
		this.baseVolume = x;
	}

	/** The reference to the remote volume. */
	@io.swagger.annotations.ApiModelProperty(value ="The reference to the remote volume." , required = true)
	@XmlElement(required = true)
	private String remoteVolRef;

	/** @return The reference to the remote volume. */
	public String getRemoteVolRef() {
		return this.remoteVolRef;
	}
	/** @param x The reference to the remote volume. */
	public void setRemoteVolRef(String x) {
		this.remoteVolRef = x;
	}

	/** An indication of what current long-running activity, if any, is currently in progress on the volume. */
	@io.swagger.annotations.ApiModelProperty(value ="An indication of what current long-running activity, if any, is currently in progress on the volume." , required = true)
	@XmlElement(required = true)
	private VolumeAction action = VolumeAction.__UNDEFINED;

	/** @return An indication of what current long-running activity, if any, is currently in progress on the volume. */
	public VolumeAction getAction() {
		return this.action;
	}
	/** @param x An indication of what current long-running activity, if any, is currently in progress on the volume. */
	public void setAction(VolumeAction x) {
		this.action = x;
	}

	/** Reserved */
	@XmlTransient
	private String reserved1;

	/** @return Reserved */
	public String getReserved1() {
		return this.reserved1;
	}
	/** @param x Reserved */
	public void setReserved1(String x) {
		this.reserved1 = x;
	}

	/** Reserved */
	@XmlTransient
	private String reserved2;

	/** @return Reserved */
	public String getReserved2() {
		return this.reserved2;
	}
	/** @param x Reserved */
	public void setReserved2(String x) {
		this.reserved2 = x;
	}

	/** The local mirror volume's write mode. */
	@io.swagger.annotations.ApiModelProperty(value ="The local mirror volume's write mode." , required = true)
	@XmlElement(required = true)
	private MirrorProxyWriteMode localWriteMode = MirrorProxyWriteMode.__UNDEFINED;

	/** @return The local mirror volume's write mode. */
	public MirrorProxyWriteMode getLocalWriteMode() {
		return this.localWriteMode;
	}
	/** @param x The local mirror volume's write mode. */
	public void setLocalWriteMode(MirrorProxyWriteMode x) {
		this.localWriteMode = x;
	}

	/** Indicates whether auto resynchronization is allowed. */
	@io.swagger.annotations.ApiModelProperty(value ="Indicates whether auto resynchronization is allowed." , required = true)
	@XmlElement(required = true)
	private boolean autoResync;

	/** @return Indicates whether auto resynchronization is allowed. */
	public boolean isAutoResync() {
		return this.autoResync;
	}
	/** @param x Indicates whether auto resynchronization is allowed. */
	public void setAutoResync(boolean x) {
		this.autoResync = x;
	}

	/** The write consistency group reference. */
	@io.swagger.annotations.ApiModelProperty(value ="The write consistency group reference." , required = true)
	@XmlElement(required = true)
	private String consistencyGroupRef;

	/** @return The write consistency group reference. */
	public String getConsistencyGroupRef() {
		return this.consistencyGroupRef;
	}
	/** @param x The write consistency group reference. */
	public void setConsistencyGroupRef(String x) {
		this.consistencyGroupRef = x;
	}
}
