package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** This structure is used to contain information about each volume that is a valid candidate for mirroring on the remote array. */
@SuppressWarnings("serial")
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(445)
public class MirrorVolumeCandidate implements Serializable {
	public MirrorVolumeCandidate() {
	}

	/** The WWN of the remote volume. */
	@io.swagger.annotations.ApiModelProperty(value ="The WWN of the remote volume." , required = true)
	@XmlElement(required = true)
	private String remoteVolWWN;

	/** @return The WWN of the remote volume. */
	public String getRemoteVolWWN() {
		return this.remoteVolWWN;
	}
	/** @param x The WWN of the remote volume. */
	public void setRemoteVolWWN(String x) {
		this.remoteVolWWN = x;
	}

	/** The user assigned label of the remote volume. */
	@io.swagger.annotations.ApiModelProperty(value ="The user assigned label of the remote volume." , required = true)
	@XmlElement(required = true)
	private String remoteVolLabel;

	/** @return The user assigned label of the remote volume. */
	public String getRemoteVolLabel() {
		return this.remoteVolLabel;
	}
	/** @param x The user assigned label of the remote volume. */
	public void setRemoteVolLabel(String x) {
		this.remoteVolLabel = x;
	}

	/** The capacity of the remote volume. */
	@io.swagger.annotations.ApiModelProperty(value ="The capacity of the remote volume." , required = true)
	@XmlElement(required = true)
	private long capacity;

	/** @return The capacity of the remote volume. */
	public long getCapacity() {
		return this.capacity;
	}
	/** @param x The capacity of the remote volume. */
	public void setCapacity(long x) {
		this.capacity = x;
	}

	/** The RAID level of the remote volume. */
	@io.swagger.annotations.ApiModelProperty(value ="The RAID level of the remote volume." , required = true)
	@XmlElement(required = true)
	private RAIDLevel raidLevel = RAIDLevel.__UNDEFINED;

	/** @return The RAID level of the remote volume. */
	public RAIDLevel getRaidLevel() {
		return this.raidLevel;
	}
	/** @param x The RAID level of the remote volume. */
	public void setRaidLevel(RAIDLevel x) {
		this.raidLevel = x;
	}

	/** The protection type of the mirror volume candidate. */
	@io.swagger.annotations.ApiModelProperty(value ="The protection type of the mirror volume candidate." , required = true)
	@XmlElement(required = true)
	private ProtectionType protectionType = ProtectionType.__UNDEFINED;

	/** @return The protection type of the mirror volume candidate. */
	public ProtectionType getProtectionType() {
		return this.protectionType;
	}
	/** @param x The protection type of the mirror volume candidate. */
	public void setProtectionType(ProtectionType x) {
		this.protectionType = x;
	}
}
