package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** This structure is used to specify attributes for creation of a PITView. */
@SuppressWarnings("serial")
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(1167)
public class PITViewCreationDescriptor implements Serializable {
	public PITViewCreationDescriptor() {
	}

	/** A reference to the base PiT. */
	@io.swagger.annotations.ApiModelProperty(value ="A reference to the base PiT." , required = true)
	@XmlElement(required = true)
	private String basePIT;

	/** @return A reference to the base PiT. */
	public String getBasePIT() {
		return this.basePIT;
	}
	/** @param x A reference to the base PiT. */
	public void setBasePIT(String x) {
		this.basePIT = x;
	}

	/** The name of the view. */
	@io.swagger.annotations.ApiModelProperty(value ="The name of the view." , required = true)
	@XmlElement(required = true)
	private String viewLabel;

	/** @return The name of the view. */
	public String getViewLabel() {
		return this.viewLabel;
	}
	/** @param x The name of the view. */
	public void setViewLabel(String x) {
		this.viewLabel = x;
	}

	/** The copy-on-write repository for this view. */
	@io.swagger.annotations.ApiModelProperty(value ="The copy-on-write repository for this view." , required = true)
	@XmlElement(required = true)
	private PITViewRepositoryCreationDescriptor repositoryDescriptor;

	/** @return The copy-on-write repository for this view. */
	public PITViewRepositoryCreationDescriptor getRepositoryDescriptor() {
		return this.repositoryDescriptor;
	}
	/** @param x The copy-on-write repository for this view. */
	public void setRepositoryDescriptor(PITViewRepositoryCreationDescriptor x) {
		this.repositoryDescriptor = x;
	}

	/** The repository utilization warning threshold percentage. */
	@io.swagger.annotations.ApiModelProperty(value ="The repository utilization warning threshold percentage." , required = true)
	@XmlElement(required = true)
	private int fullWarnThreshold;

	/** @return The repository utilization warning threshold percentage. */
	public int getFullWarnThreshold() {
		return this.fullWarnThreshold;
	}
	/** @param x The repository utilization warning threshold percentage. */
	public void setFullWarnThreshold(int x) {
		this.fullWarnThreshold = x;
	}
}
