package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** This structure is used to specify deletion of a view. */
@SuppressWarnings("serial")
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(1094)
public class PITViewDeletionDescriptor implements Serializable {
	public PITViewDeletionDescriptor() {
	}

	/** The view to delete. */
	@io.swagger.annotations.ApiModelProperty(value ="The view to delete." , required = true)
	@XmlElement(required = true)
	private String viewRef;

	/** @return The view to delete. */
	public String getViewRef() {
		return this.viewRef;
	}
	/** @param x The view to delete. */
	public void setViewRef(String x) {
		this.viewRef = x;
	}

	/** A flag used to indicate whether the member volumes of the associated repository should be retained or removed as part of the deletion. */
	@io.swagger.annotations.ApiModelProperty(value ="A flag used to indicate whether the member volumes of the associated repository should be retained or removed as part of the deletion." , required = true)
	@XmlElement(required = true)
	private boolean retainRepositoryMembers;

	/** @return A flag used to indicate whether the member volumes of the associated repository should be retained or removed as part of the deletion. */
	public boolean isRetainRepositoryMembers() {
		return this.retainRepositoryMembers;
	}
	/** @param x A flag used to indicate whether the member volumes of the associated repository should be retained or removed as part of the deletion. */
	public void setRetainRepositoryMembers(boolean x) {
		this.retainRepositoryMembers = x;
	}
}
