package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** This structure is used to contain information about the persistent registrations associated with a volume. */
@SuppressWarnings("serial")
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(1113)
public class PRegistration implements Serializable {
	public PRegistration() {
	}

	/** The volume identifier */
	@io.swagger.annotations.ApiModelProperty(value ="The volume identifier" , required = true)
	@XmlElement(required = true)
	private String volumeRef;

	/** @return The volume identifier */
	public String getVolumeRef() {
		return this.volumeRef;
	}
	/** @param x The volume identifier */
	public void setVolumeRef(String x) {
		this.volumeRef = x;
	}

	/** LUN (mapped) */
	@io.swagger.annotations.ApiModelProperty(value ="LUN (mapped)" , required = true)
	@XmlElement(required = true)
	private int lun;

	/** @return LUN (mapped) */
	public int getLun() {
		return this.lun;
	}
	/** @param x LUN (mapped) */
	public void setLun(int x) {
		this.lun = x;
	}

	/** Reservation Type */
	@io.swagger.annotations.ApiModelProperty(value ="Reservation Type" , required = true)
	@XmlElement(required = true)
	private ReservationTypeID reservationTypeID = ReservationTypeID.__UNDEFINED;

	/** @return Reservation Type */
	public ReservationTypeID getReservationTypeID() {
		return this.reservationTypeID;
	}
	/** @param x Reservation Type */
	public void setReservationTypeID(ReservationTypeID x) {
		this.reservationTypeID = x;
	}

	/** List of registrants */
	@io.swagger.annotations.ApiModelProperty(value ="List of registrants" , required = true)
	@XmlElement(required = true)
	private PRegistrantList registrantList;

	/** @return List of registrants */
	public PRegistrantList getRegistrantList() {
		return this.registrantList;
	}
	/** @param x List of registrants */
	public void setRegistrantList(PRegistrantList x) {
		this.registrantList = x;
	}

	/** Invalid if Type = ALL_REG */
	@io.swagger.annotations.ApiModelProperty(value ="Invalid if Type = ALL_REG" , required = true)
	@XmlElement(required = true)
	private ITNexus holdingITNexus;

	/** @return Invalid if Type = ALL_REG */
	public ITNexus getHoldingITNexus() {
		return this.holdingITNexus;
	}
	/** @param x Invalid if Type = ALL_REG */
	public void setHoldingITNexus(ITNexus x) {
		this.holdingITNexus = x;
	}

	/** Persist through power loss */
	@io.swagger.annotations.ApiModelProperty(value ="Persist through power loss" , required = true)
	@XmlElement(required = true)
	private boolean ptpl_A;

	/** @return Persist through power loss */
	public boolean isPtpl_A() {
		return this.ptpl_A;
	}
	/** @param x Persist through power loss */
	public void setPtpl_A(boolean x) {
		this.ptpl_A = x;
	}
}
