package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** This enumeration object is used to indicate the physical type of an I/O interface, in contrast to the logical protocol used by the interface (iSCSI is a logical protocol; Ethernet is a physical interface). */
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(147)
public enum PhysicalInterfaceType implements Serializable {
		/** The type of the physical interface is unknown. */
		unknown(0),
		/** The type of the physical interface is Ethernet. */
		ethernet(1),
		/** The type of the physical interface is Infiniband. */
		infiniband(2),
		__UNDEFINED(464378545);

		public final int value;

		private PhysicalInterfaceType(int v) {
			this.value = v;
		}
}
