package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** This structure allows functions to return a list of references and a status. */
@SuppressWarnings("serial")
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(596)
public class ReturnCodeWithRefList implements Serializable {
	public ReturnCodeWithRefList() {
	}

	/** An enumeration used to determine the return status of a SYMbol function call. */
	@io.swagger.annotations.ApiModelProperty(value ="An enumeration used to determine the return status of a SYMbol function call." , required = true)
	@XmlElement(required = true)
	private ReturnCode returnCode = ReturnCode.__UNDEFINED;

	/** @return An enumeration used to determine the return status of a SYMbol function call. */
	public ReturnCode getReturnCode() {
		return this.returnCode;
	}
	/** @param x An enumeration used to determine the return status of a SYMbol function call. */
	public void setReturnCode(ReturnCode x) {
		this.returnCode = x;
	}

	/** This field is present only if returnCode is equal to RETCODE_OK. It is a variable length array of references. */
	@io.swagger.annotations.ApiModelProperty(value ="This field is present only if returnCode is equal to RETCODE_OK. It is a variable length array of references." , required = false)
	@XmlElement(required = false)
	private String[] refList;

	/** @return This field is present only if returnCode is equal to RETCODE_OK. It is a variable length array of references. */
	public String[] getRefList() {
		return this.refList;
	}
	/** @param x This field is present only if returnCode is equal to RETCODE_OK. It is a variable length array of references. */
	public void setRefList(String[] x) {
		this.refList = x;
	}
}
