package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** This structure is used as an argument when updating the storage array's caching parameters. Note that these parameters apply to all volumes. Volume-specific caching parameters are handled separately. */
@SuppressWarnings("serial")
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(284)
public class SACacheParamsUpdateDescriptor implements Serializable {
	public SACacheParamsUpdateDescriptor() {
	}

	/** The size (in bytes) used for each entry in the controller's data cache. If volumes already exist in the array, the new cache block size must smaller than the smallest segment size currently defined for any volume. Furthermore, only two block sizes are currently supported: 4KB and 16KB. */
	@io.swagger.annotations.ApiModelProperty(value ="The size (in bytes) used for each entry in the controller's data cache. If volumes already exist in the array, the new cache block size must smaller than the smallest segment size currently defined for any volume. Furthermore, only two block sizes are currently supported: 4KB and 16KB." , required = true)
	@XmlElement(required = true)
	private int cacheBlkSize;

	/** @return The size (in bytes) used for each entry in the controller's data cache. If volumes already exist in the array, the new cache block size must smaller than the smallest segment size currently defined for any volume. Furthermore, only two block sizes are currently supported: 4KB and 16KB. */
	public int getCacheBlkSize() {
		return this.cacheBlkSize;
	}
	/** @param x The size (in bytes) used for each entry in the controller's data cache. If volumes already exist in the array, the new cache block size must smaller than the smallest segment size currently defined for any volume. Furthermore, only two block sizes are currently supported: 4KB and 16KB. */
	public void setCacheBlkSize(int x) {
		this.cacheBlkSize = x;
	}

	/** Specifies the amount of cache data that will be flushed to disk when a cache flush operation is initiated. This value is specified as an integer in the range 0-100 that represents the percentage of the controller's write cache data that can remain in the "dirty", or unflushed state. When demand flush operations are started, data will be flushed from cache to disk until the overall amount of dirty data drops to or below the percentage specified by this value. */
	@io.swagger.annotations.ApiModelProperty(value ="Specifies the amount of cache data that will be flushed to disk when a cache flush operation is initiated. This value is specified as an integer in the range 0-100 that represents the percentage of the controller's write cache data that can remain in the \"dirty\", or unflushed state. When demand flush operations are started, data will be flushed from cache to disk until the overall amount of dirty data drops to or below the percentage specified by this value." , required = true)
	@XmlElement(required = true)
	private int demandFlushAmount;

	/** @return Specifies the amount of cache data that will be flushed to disk when a cache flush operation is initiated. This value is specified as an integer in the range 0-100 that represents the percentage of the controller's write cache data that can remain in the "dirty", or unflushed state. When demand flush operations are started, data will be flushed from cache to disk until the overall amount of dirty data drops to or below the percentage specified by this value. */
	public int getDemandFlushAmount() {
		return this.demandFlushAmount;
	}
	/** @param x Specifies the amount of cache data that will be flushed to disk when a cache flush operation is initiated. This value is specified as an integer in the range 0-100 that represents the percentage of the controller's write cache data that can remain in the "dirty", or unflushed state. When demand flush operations are started, data will be flushed from cache to disk until the overall amount of dirty data drops to or below the percentage specified by this value. */
	public void setDemandFlushAmount(int x) {
		this.demandFlushAmount = x;
	}

	/** Specifies the "level of fullness" of "dirty" data in the controller's write cache which, when reached, will cause the controller to begin flushing data from cache to disk. This value is specified as a percentage, in the range 0-100, of the overall write cache capacity of the controller. After flushing begins, it will continue until enough data has been flushed to drop the percentage of dirty data to or below the value specified in the demandFlushAmount parameter described above. */
	@io.swagger.annotations.ApiModelProperty(value ="Specifies the \"level of fullness\" of \"dirty\" data in the controller's write cache which, when reached, will cause the controller to begin flushing data from cache to disk. This value is specified as a percentage, in the range 0-100, of the overall write cache capacity of the controller. After flushing begins, it will continue until enough data has been flushed to drop the percentage of dirty data to or below the value specified in the demandFlushAmount parameter described above." , required = true)
	@XmlElement(required = true)
	private int demandFlushThreshold;

	/** @return Specifies the "level of fullness" of "dirty" data in the controller's write cache which, when reached, will cause the controller to begin flushing data from cache to disk. This value is specified as a percentage, in the range 0-100, of the overall write cache capacity of the controller. After flushing begins, it will continue until enough data has been flushed to drop the percentage of dirty data to or below the value specified in the demandFlushAmount parameter described above. */
	public int getDemandFlushThreshold() {
		return this.demandFlushThreshold;
	}
	/** @param x Specifies the "level of fullness" of "dirty" data in the controller's write cache which, when reached, will cause the controller to begin flushing data from cache to disk. This value is specified as a percentage, in the range 0-100, of the overall write cache capacity of the controller. After flushing begins, it will continue until enough data has been flushed to drop the percentage of dirty data to or below the value specified in the demandFlushAmount parameter described above. */
	public void setDemandFlushThreshold(int x) {
		this.demandFlushThreshold = x;
	}
}
