package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** This structure represents a world-wide unique identifier for a storage array. */
@SuppressWarnings("serial")
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(313)
public class SAIdentifier implements Serializable {
	public SAIdentifier() {
	}

	/** A variable-length, opaque byte array whose value is guaranteed to be globally unique, and thus serves as the unique identifier for the storage array. No assumptions may be made outside the controller firmware environment about the meaning of the various bytes within this array. The only operation that a SYMbol client is allowed to perform on this field is a comparison for equality with the same field of a different storage array object. */
	@io.swagger.annotations.ApiModelProperty(value ="A variable-length, opaque byte array whose value is guaranteed to be globally unique, and thus serves as the unique identifier for the storage array. No assumptions may be made outside the controller firmware environment about the meaning of the various bytes within this array. The only operation that a SYMbol client is allowed to perform on this field is a comparison for equality with the same field of a different storage array object." , required = true)
	@XmlElement(required = true)
	private String worldWideName;

	/** @return A variable-length, opaque byte array whose value is guaranteed to be globally unique, and thus serves as the unique identifier for the storage array. No assumptions may be made outside the controller firmware environment about the meaning of the various bytes within this array. The only operation that a SYMbol client is allowed to perform on this field is a comparison for equality with the same field of a different storage array object. */
	public String getWorldWideName() {
		return this.worldWideName;
	}
	/** @param x A variable-length, opaque byte array whose value is guaranteed to be globally unique, and thus serves as the unique identifier for the storage array. No assumptions may be made outside the controller firmware environment about the meaning of the various bytes within this array. The only operation that a SYMbol client is allowed to perform on this field is a comparison for equality with the same field of a different storage array object. */
	public void setWorldWideName(String x) {
		this.worldWideName = x;
	}
}
