package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** This structure contains the digest and salt values for a view array password. */
@SuppressWarnings("serial")
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(341)
public class SAViewPasswordDigest implements Serializable {
	public SAViewPasswordDigest() {
	}

	/** SHA-1 message digest value of the salt and view array password. */
	@io.swagger.annotations.ApiModelProperty(value ="SHA-1 message digest value of the salt and view array password." , required = true)
	@XmlElement(required = true)
	private String digest;

	/** @return SHA-1 message digest value of the salt and view array password. */
	public String getDigest() {
		return this.digest;
	}
	/** @param x SHA-1 message digest value of the salt and view array password. */
	public void setDigest(String x) {
		this.digest = x;
	}

	/** Salt value used to mix with the view array password for generating the digest. */
	@io.swagger.annotations.ApiModelProperty(value ="Salt value used to mix with the view array password for generating the digest." , required = true)
	@XmlElement(required = true)
	private String salt;

	/** @return Salt value used to mix with the view array password for generating the digest. */
	public String getSalt() {
		return this.salt;
	}
	/** @param x Salt value used to mix with the view array password for generating the digest. */
	public void setSalt(String x) {
		this.salt = x;
	}
}
