package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** This structure contains SNMP-related items in the ObjectBundle. */
@SuppressWarnings("serial")
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(1019)
public class SNMPAgentBundle implements Serializable {
	public SNMPAgentBundle() {
	}

	/** All configured SNMP communities */
	@io.swagger.annotations.ApiModelProperty(value ="All configured SNMP communities" , required = true)
	@XmlElement(required = true)
	private SNMPCommunity[] community;

	/** @return All configured SNMP communities */
	public SNMPCommunity[] getCommunity() {
		return this.community;
	}
	/** @param x All configured SNMP communities */
	public void setCommunity(SNMPCommunity[] x) {
		this.community = x;
	}

	/** SNMP Trap Destinations. Traps will be delivered to these destinations when an alertable MEL event is generated. */
	@io.swagger.annotations.ApiModelProperty(value ="SNMP Trap Destinations. Traps will be delivered to these destinations when an alertable MEL event is generated." , required = true)
	@XmlElement(required = true)
	private SNMPTrapDestination[] trapDestination;

	/** @return SNMP Trap Destinations. Traps will be delivered to these destinations when an alertable MEL event is generated. */
	public SNMPTrapDestination[] getTrapDestination() {
		return this.trapDestination;
	}
	/** @param x SNMP Trap Destinations. Traps will be delivered to these destinations when an alertable MEL event is generated. */
	public void setTrapDestination(SNMPTrapDestination[] x) {
		this.trapDestination = x;
	}

	/** Current settings for SNMP "system" variables */
	@io.swagger.annotations.ApiModelProperty(value ="Current settings for SNMP \"system\" variables" , required = true)
	@XmlElement(required = true)
	private SNMPSystemVariables systemVariables;

	/** @return Current settings for SNMP "system" variables */
	public SNMPSystemVariables getSystemVariables() {
		return this.systemVariables;
	}
	/** @param x Current settings for SNMP "system" variables */
	public void setSystemVariables(SNMPSystemVariables x) {
		this.systemVariables = x;
	}
}
