package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** This structure is used to describe the percentage of wear life remaining in the SSD drive. */
@SuppressWarnings("serial")
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(354)
public class SSDWearLife implements Serializable {
	public SSDWearLife() {
	}

	/** The percentage of average erase count. */
	@io.swagger.annotations.ApiModelProperty(value ="The percentage of average erase count." , required = true)
	@XmlElement(required = true)
	private int averageEraseCountPercent;

	/** @return The percentage of average erase count. */
	public int getAverageEraseCountPercent() {
		return this.averageEraseCountPercent;
	}
	/** @param x The percentage of average erase count. */
	public void setAverageEraseCountPercent(int x) {
		this.averageEraseCountPercent = x;
	}

	/** The percentage of spare blocks remaining in the solid state drive. Controller firmware checks and updates this percentage approximately once per hour. */
	@io.swagger.annotations.ApiModelProperty(value ="The percentage of spare blocks remaining in the solid state drive. Controller firmware checks and updates this percentage approximately once per hour." , required = true)
	@XmlElement(required = true)
	private int spareBlocksRemainingPercent;

	/** @return The percentage of spare blocks remaining in the solid state drive. Controller firmware checks and updates this percentage approximately once per hour. */
	public int getSpareBlocksRemainingPercent() {
		return this.spareBlocksRemainingPercent;
	}
	/** @param x The percentage of spare blocks remaining in the solid state drive. Controller firmware checks and updates this percentage approximately once per hour. */
	public void setSpareBlocksRemainingPercent(int x) {
		this.spareBlocksRemainingPercent = x;
	}

	/** This field is set to true if wear life monitoring is supported on the drive. If true then the values in the other fields in this structure are valid, otherwise they are not valid. */
	@io.swagger.annotations.ApiModelProperty(value ="This field is set to true if wear life monitoring is supported on the drive. If true then the values in the other fields in this structure are valid, otherwise they are not valid." , required = true)
	@XmlElement(required = true)
	private boolean isWearLifeMonitoringSupported;

	/** @return This field is set to true if wear life monitoring is supported on the drive. If true then the values in the other fields in this structure are valid, otherwise they are not valid. */
	public boolean isIsWearLifeMonitoringSupported() {
		return this.isWearLifeMonitoringSupported;
	}
	/** @param x This field is set to true if wear life monitoring is supported on the drive. If true then the values in the other fields in this structure are valid, otherwise they are not valid. */
	public void setIsWearLifeMonitoringSupported(boolean x) {
		this.isWearLifeMonitoringSupported = x;
	}
}
