package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** This enumeration specifies the different kinds of devices that may be attached to a SAS port. */
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(218)
public enum SasAttachedDeviceType implements Serializable {
		/** The attached device is unknown or non-existent. */
		unknown(1),
		/** The attached device is a drive. */
		drive(2),
		/** The attached device is a SAS expander. */
		expander(3),
		/** The attached device is the local RAID controller. */
		localController(4),
		/** The attached device is the alternate RAID controller. */
		alternateController(5),
		/** The attached device is a host computer. */
		host(6),
		__UNDEFINED(464378545);

		public final int value;

		private SasAttachedDeviceType(int v) {
			this.value = v;
		}
}
