package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** This structure is a structure used to hold the SAS phy error counts. */
@SuppressWarnings("serial")
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(430)
public class SasPhyErrorCounts implements Serializable {
	public SasPhyErrorCounts() {
	}

	/** The number of invalid dwords that have been received outside of PHY reset sequences. */
	@io.swagger.annotations.ApiModelProperty(value ="The number of invalid dwords that have been received outside of PHY reset sequences." , required = true)
	@XmlElement(required = true)
	private int invalidDwordCount;

	/** @return The number of invalid dwords that have been received outside of PHY reset sequences. */
	public int getInvalidDwordCount() {
		return this.invalidDwordCount;
	}
	/** @param x The number of invalid dwords that have been received outside of PHY reset sequences. */
	public void setInvalidDwordCount(int x) {
		this.invalidDwordCount = x;
	}

	/** The number of dwords containing running disparity errors that have been received outside of PHY reset sequences. */
	@io.swagger.annotations.ApiModelProperty(value ="The number of dwords containing running disparity errors that have been received outside of PHY reset sequences." , required = true)
	@XmlElement(required = true)
	private int runningDisparityErrorCount;

	/** @return The number of dwords containing running disparity errors that have been received outside of PHY reset sequences. */
	public int getRunningDisparityErrorCount() {
		return this.runningDisparityErrorCount;
	}
	/** @param x The number of dwords containing running disparity errors that have been received outside of PHY reset sequences. */
	public void setRunningDisparityErrorCount(int x) {
		this.runningDisparityErrorCount = x;
	}

	/** The number of times the PHY has restarted the link reset sequence because it lost dword synchronization. */
	@io.swagger.annotations.ApiModelProperty(value ="The number of times the PHY has restarted the link reset sequence because it lost dword synchronization." , required = true)
	@XmlElement(required = true)
	private int lossOfDwordSyncCount;

	/** @return The number of times the PHY has restarted the link reset sequence because it lost dword synchronization. */
	public int getLossOfDwordSyncCount() {
		return this.lossOfDwordSyncCount;
	}
	/** @param x The number of times the PHY has restarted the link reset sequence because it lost dword synchronization. */
	public void setLossOfDwordSyncCount(int x) {
		this.lossOfDwordSyncCount = x;
	}

	/** The number of times the PHY did not receive dword synchronization during the final SAS speed negotiation window. */
	@io.swagger.annotations.ApiModelProperty(value ="The number of times the PHY did not receive dword synchronization during the final SAS speed negotiation window." , required = true)
	@XmlElement(required = true)
	private int resetProblemCount;

	/** @return The number of times the PHY did not receive dword synchronization during the final SAS speed negotiation window. */
	public int getResetProblemCount() {
		return this.resetProblemCount;
	}
	/** @param x The number of times the PHY did not receive dword synchronization during the final SAS speed negotiation window. */
	public void setResetProblemCount(int x) {
		this.resetProblemCount = x;
	}
}
