package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** This enumeration object is used to identify the specific type of "port provider" device. */
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(123)
public enum SasPortProviderDeviceType implements Serializable {
		/** The port provider device is a RAID controller. */
		controller(1),
		/** The port provider device is a drive. */
		drive(2),
		/** The port provider device is a SAS expander. */
		expander(3),
		/** The port provider device is a SAS host board. */
		hostboard(4),
		__UNDEFINED(464378545);

		public final int value;

		private SasPortProviderDeviceType(int v) {
			this.value = v;
		}
}
