package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** This union data type is used in responding to the getSasErrorStatistics procedure call. */
@SuppressWarnings("serial")
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(1135)
public class SasStatisticsReturned implements Serializable {
	public SasStatisticsReturned() {
	}

	/** An enumeration used to determine the return status of a SYMbol function call. */
	@io.swagger.annotations.ApiModelProperty(value ="An enumeration used to determine the return status of a SYMbol function call." , required = true)
	@XmlElement(required = true)
	private ReturnCode returnCode = ReturnCode.__UNDEFINED;

	/** @return An enumeration used to determine the return status of a SYMbol function call. */
	public ReturnCode getReturnCode() {
		return this.returnCode;
	}
	/** @param x An enumeration used to determine the return status of a SYMbol function call. */
	public void setReturnCode(ReturnCode x) {
		this.returnCode = x;
	}

	/** This field contains the SAS statistics. It is only valid if the returnCode field is equal to RETCODE_OK. */
	@io.swagger.annotations.ApiModelProperty(value ="This field contains the SAS statistics. It is only valid if the returnCode field is equal to RETCODE_OK." , required = false)
	@XmlElement(required = false)
	private SasStatistics sasStatistics;

	/** @return This field contains the SAS statistics. It is only valid if the returnCode field is equal to RETCODE_OK. */
	public SasStatistics getSasStatistics() {
		return this.sasStatistics;
	}
	/** @param x This field contains the SAS statistics. It is only valid if the returnCode field is equal to RETCODE_OK. */
	public void setSasStatistics(SasStatistics x) {
		this.sasStatistics = x;
	}
}
