package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** This structure describes drive properties that are unique to a SATA physical drive type: */
@SuppressWarnings("serial")
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(574)
public class SataDriveAttributes implements Serializable {
	public SataDriveAttributes() {
	}

	/** This field provides information about the SCSI-to-ATA translator hardware. */
	@io.swagger.annotations.ApiModelProperty(value ="This field provides information about the SCSI-to-ATA translator hardware." , required = true)
	@XmlElement(required = true)
	private ScsiToAtaTranslatorData translatorData;

	/** @return This field provides information about the SCSI-to-ATA translator hardware. */
	public ScsiToAtaTranslatorData getTranslatorData() {
		return this.translatorData;
	}
	/** @param x This field provides information about the SCSI-to-ATA translator hardware. */
	public void setTranslatorData(ScsiToAtaTranslatorData x) {
		this.translatorData = x;
	}

	/** This field is the disk model number as reported in the ATA protocol. */
	@io.swagger.annotations.ApiModelProperty(value ="This field is the disk model number as reported in the ATA protocol." , required = true)
	@XmlElement(required = true)
	private String ataDiskModelNumber;

	/** @return This field is the disk model number as reported in the ATA protocol. */
	public String getAtaDiskModelNumber() {
		return this.ataDiskModelNumber;
	}
	/** @param x This field is the disk model number as reported in the ATA protocol. */
	public void setAtaDiskModelNumber(String x) {
		this.ataDiskModelNumber = x;
	}

	/** This field is the disk firmware revision number as reported in the ATA protocol. */
	@io.swagger.annotations.ApiModelProperty(value ="This field is the disk firmware revision number as reported in the ATA protocol." , required = true)
	@XmlElement(required = true)
	private String ataDiskFwRevision;

	/** @return This field is the disk firmware revision number as reported in the ATA protocol. */
	public String getAtaDiskFwRevision() {
		return this.ataDiskFwRevision;
	}
	/** @param x This field is the disk firmware revision number as reported in the ATA protocol. */
	public void setAtaDiskFwRevision(String x) {
		this.ataDiskFwRevision = x;
	}
}
