package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** This union contains schedule information for a specified schedule method. */
@SuppressWarnings("serial")
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(656)
public class ScheduleCalendar implements Serializable {
	public ScheduleCalendar() {
	}

	/** This enumeration specifies the different types of scheduling methods. */
	@io.swagger.annotations.ApiModelProperty(value ="This enumeration specifies the different types of scheduling methods." , required = true)
	@XmlElement(required = true)
	private ScheduleMethod scheduleMethod = ScheduleMethod.__UNDEFINED;

	/** @return This enumeration specifies the different types of scheduling methods. */
	public ScheduleMethod getScheduleMethod() {
		return this.scheduleMethod;
	}
	/** @param x This enumeration specifies the different types of scheduling methods. */
	public void setScheduleMethod(ScheduleMethod x) {
		this.scheduleMethod = x;
	}

	/** This field is present only if scheduleMethod is equal to SCHEDULE_METHOD_DAILY. */
	@io.swagger.annotations.ApiModelProperty(value ="This field is present only if scheduleMethod is equal to SCHEDULE_METHOD_DAILY." , required = false)
	@XmlElement(required = false)
	private ScheduleDaily daily;

	/** @return This field is present only if scheduleMethod is equal to SCHEDULE_METHOD_DAILY. */
	public ScheduleDaily getDaily() {
		return this.daily;
	}
	/** @param x This field is present only if scheduleMethod is equal to SCHEDULE_METHOD_DAILY. */
	public void setDaily(ScheduleDaily x) {
		this.daily = x;
	}

	/** This field is present only if scheduleMethod is equal to SCHEDULE_METHOD_WEEKLY. */
	@io.swagger.annotations.ApiModelProperty(value ="This field is present only if scheduleMethod is equal to SCHEDULE_METHOD_WEEKLY." , required = false)
	@XmlElement(required = false)
	private ScheduleWeekly weekly;

	/** @return This field is present only if scheduleMethod is equal to SCHEDULE_METHOD_WEEKLY. */
	public ScheduleWeekly getWeekly() {
		return this.weekly;
	}
	/** @param x This field is present only if scheduleMethod is equal to SCHEDULE_METHOD_WEEKLY. */
	public void setWeekly(ScheduleWeekly x) {
		this.weekly = x;
	}

	/** This field is present only if scheduleMethod is equal to SCHEDULE_METHOD_MONTHLY_DATE. */
	@io.swagger.annotations.ApiModelProperty(value ="This field is present only if scheduleMethod is equal to SCHEDULE_METHOD_MONTHLY_DATE." , required = false)
	@XmlElement(required = false)
	private ScheduleMonthlyByDate monthlyByDate;

	/** @return This field is present only if scheduleMethod is equal to SCHEDULE_METHOD_MONTHLY_DATE. */
	public ScheduleMonthlyByDate getMonthlyByDate() {
		return this.monthlyByDate;
	}
	/** @param x This field is present only if scheduleMethod is equal to SCHEDULE_METHOD_MONTHLY_DATE. */
	public void setMonthlyByDate(ScheduleMonthlyByDate x) {
		this.monthlyByDate = x;
	}

	/** This field is present only if scheduleMethod is equal to SCHEDULE_METHOD_MONTHLY_DAY. */
	@io.swagger.annotations.ApiModelProperty(value ="This field is present only if scheduleMethod is equal to SCHEDULE_METHOD_MONTHLY_DAY." , required = false)
	@XmlElement(required = false)
	private ScheduleMonthlyByDay monthlyByDay;

	/** @return This field is present only if scheduleMethod is equal to SCHEDULE_METHOD_MONTHLY_DAY. */
	public ScheduleMonthlyByDay getMonthlyByDay() {
		return this.monthlyByDay;
	}
	/** @param x This field is present only if scheduleMethod is equal to SCHEDULE_METHOD_MONTHLY_DAY. */
	public void setMonthlyByDay(ScheduleMonthlyByDay x) {
		this.monthlyByDay = x;
	}
}
