package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** This enumeration specifies the different types of scheduling methods. */
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(181)
public enum ScheduleMethod implements Serializable {
		/** This should never happen. */
		unknown(0),
		/** This specifies a daily schedule. */
		daily(1),
		/** This specifies a weekly schedule. */
		weekly(2),
		/** This specifies a monthly date-based schedule. */
		monthlyDate(3),
		/** This specifies a monthly day-of-week-based schedule. */
		monthlyDay(4),
		__UNDEFINED(464378545);

		public final int value;

		private ScheduleMethod(int v) {
			this.value = v;
		}
}
