package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** This union data type represents a SCSI alias name. It is presently only defined for iSCSI. */
@SuppressWarnings("serial")
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(401)
public class ScsiAlias implements Serializable {
	public ScsiAlias() {
	}

	/** This enumeration defines the different I/O interface types that may be reported as part of the configuration information associated with a controller. */
	@io.swagger.annotations.ApiModelProperty(value ="This enumeration defines the different I/O interface types that may be reported as part of the configuration information associated with a controller." , required = true)
	@XmlElement(required = true)
	private IOInterfaceType ioInterfaceType = IOInterfaceType.__UNDEFINED;

	/** @return This enumeration defines the different I/O interface types that may be reported as part of the configuration information associated with a controller. */
	public IOInterfaceType getIoInterfaceType() {
		return this.ioInterfaceType;
	}
	/** @param x This enumeration defines the different I/O interface types that may be reported as part of the configuration information associated with a controller. */
	public void setIoInterfaceType(IOInterfaceType x) {
		this.ioInterfaceType = x;
	}

	/** The SCSI alias name as defined under iSCSI. This field is only valid if the I/O interface type is equal to IO_IF_ISCSI. */
	@io.swagger.annotations.ApiModelProperty(value ="The SCSI alias name as defined under iSCSI. This field is only valid if the I/O interface type is equal to IO_IF_ISCSI." , required = false)
	@XmlElement(required = false)
	private String iscsiAlias;

	/** @return The SCSI alias name as defined under iSCSI. This field is only valid if the I/O interface type is equal to IO_IF_ISCSI. */
	public String getIscsiAlias() {
		return this.iscsiAlias;
	}
	/** @param x The SCSI alias name as defined under iSCSI. This field is only valid if the I/O interface type is equal to IO_IF_ISCSI. */
	public void setIscsiAlias(String x) {
		this.iscsiAlias = x;
	}
}
