package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** This object is used to convey failure information associated with the REC_SECURITY_GET_KEY condition. The structure returns a list of locked down drives and the lockKeyIDRef of the lock key needed to unlock them. */
@SuppressWarnings("serial")
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(702)
public class SecurityKeyNeeded implements Serializable {
	public SecurityKeyNeeded() {
	}

	/** This is a reference to the lock key needed for the set of locked drives referenced in the drives field. */
	@io.swagger.annotations.ApiModelProperty(value ="This is a reference to the lock key needed for the set of locked drives referenced in the drives field." , required = true)
	@XmlElement(required = true)
	private String lockKeyIDRef;

	/** @return This is a reference to the lock key needed for the set of locked drives referenced in the drives field. */
	public String getLockKeyIDRef() {
		return this.lockKeyIDRef;
	}
	/** @param x This is a reference to the lock key needed for the set of locked drives referenced in the drives field. */
	public void setLockKeyIDRef(String x) {
		this.lockKeyIDRef = x;
	}
}
