package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** This structure is designed to model the critical aspects of a SFP component. */
@SuppressWarnings("serial")
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(780)
public class Sfp implements Serializable,devmgr.api.model.Identifiable {
	public Sfp() {
	}

	/** The reference for this physical SFP. */
	@io.swagger.annotations.ApiModelProperty(value ="The reference for this physical SFP." , required = true)
	@XmlElement(required = true)
	private String sfpRef;

	/** @return The reference for this physical SFP. */
	public String getSfpRef() {
		return this.sfpRef;
	}
	/** @param x The reference for this physical SFP. */
	public void setSfpRef(String x) {
		this.sfpRef = x;
	}

	/** The operational status of the SFP. */
	@io.swagger.annotations.ApiModelProperty(value ="The operational status of the SFP." , required = true)
	@XmlElement(required = true)
	private SFPStatus status = SFPStatus.__UNDEFINED;

	/** @return The operational status of the SFP. */
	public SFPStatus getStatus() {
		return this.status;
	}
	/** @param x The operational status of the SFP. */
	public void setStatus(SFPStatus x) {
		this.status = x;
	}

	/** The physical location of the SFP. */
	@io.swagger.annotations.ApiModelProperty(value ="The physical location of the SFP." , required = true)
	@XmlElement(required = true)
	private Location physicalLocation;

	/** @return The physical location of the SFP. */
	public Location getPhysicalLocation() {
		return this.physicalLocation;
	}
	/** @param x The physical location of the SFP. */
	public void setPhysicalLocation(Location x) {
		this.physicalLocation = x;
	}

	/** The type of the SFP. */
	@io.swagger.annotations.ApiModelProperty(value ="The type of the SFP." , required = true)
	@XmlElement(required = true)
	private SFPType sfpType;

	/** @return The type of the SFP. */
	public SFPType getSfpType() {
		return this.sfpType;
	}
	/** @param x The type of the SFP. */
	public void setSfpType(SFPType x) {
		this.sfpType = x;
	}

	/** The port that the SFP is associated with. */
	@io.swagger.annotations.ApiModelProperty(value ="The port that the SFP is associated with." , required = true)
	@XmlElement(required = true)
	private SFPPort sfpPort = SFPPort.__UNDEFINED;

	/** @return The port that the SFP is associated with. */
	public SFPPort getSfpPort() {
		return this.sfpPort;
	}
	/** @param x The port that the SFP is associated with. */
	public void setSfpPort(SFPPort x) {
		this.sfpPort = x;
	}

	/** Data specific to SFP parent type. */
	@io.swagger.annotations.ApiModelProperty(value ="Data specific to SFP parent type." , required = true)
	@XmlElement(required = true)
	private SFPParentTypeData parentData;

	/** @return Data specific to SFP parent type. */
	public SFPParentTypeData getParentData() {
		return this.parentData;
	}
	/** @param x Data specific to SFP parent type. */
	public void setParentData(SFPParentTypeData x) {
		this.parentData = x;
	}

	/** Reserved. */
	@XmlTransient
	private String reserved1;

	/** @return Reserved. */
	public String getReserved1() {
		return this.reserved1;
	}
	/** @param x Reserved. */
	public void setReserved1(String x) {
		this.reserved1 = x;
	}

	/** Reserved. */
	@XmlTransient
	private String reserved2;

	/** @return Reserved. */
	public String getReserved2() {
		return this.reserved2;
	}
	/** @param x Reserved. */
	public void setReserved2(String x) {
		this.reserved2 = x;
	}

	/** A reference identifying the channel port that the SFP is plugged into. */
	@io.swagger.annotations.ApiModelProperty(value ="A reference identifying the channel port that the SFP is plugged into." , required = true)
	@XmlElement(required = true)
	private String sfpPortRef;

	/** @return A reference identifying the channel port that the SFP is plugged into. */
	public String getSfpPortRef() {
		return this.sfpPortRef;
	}
	/** @param x A reference identifying the channel port that the SFP is plugged into. */
	public void setSfpPortRef(String x) {
		this.sfpPortRef = x;
	}

	/** The repair policy for the SFP component. */
	@io.swagger.annotations.ApiModelProperty(value ="The repair policy for the SFP component." , required = true)
	@XmlElement(required = true)
	private RepairPolicy repairPolicy;

	/** @return The repair policy for the SFP component. */
	public RepairPolicy getRepairPolicy() {
		return this.repairPolicy;
	}
	/** @param x The repair policy for the SFP component. */
	public void setRepairPolicy(RepairPolicy x) {
		this.repairPolicy = x;
	}
	@Override
	public String getId(){
		return sfpRef;
	}
}
