package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** This structure contains both global and port-dependent information for a particular SOC device. */
@SuppressWarnings("serial")
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(1112)
public class SocData implements Serializable {
	public SocData() {
	}

	/** Set to true if the information in this structure is valid. */
	@io.swagger.annotations.ApiModelProperty(value ="Set to true if the information in this structure is valid." , required = true)
	@XmlElement(required = true)
	private boolean valid;

	/** @return Set to true if the information in this structure is valid. */
	public boolean isValid() {
		return this.valid;
	}
	/** @param x Set to true if the information in this structure is valid. */
	public void setValid(boolean x) {
		this.valid = x;
	}

	/** Port-independent data about the SOC device. */
	@io.swagger.annotations.ApiModelProperty(value ="Port-independent data about the SOC device." , required = true)
	@XmlElement(required = true)
	private SocDeviceData socDeviceData;

	/** @return Port-independent data about the SOC device. */
	public SocDeviceData getSocDeviceData() {
		return this.socDeviceData;
	}
	/** @param x Port-independent data about the SOC device. */
	public void setSocDeviceData(SocDeviceData x) {
		this.socDeviceData = x;
	}

	/** An array in which each element (one per port) contains port-dependent SOC device data. */
	@io.swagger.annotations.ApiModelProperty(value ="An array in which each element (one per port) contains port-dependent SOC device data." , required = true)
	@XmlElement(required = true)
	private SocPortData[] socPortData;

	/** @return An array in which each element (one per port) contains port-dependent SOC device data. */
	public SocPortData[] getSocPortData() {
		return this.socPortData;
	}
	/** @param x An array in which each element (one per port) contains port-dependent SOC device data. */
	public void setSocPortData(SocPortData[] x) {
		this.socPortData = x;
	}
}
