package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** This enumeration is used to determine the status of a thermal sensor component. */
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(76)
public enum ThermalSensorStatus implements Serializable {
		/** The thermal sensor is working correctly. */
		optimal(1),
		/** The thermal sensor nominal temperature has been exceeded. */
		nominalTempExceed(2),
		/** The thermal sensor maximum temperature has been exceeded. */
		maxTempExceed(3),
		/** The thermal sensor has been removed or is missing. */
		removed(4),
		/** The status of the thermal sensor is unknown. */
		unknown(5),
		__UNDEFINED(464378545);

		public final int value;

		private ThermalSensorStatus(int v) {
			this.value = v;
		}
}
