package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** This union is used when retrieving a thin volume's consumed capacity. */
@SuppressWarnings("serial")
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(1038)
public class ThinVolumeConsumedCapacityReturned implements Serializable {
	public ThinVolumeConsumedCapacityReturned() {
	}

	/** An enumeration used to determine the return status of a SYMbol function call. */
	@io.swagger.annotations.ApiModelProperty(value ="An enumeration used to determine the return status of a SYMbol function call." , required = true)
	@XmlElement(required = true)
	private ReturnCode returnCode = ReturnCode.__UNDEFINED;

	/** @return An enumeration used to determine the return status of a SYMbol function call. */
	public ReturnCode getReturnCode() {
		return this.returnCode;
	}
	/** @param x An enumeration used to determine the return status of a SYMbol function call. */
	public void setReturnCode(ReturnCode x) {
		this.returnCode = x;
	}

	/** The consumed capacity of the thin volume. This field is present only if the value of returnCode is equal to RETCODE_OK. */
	@io.swagger.annotations.ApiModelProperty(value ="The consumed capacity of the thin volume. This field is present only if the value of returnCode is equal to RETCODE_OK." , required = false)
	@XmlElement(required = false)
	private ThinVolumeConsumedCapacity[] capacity;

	/** @return The consumed capacity of the thin volume. This field is present only if the value of returnCode is equal to RETCODE_OK. */
	public ThinVolumeConsumedCapacity[] getCapacity() {
		return this.capacity;
	}
	/** @param x The consumed capacity of the thin volume. This field is present only if the value of returnCode is equal to RETCODE_OK. */
	public void setCapacity(ThinVolumeConsumedCapacity[] x) {
		this.capacity = x;
	}
}
