package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** This structure is used as an argument to the setTrayAttributes procedure. It contains an indication of which enclosure tray the attribute data is for, plus the attribute data itself. */
@SuppressWarnings("serial")
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(657)
public class TrayAttributeUpdateDescriptor implements Serializable {
	public TrayAttributeUpdateDescriptor() {
	}

	/** The reference to the tray. */
	@io.swagger.annotations.ApiModelProperty(value ="The reference to the tray." , required = true)
	@XmlElement(required = true)
	private String trayRef;

	/** @return The reference to the tray. */
	public String getTrayRef() {
		return this.trayRef;
	}
	/** @param x The reference to the tray. */
	public void setTrayRef(String x) {
		this.trayRef = x;
	}

	/** A variable-length list of attribute data to write. */
	@io.swagger.annotations.ApiModelProperty(value ="A variable-length list of attribute data to write." , required = true)
	@XmlElement(required = true)
	private TrayAttribute[] trayAttributes;

	/** @return A variable-length list of attribute data to write. */
	public TrayAttribute[] getTrayAttributes() {
		return this.trayAttributes;
	}
	/** @param x A variable-length list of attribute data to write. */
	public void setTrayAttributes(TrayAttribute[] x) {
		this.trayAttributes = x;
	}
}
