package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** This enumeration is used to describe the type of unreadable sector record. */
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(120)
public enum UsmRecordType implements Serializable {
		/** The sector is physically unreadable. */
		physical(1),
		/** The sector is corrupted due to dynamic reconfiguration, reconstruction, etc. */
		logical(2),
		/** The sector is corrupted due to a test. */
		injected(3),
		/** The sector is considered bad because of an EDC error. */
		edcError(4),
		/** The sector is inconsistent with the data/parity redundancy. */
		inconsistent(5),
		/** The sector is considered bad due to a Protection Information error. */
		piError(6),
		__UNDEFINED(464378545);

		public final int value;

		private UsmRecordType(int v) {
			this.value = v;
		}
}
