package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** This structure is used to convey information about how a new volume-copy is to be created. */
@SuppressWarnings("serial")
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(979)
public class VolumeCopyParamsUpdateDescriptor implements Serializable {
	public VolumeCopyParamsUpdateDescriptor() {
	}

	/** The volume copy to be updated. */
	@io.swagger.annotations.ApiModelProperty(value ="The volume copy to be updated." , required = true)
	@XmlElement(required = true)
	private String volCopyRef;

	/** @return The volume copy to be updated. */
	public String getVolCopyRef() {
		return this.volCopyRef;
	}
	/** @param x The volume copy to be updated. */
	public void setVolCopyRef(String x) {
		this.volCopyRef = x;
	}

	/** Importance of copy operation. */
	@io.swagger.annotations.ApiModelProperty(value ="Importance of copy operation." , required = true)
	@XmlElement(required = true)
	private VolumeCopyPriority copyPriority = VolumeCopyPriority.__UNDEFINED;

	/** @return Importance of copy operation. */
	public VolumeCopyPriority getCopyPriority() {
		return this.copyPriority;
	}
	/** @param x Importance of copy operation. */
	public void setCopyPriority(VolumeCopyPriority x) {
		this.copyPriority = x;
	}

	/** Apply write protection to target volume when copy is idle (true/false). */
	@io.swagger.annotations.ApiModelProperty(value ="Apply write protection to target volume when copy is idle (true/false)." , required = true)
	@XmlElement(required = true)
	private boolean idleTargetWriteProt;

	/** @return Apply write protection to target volume when copy is idle (true/false). */
	public boolean isIdleTargetWriteProt() {
		return this.idleTargetWriteProt;
	}
	/** @param x Apply write protection to target volume when copy is idle (true/false). */
	public void setIdleTargetWriteProt(boolean x) {
		this.idleTargetWriteProt = x;
	}
}
