package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** This structure object describes a candidate drive set that may be used to expand a volume group. */
@SuppressWarnings("serial")
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(682)
public class VolumeGroupExpansionCandidate implements Serializable {
	public VolumeGroupExpansionCandidate() {
	}

	/** An array of references to drives comprising the set that can be used to expand the volume group. */
	@io.swagger.annotations.ApiModelProperty(value ="An array of references to drives comprising the set that can be used to expand the volume group." , required = true)
	@XmlElement(required = true)
	private String[] drives;

	/** @return An array of references to drives comprising the set that can be used to expand the volume group. */
	public String[] getDrives() {
		return this.drives;
	}
	/** @param x An array of references to drives comprising the set that can be used to expand the volume group. */
	public void setDrives(String[] x) {
		this.drives = x;
	}

	/** Set to true if the expanded volume group will have tray loss protection. */
	@io.swagger.annotations.ApiModelProperty(value ="Set to true if the expanded volume group will have tray loss protection." , required = true)
	@XmlElement(required = true)
	private boolean trayLossProtection;

	/** @return Set to true if the expanded volume group will have tray loss protection. */
	public boolean isTrayLossProtection() {
		return this.trayLossProtection;
	}
	/** @param x Set to true if the expanded volume group will have tray loss protection. */
	public void setTrayLossProtection(boolean x) {
		this.trayLossProtection = x;
	}

	/** The number of bytes of wasted capacity in the given drive set if is used to expand the volume. Wasting of capacity occurs when the drives in the set are larger than the drives in the volume group being expanded. */
	@io.swagger.annotations.ApiModelProperty(value ="The number of bytes of wasted capacity in the given drive set if is used to expand the volume. Wasting of capacity occurs when the drives in the set are larger than the drives in the volume group being expanded." , required = true)
	@XmlElement(required = true)
	private long wastedCapacity;

	/** @return The number of bytes of wasted capacity in the given drive set if is used to expand the volume. Wasting of capacity occurs when the drives in the set are larger than the drives in the volume group being expanded. */
	public long getWastedCapacity() {
		return this.wastedCapacity;
	}
	/** @param x The number of bytes of wasted capacity in the given drive set if is used to expand the volume. Wasting of capacity occurs when the drives in the set are larger than the drives in the volume group being expanded. */
	public void setWastedCapacity(long x) {
		this.wastedCapacity = x;
	}

	/** Set to true if the expanded volume group will have uniform spindle speed across its drives. */
	@io.swagger.annotations.ApiModelProperty(value ="Set to true if the expanded volume group will have uniform spindle speed across its drives." , required = true)
	@XmlElement(required = true)
	private boolean spindleSpeedMatch;

	/** @return Set to true if the expanded volume group will have uniform spindle speed across its drives. */
	public boolean isSpindleSpeedMatch() {
		return this.spindleSpeedMatch;
	}
	/** @param x Set to true if the expanded volume group will have uniform spindle speed across its drives. */
	public void setSpindleSpeedMatch(boolean x) {
		this.spindleSpeedMatch = x;
	}

	/** Set to true if the expanded volume group will have drawer loss protection. */
	@io.swagger.annotations.ApiModelProperty(value ="Set to true if the expanded volume group will have drawer loss protection." , required = true)
	@XmlElement(required = true)
	private boolean drawerLossProtection;

	/** @return Set to true if the expanded volume group will have drawer loss protection. */
	public boolean isDrawerLossProtection() {
		return this.drawerLossProtection;
	}
	/** @param x Set to true if the expanded volume group will have drawer loss protection. */
	public void setDrawerLossProtection(boolean x) {
		this.drawerLossProtection = x;
	}

	/** The total usable capacity of the expansion candidate in bytes. */
	@io.swagger.annotations.ApiModelProperty(value ="The total usable capacity of the expansion candidate in bytes." , required = true)
	@XmlElement(required = true)
	private long usableCapacity;

	/** @return The total usable capacity of the expansion candidate in bytes. */
	public long getUsableCapacity() {
		return this.usableCapacity;
	}
	/** @param x The total usable capacity of the expansion candidate in bytes. */
	public void setUsableCapacity(long x) {
		this.usableCapacity = x;
	}

	/** Identifies the drive block format of the volume candidate. */
	@io.swagger.annotations.ApiModelProperty(value ="Identifies the drive block format of the volume candidate." , required = true)
	@XmlElement(required = true)
	private DriveBlockFormat driveBlockFormat = DriveBlockFormat.__UNDEFINED;

	/** @return Identifies the drive block format of the volume candidate. */
	public DriveBlockFormat getDriveBlockFormat() {
		return this.driveBlockFormat;
	}
	/** @param x Identifies the drive block format of the volume candidate. */
	public void setDriveBlockFormat(DriveBlockFormat x) {
		this.driveBlockFormat = x;
	}
}
