package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** This structure is used as an argument when performing a volume group expansion operation. */
@SuppressWarnings("serial")
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(893)
public class VolumeGroupExpansionDescriptor implements Serializable {
	public VolumeGroupExpansionDescriptor() {
	}

	/** The reference value that identifies the volume group being expanded. */
	@io.swagger.annotations.ApiModelProperty(value ="The reference value that identifies the volume group being expanded." , required = true)
	@XmlElement(required = true)
	private String volumeGroupRef;

	/** @return The reference value that identifies the volume group being expanded. */
	public String getVolumeGroupRef() {
		return this.volumeGroupRef;
	}
	/** @param x The reference value that identifies the volume group being expanded. */
	public void setVolumeGroupRef(String x) {
		this.volumeGroupRef = x;
	}

	/** A variable-length array of drive references that identifies the drives to be added to the volume group to expand its capacity. */
	@io.swagger.annotations.ApiModelProperty(value ="A variable-length array of drive references that identifies the drives to be added to the volume group to expand its capacity." , required = true)
	@XmlElement(required = true)
	private String[] driveRef;

	/** @return A variable-length array of drive references that identifies the drives to be added to the volume group to expand its capacity. */
	public String[] getDriveRef() {
		return this.driveRef;
	}
	/** @param x A variable-length array of drive references that identifies the drives to be added to the volume group to expand its capacity. */
	public void setDriveRef(String[] x) {
		this.driveRef = x;
	}
}
