package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** This structure contains a list of responses from a procedure that is acting on multiple volumes. */
@SuppressWarnings("serial")
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(1106)
public class VolumeListReturned implements Serializable {
	public VolumeListReturned() {
	}

	/** The return code from the procedure. */
	@io.swagger.annotations.ApiModelProperty(value ="The return code from the procedure." , required = true)
	@XmlElement(required = true)
	private ReturnCode retCode = ReturnCode.__UNDEFINED;

	/** @return The return code from the procedure. */
	public ReturnCode getRetCode() {
		return this.retCode;
	}
	/** @param x The return code from the procedure. */
	public void setRetCode(ReturnCode x) {
		this.retCode = x;
	}

	/** The list of responses. */
	@io.swagger.annotations.ApiModelProperty(value ="The list of responses." , required = true)
	@XmlElement(required = true)
	private VolumeResponse[] volumeListResponse;

	/** @return The list of responses. */
	public VolumeResponse[] getVolumeListResponse() {
		return this.volumeListResponse;
	}
	/** @param x The list of responses. */
	public void setVolumeListResponse(VolumeResponse[] x) {
		this.volumeListResponse = x;
	}
}
