package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** This structure is used to convey information about a volume's configuration settings with regard to the controller's background media scan operation. */
@SuppressWarnings("serial")
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(483)
public class VolumeMediaScanParams implements Serializable {
	public VolumeMediaScanParams() {
	}

	/** A true value means that the controller should perform a media scan for this volume as part of its background processing. A false value means that the volume should not participate in media scans. */
	@io.swagger.annotations.ApiModelProperty(value ="A true value means that the controller should perform a media scan for this volume as part of its background processing. A false value means that the volume should not participate in media scans." , required = true)
	@XmlElement(required = true)
	private boolean enable;

	/** @return A true value means that the controller should perform a media scan for this volume as part of its background processing. A false value means that the volume should not participate in media scans. */
	public boolean isEnable() {
		return this.enable;
	}
	/** @param x A true value means that the controller should perform a media scan for this volume as part of its background processing. A false value means that the volume should not participate in media scans. */
	public void setEnable(boolean x) {
		this.enable = x;
	}

	/** A true value means that, in addition to ensuring that the volume's media blocks are fully accessible, the controller should also compute and validate all parity blocks for the volume during the media scan. A false value means that parity validation should not occur in conjunction with media checking. Note that this field has no significance unless the enable field is set to true. */
	@io.swagger.annotations.ApiModelProperty(value ="A true value means that, in addition to ensuring that the volume's media blocks are fully accessible, the controller should also compute and validate all parity blocks for the volume during the media scan. A false value means that parity validation should not occur in conjunction with media checking. Note that this field has no significance unless the enable field is set to true." , required = true)
	@XmlElement(required = true)
	private boolean parityValidationEnable;

	/** @return A true value means that, in addition to ensuring that the volume's media blocks are fully accessible, the controller should also compute and validate all parity blocks for the volume during the media scan. A false value means that parity validation should not occur in conjunction with media checking. Note that this field has no significance unless the enable field is set to true. */
	public boolean isParityValidationEnable() {
		return this.parityValidationEnable;
	}
	/** @param x A true value means that, in addition to ensuring that the volume's media blocks are fully accessible, the controller should also compute and validate all parity blocks for the volume during the media scan. A false value means that parity validation should not occur in conjunction with media checking. Note that this field has no significance unless the enable field is set to true. */
	public void setParityValidationEnable(boolean x) {
		this.parityValidationEnable = x;
	}
}
