package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** This structure is used to return current volume performance information to the caller as the result of the getVolumePerformance procedure. */
@SuppressWarnings("serial")
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(725)
public class VolumePerformance implements Serializable {
	public VolumePerformance() {
	}

	/** Timestamp returned by controller with performance metrics. */
	@io.swagger.annotations.ApiModelProperty(value ="Timestamp returned by controller with performance metrics." , required = true)
	@XmlElement(required = true)
	private long time;

	/** @return Timestamp returned by controller with performance metrics. */
	public long getTime() {
		return this.time;
	}
	/** @param x Timestamp returned by controller with performance metrics. */
	public void setTime(long x) {
		this.time = x;
	}

	/** Total number of requests. */
	@io.swagger.annotations.ApiModelProperty(value ="Total number of requests." , required = true)
	@XmlElement(required = true)
	private int totalRequestsServiced;

	/** @return Total number of requests. */
	public int getTotalRequestsServiced() {
		return this.totalRequestsServiced;
	}
	/** @param x Total number of requests. */
	public void setTotalRequestsServiced(int x) {
		this.totalRequestsServiced = x;
	}

	/** Total number of blocks requested. */
	@io.swagger.annotations.ApiModelProperty(value ="Total number of blocks requested." , required = true)
	@XmlElement(required = true)
	private int totalBlocksRequested;

	/** @return Total number of blocks requested. */
	public int getTotalBlocksRequested() {
		return this.totalBlocksRequested;
	}
	/** @param x Total number of blocks requested. */
	public void setTotalBlocksRequested(int x) {
		this.totalBlocksRequested = x;
	}

	/** Total number of read requests. */
	@io.swagger.annotations.ApiModelProperty(value ="Total number of read requests." , required = true)
	@XmlElement(required = true)
	private int totalReadRequests;

	/** @return Total number of read requests. */
	public int getTotalReadRequests() {
		return this.totalReadRequests;
	}
	/** @param x Total number of read requests. */
	public void setTotalReadRequests(int x) {
		this.totalReadRequests = x;
	}

	/** Total number of read blocks requested. */
	@io.swagger.annotations.ApiModelProperty(value ="Total number of read blocks requested." , required = true)
	@XmlElement(required = true)
	private int totalReadBlocksRequested;

	/** @return Total number of read blocks requested. */
	public int getTotalReadBlocksRequested() {
		return this.totalReadBlocksRequested;
	}
	/** @param x Total number of read blocks requested. */
	public void setTotalReadBlocksRequested(int x) {
		this.totalReadBlocksRequested = x;
	}

	/** Total number of write requests. */
	@io.swagger.annotations.ApiModelProperty(value ="Total number of write requests." , required = true)
	@XmlElement(required = true)
	private int totalWriteRequests;

	/** @return Total number of write requests. */
	public int getTotalWriteRequests() {
		return this.totalWriteRequests;
	}
	/** @param x Total number of write requests. */
	public void setTotalWriteRequests(int x) {
		this.totalWriteRequests = x;
	}

	/** Total number of write blocks requested. */
	@io.swagger.annotations.ApiModelProperty(value ="Total number of write blocks requested." , required = true)
	@XmlElement(required = true)
	private int totalWriteBlocksRequested;

	/** @return Total number of write blocks requested. */
	public int getTotalWriteBlocksRequested() {
		return this.totalWriteBlocksRequested;
	}
	/** @param x Total number of write blocks requested. */
	public void setTotalWriteBlocksRequested(int x) {
		this.totalWriteBlocksRequested = x;
	}

	/** The percentReadRequests is computed directly as: (totalReadRequests * 100) / totalRequests. */
	@io.swagger.annotations.ApiModelProperty(value ="The percentReadRequests is computed directly as: (totalReadRequests * 100) / totalRequests." , required = true)
	@XmlElement(required = true)
	private int percentReadRequests;

	/** @return The percentReadRequests is computed directly as: (totalReadRequests * 100) / totalRequests. */
	public int getPercentReadRequests() {
		return this.percentReadRequests;
	}
	/** @param x The percentReadRequests is computed directly as: (totalReadRequests * 100) / totalRequests. */
	public void setPercentReadRequests(int x) {
		this.percentReadRequests = x;
	}

	/** Average number of blocks requested. */
	@io.swagger.annotations.ApiModelProperty(value ="Average number of blocks requested." , required = true)
	@XmlElement(required = true)
	private int averageBlocksRequested;

	/** @return Average number of blocks requested. */
	public int getAverageBlocksRequested() {
		return this.averageBlocksRequested;
	}
	/** @param x Average number of blocks requested. */
	public void setAverageBlocksRequested(int x) {
		this.averageBlocksRequested = x;
	}

	/** Total number of reads considered large. */
	@io.swagger.annotations.ApiModelProperty(value ="Total number of reads considered large." , required = true)
	@XmlElement(required = true)
	private int totalLargeReads;

	/** @return Total number of reads considered large. */
	public int getTotalLargeReads() {
		return this.totalLargeReads;
	}
	/** @param x Total number of reads considered large. */
	public void setTotalLargeReads(int x) {
		this.totalLargeReads = x;
	}

	/** Total requested blocks for large reads. */
	@io.swagger.annotations.ApiModelProperty(value ="Total requested blocks for large reads." , required = true)
	@XmlElement(required = true)
	private int totalLargeReadBlocksRequested;

	/** @return Total requested blocks for large reads. */
	public int getTotalLargeReadBlocksRequested() {
		return this.totalLargeReadBlocksRequested;
	}
	/** @param x Total requested blocks for large reads. */
	public void setTotalLargeReadBlocksRequested(int x) {
		this.totalLargeReadBlocksRequested = x;
	}

	/** Total number of writes considered large. */
	@io.swagger.annotations.ApiModelProperty(value ="Total number of writes considered large." , required = true)
	@XmlElement(required = true)
	private int totalLargeWrites;

	/** @return Total number of writes considered large. */
	public int getTotalLargeWrites() {
		return this.totalLargeWrites;
	}
	/** @param x Total number of writes considered large. */
	public void setTotalLargeWrites(int x) {
		this.totalLargeWrites = x;
	}

	/** Total requested blocks for large writes. */
	@io.swagger.annotations.ApiModelProperty(value ="Total requested blocks for large writes." , required = true)
	@XmlElement(required = true)
	private int totalLargeWriteBlocksRequested;

	/** @return Total requested blocks for large writes. */
	public int getTotalLargeWriteBlocksRequested() {
		return this.totalLargeWriteBlocksRequested;
	}
	/** @param x Total requested blocks for large writes. */
	public void setTotalLargeWriteBlocksRequested(int x) {
		this.totalLargeWriteBlocksRequested = x;
	}

	/** This field tracks the number of calls to the cache manager to check if a host-initiated read request can be fully satisfied out of cache. */
	@io.swagger.annotations.ApiModelProperty(value ="This field tracks the number of calls to the cache manager to check if a host-initiated read request can be fully satisfied out of cache." , required = true)
	@XmlElement(required = true)
	private int totalCacheReadChecks;

	/** @return This field tracks the number of calls to the cache manager to check if a host-initiated read request can be fully satisfied out of cache. */
	public int getTotalCacheReadChecks() {
		return this.totalCacheReadChecks;
	}
	/** @param x This field tracks the number of calls to the cache manager to check if a host-initiated read request can be fully satisfied out of cache. */
	public void setTotalCacheReadChecks(int x) {
		this.totalCacheReadChecks = x;
	}

	/** Number of cache read check hits. */
	@io.swagger.annotations.ApiModelProperty(value ="Number of cache read check hits." , required = true)
	@XmlElement(required = true)
	private int totalCacheReadCheckHits;

	/** @return Number of cache read check hits. */
	public int getTotalCacheReadCheckHits() {
		return this.totalCacheReadCheckHits;
	}
	/** @param x Number of cache read check hits. */
	public void setTotalCacheReadCheckHits(int x) {
		this.totalCacheReadCheckHits = x;
	}

	/** Number of cache write requests. (This field is always set to zero by firmware releases prior to 7.10.) */
	@io.swagger.annotations.ApiModelProperty(value ="Number of cache write requests. (This field is always set to zero by firmware releases prior to 7.10.)" , required = true)
	@XmlElement(required = true)
	private int totalCacheWriteRequests;

	/** @return Number of cache write requests. (This field is always set to zero by firmware releases prior to 7.10.) */
	public int getTotalCacheWriteRequests() {
		return this.totalCacheWriteRequests;
	}
	/** @param x Number of cache write requests. (This field is always set to zero by firmware releases prior to 7.10.) */
	public void setTotalCacheWriteRequests(int x) {
		this.totalCacheWriteRequests = x;
	}

	/** The volume for which this information applies. */
	@io.swagger.annotations.ApiModelProperty(value ="The volume for which this information applies." , required = true)
	@XmlElement(required = true)
	private String volumeRef;

	/** @return The volume for which this information applies. */
	public String getVolumeRef() {
		return this.volumeRef;
	}
	/** @param x The volume for which this information applies. */
	public void setVolumeRef(String x) {
		this.volumeRef = x;
	}

	/** The number of flash cache write hits. */
	@io.swagger.annotations.ApiModelProperty(value ="The number of flash cache write hits." , required = true)
	@XmlElement(required = true)
	private int totalCacheWriteHits;

	/** @return The number of flash cache write hits. */
	public int getTotalCacheWriteHits() {
		return this.totalCacheWriteHits;
	}
	/** @param x The number of flash cache write hits. */
	public void setTotalCacheWriteHits(int x) {
		this.totalCacheWriteHits = x;
	}

	/** The total number of flash cache read hits. */
	@io.swagger.annotations.ApiModelProperty(value ="The total number of flash cache read hits." , required = true)
	@XmlElement(required = true)
	private int totalFlashCacheReadHits;

	/** @return The total number of flash cache read hits. */
	public int getTotalFlashCacheReadHits() {
		return this.totalFlashCacheReadHits;
	}
	/** @param x The total number of flash cache read hits. */
	public void setTotalFlashCacheReadHits(int x) {
		this.totalFlashCacheReadHits = x;
	}
}
