package devmgr.api.symbol;

import devmgr.api.runtime.*;
import java.io.Serializable;
import javax.xml.bind.annotation.*;

/** This structure is passed as the argument to the scanVolume procedure. It specifies the volume to scan, the starting and ending LBAs and any repair actions to be taken. */
@SuppressWarnings("serial")
@XmlRootElement
@io.swagger.annotations.ApiModel()
@TypeTableIndex(812)
public class VolumeScanDescriptor implements Serializable {
	public VolumeScanDescriptor() {
	}

	/** The reference value that identifies the volume to be scanned/repaired. */
	@io.swagger.annotations.ApiModelProperty(value ="The reference value that identifies the volume to be scanned/repaired." , required = true)
	@XmlElement(required = true)
	private String volumeRef;

	/** @return The reference value that identifies the volume to be scanned/repaired. */
	public String getVolumeRef() {
		return this.volumeRef;
	}
	/** @param x The reference value that identifies the volume to be scanned/repaired. */
	public void setVolumeRef(String x) {
		this.volumeRef = x;
	}

	/** The starting LBA of the scan/repair. */
	@io.swagger.annotations.ApiModelProperty(value ="The starting LBA of the scan/repair." , required = true)
	@XmlElement(required = true)
	private long startingLBA;

	/** @return The starting LBA of the scan/repair. */
	public long getStartingLBA() {
		return this.startingLBA;
	}
	/** @param x The starting LBA of the scan/repair. */
	public void setStartingLBA(long x) {
		this.startingLBA = x;
	}

	/** The ending LBA of the scan/repair. */
	@io.swagger.annotations.ApiModelProperty(value ="The ending LBA of the scan/repair." , required = true)
	@XmlElement(required = true)
	private long endingLBA;

	/** @return The ending LBA of the scan/repair. */
	public long getEndingLBA() {
		return this.endingLBA;
	}
	/** @param x The ending LBA of the scan/repair. */
	public void setEndingLBA(long x) {
		this.endingLBA = x;
	}

	/** When this parameter is set to true(1) the controller will automatically repair any media errors detected during the scan. When it is set to false(0) the scan will stop on any media error detected and report the error in the ParityScanResponse. */
	@io.swagger.annotations.ApiModelProperty(value ="When this parameter is set to true(1) the controller will automatically repair any media errors detected during the scan. When it is set to false(0) the scan will stop on any media error detected and report the error in the ParityScanResponse." , required = true)
	@XmlElement(required = true)
	private boolean repairMedia;

	/** @return When this parameter is set to true(1) the controller will automatically repair any media errors detected during the scan. When it is set to false(0) the scan will stop on any media error detected and report the error in the ParityScanResponse. */
	public boolean isRepairMedia() {
		return this.repairMedia;
	}
	/** @param x When this parameter is set to true(1) the controller will automatically repair any media errors detected during the scan. When it is set to false(0) the scan will stop on any media error detected and report the error in the ParityScanResponse. */
	public void setRepairMedia(boolean x) {
		this.repairMedia = x;
	}

	/** When this parameter is set to true(1) the parity for the data stripe containing startingLBA will be repaired. When this parameter is set to false(0) the controller performs a volume parity scan on the data from startingLBA to endingLBA. */
	@io.swagger.annotations.ApiModelProperty(value ="When this parameter is set to true(1) the parity for the data stripe containing startingLBA will be repaired. When this parameter is set to false(0) the controller performs a volume parity scan on the data from startingLBA to endingLBA." , required = true)
	@XmlElement(required = true)
	private boolean repairParity;

	/** @return When this parameter is set to true(1) the parity for the data stripe containing startingLBA will be repaired. When this parameter is set to false(0) the controller performs a volume parity scan on the data from startingLBA to endingLBA. */
	public boolean isRepairParity() {
		return this.repairParity;
	}
	/** @param x When this parameter is set to true(1) the parity for the data stripe containing startingLBA will be repaired. When this parameter is set to false(0) the controller performs a volume parity scan on the data from startingLBA to endingLBA. */
	public void setRepairParity(boolean x) {
		this.repairParity = x;
	}

	/** Scan priority */
	@io.swagger.annotations.ApiModelProperty(value ="Scan priority" , required = true)
	@XmlElement(required = true)
	private VolumeScanPriority priority = VolumeScanPriority.__UNDEFINED;

	/** @return Scan priority */
	public VolumeScanPriority getPriority() {
		return this.priority;
	}
	/** @param x Scan priority */
	public void setPriority(VolumeScanPriority x) {
		this.priority = x;
	}

	/** Volume scan timeout, in seconds. */
	@io.swagger.annotations.ApiModelProperty(value ="Volume scan timeout, in seconds." , required = true)
	@XmlElement(required = true)
	private int timeout;

	/** @return Volume scan timeout, in seconds. */
	public int getTimeout() {
		return this.timeout;
	}
	/** @param x Volume scan timeout, in seconds. */
	public void setTimeout(int x) {
		this.timeout = x;
	}
}
